/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "parser.ypp"
 /* -*- mode: c++; indent-tabs-mode: nil -*-

   parser.ypp

   Qore Programming Language

   Copyright 2003 - 2013 David Nichols

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
#include <qore/intern/BreakStatement.h>
#include <qore/intern/ContinueStatement.h>
#include <qore/intern/ReturnStatement.h>
#include <qore/intern/RethrowStatement.h>
#include <qore/intern/ThreadExitStatement.h>
#include <qore/intern/ExpressionStatement.h>
#include <qore/intern/DoWhileStatement.h>
#include <qore/intern/SummarizeStatement.h>
#include <qore/intern/ContextStatement.h>
#include <qore/intern/IfStatement.h>
#include <qore/intern/WhileStatement.h>
#include <qore/intern/ForStatement.h>
#include <qore/intern/ForEachStatement.h>
#include <qore/intern/TryStatement.h>
#include <qore/intern/ThrowStatement.h>
#include <qore/intern/StatementBlock.h>
#include <qore/intern/ParserSupport.h>
#include <qore/intern/SwitchStatement.h>
#include <qore/intern/CaseNodeWithOperator.h>
#include <qore/intern/CaseNodeRegex.h>
#include <qore/intern/OnBlockExitStatement.h>
#include <qore/intern/ConstantList.h>
#include <qore/intern/GlobalVariableList.h>
#include <qore/intern/QoreNamespaceIntern.h>

#include "parser.hpp"

#include <qore/intern/QoreClassIntern.h>
#include <qore/intern/qore_program_private.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <memory>
#include <utility>
#include <vector>

#define YYINITDEPTH 300
//#define YYDEBUG 1

#define YYLLOC_DEFAULT(Current, Rhs, N)                                \
          do                                                           \
            if (N) {                                                   \
                (Current).first_line   = YYRHSLOC(Rhs, 1).first_line;  \
                (Current).last_line    = YYRHSLOC(Rhs, N).last_line;   \
            }                                                          \
            else {                                                     \
                (Current).first_line   = (Current).last_line   =       \
                  YYRHSLOC(Rhs, 0).last_line;                          \
            }                                                          \
          while (0)

class HashElement {
public:
   char* key;
   AbstractQoreNode* value;
 
   DLLLOCAL HashElement(AbstractQoreNode* k, AbstractQoreNode* v) {
      //tracein("HashElement::HashElement()");
      if (!k || k->getType() != NT_STRING) {
	 parse_error("hash member name must be a string value!");
	 key = strdup("");
      }
      else
	 key = strdup(reinterpret_cast<QoreStringNode*>(k)->getBuffer());
      k->deref(0);
      value = v;
      //traceout("HashElement::HashElement()");
   }

   DLLLOCAL HashElement(int tag, char* constant, AbstractQoreNode* v) {
      //tracein("HashElement::HashElement()");
      key = (char* )malloc(sizeof(char) * strlen(constant) + 2);
      key[0] = tag; // mark as constant
      strcpy(key + 1, constant);
      value = v;
      free(constant);
      //traceout("HashElement::HashElement()");
   }

   DLLLOCAL ~HashElement() {
      free(key);
   }
};

static AbstractQoreNode* makeErrorTree(AbstractQoreNode* left, AbstractQoreNode* right) {
   discard(left, 0);
   discard(right, 0);
   return &False;
}

// for constant definitions
class ConstNode {
public:
   NamedScope name;
   AbstractQoreNode* value;
   bool pub;

   DLLLOCAL ConstNode(char* n, AbstractQoreNode* v, bool p = false) : name(n), value(v), pub(p) {
      // see if constant definitions are allowed
      if (checkParseOption(PO_NO_CONSTANT_DEFS))
         parse_error("illegal constant definition \"%s\" (conflicts with parse option NO_CONSTANT_DEFS)", n);
   }
   DLLLOCAL AbstractQoreNode* takeValue() {
      AbstractQoreNode* rv = value;
      value = 0;
      return rv;
   }
   DLLLOCAL const std::string &getName() const {
      return name.getIdentifierStr();
   }
   DLLLOCAL bool isPublic() const {
      return pub;
   }
};

class ObjClassDef {
public:
   NamedScope *name;
   QoreClass *oc;

   DLLLOCAL inline ObjClassDef(NamedScope *n, QoreClass *o) : name(n), oc(o) {}
   DLLLOCAL inline ObjClassDef(char* n, QoreClass *o) : name(new NamedScope(n)), oc(o) {}
   DLLLOCAL inline ~ObjClassDef() { delete name; }
};

class ParseUserFunctionBase {
public:
   UserFunctionVariant* variant;

   DLLLOCAL ParseUserFunctionBase(UserFunctionVariant* v) : variant(v) {
   }

   DLLLOCAL ~ParseUserFunctionBase() {
      if (variant)
         variant->deref();
   }

   DLLLOCAL void setPublic() {
      variant->setModulePublic();
   }
};

class ParseUserFunction : public ParseUserFunctionBase {
public:
   char* name;

   DLLLOCAL ParseUserFunction(char* n_name, UserFunctionVariant* n_variant) : ParseUserFunctionBase(n_variant), name(n_name) {
   }

   DLLLOCAL ~ParseUserFunction() {
      if (name)
         free(name);
   }

   DLLLOCAL void add(qore_ns_private& ns) {
      qore_root_ns_private::addPendingVariant(ns, name, variant);
      variant = 0;
      // make sure definition was legal
      if (checkParseOption(PO_NO_SUBROUTINE_DEFS)) {
         const char* nsn = ns.name.c_str();
         parse_error("function '%s%s%s()' cannot be defined (conflicts with parse option NO_SUBROUTINE_DEFS)", nsn[0] ? nsn : "", nsn[0] ? "::" : "", name);
      }

      delete this;
   }
};

class ParseScopedUserFunction : public ParseUserFunctionBase {
public:
   NamedScope name;

   DLLLOCAL ParseScopedUserFunction(char* n_name, UserFunctionVariant* n_variant) : ParseUserFunctionBase(n_variant), name(n_name) {
   }

   DLLLOCAL void add(qore_ns_private& ns) {
      qore_root_ns_private::addPendingVariant(ns, name, variant);
      variant = 0;
      // make sure definition was legal
      if (checkParseOption(PO_NO_SUBROUTINE_DEFS))
         parse_error("function '%s()' cannot be defined (conflicts with parse option NO_SUBROUTINE_DEFS)", name.ostr);

      delete this;
   }
};

struct GVarDecl {
   bool pub;

   DLLLOCAL GVarDecl(bool p) : pub(p) {
   }

   DLLLOCAL virtual ~GVarDecl() {
   }

   DLLLOCAL virtual void add(qore_ns_private& ns) = 0;

   DLLLOCAL virtual AbstractQoreNode* makeVar() = 0;
};

struct GVarSingleDecl : public GVarDecl {
   char* name;
   const QoreTypeInfo* typeInfo;
   QoreParseTypeInfo* parseTypeInfo;

   DLLLOCAL GVarSingleDecl(char* n, const QoreTypeInfo* ti, QoreParseTypeInfo* pti, bool p, bool bare) : GVarDecl(p), name(n), typeInfo(ti), parseTypeInfo(pti) {
      if (bare) {
         if (!checkParseOption(PO_ALLOW_BARE_REFS))
            parse_error("global variable '%s' declared without '$' prefix, but parse option 'allow-bare-refs' is not set", n);
      }
      else {
         if (checkParseOption(PO_ALLOW_BARE_REFS))
            parse_error("reference to variable '$%s' with the '$' sign is not allowed when parse option 'allow-bare-refs' is set", n);
      }
   }

   DLLLOCAL virtual ~GVarSingleDecl() {
      if (name)
         free(name);

      delete parseTypeInfo;
   }

   DLLLOCAL char* takeName() {
      char* rv = name;
      name = 0;
      return rv;
   }

   DLLLOCAL QoreParseTypeInfo* takeParseTypeInfo() {
      QoreParseTypeInfo* rv = parseTypeInfo;
      parseTypeInfo = 0;
      return rv;
   }

   DLLLOCAL virtual void add(qore_ns_private& ns) {
      ns.parseAddGlobalVarDecl(takeName(), typeInfo, takeParseTypeInfo(), pub);
      delete this;
   }

   DLLLOCAL virtual AbstractQoreNode* makeVar() {
      GlobalVarRefNode* gv = typeInfo
         ? new GlobalVarRefNode(takeName(), typeInfo)
         : new GlobalVarRefNode(takeName(), takeParseTypeInfo());
      if (pub)
         gv->setPublic();

      delete this;
      return gv;
   }   
};

struct GVarListDecl : public GVarDecl {
   QoreListNode* l;

   DLLLOCAL GVarListDecl(QoreListNode* list, bool p) : GVarDecl(p), l(list) {
      bool bareok = checkParseOption(PO_ALLOW_BARE_REFS);

      ListIterator li(l);
      while (li.next()) {
         AbstractQoreNode* n = li.getValue();
         qore_type_t t = get_node_type(n);
         if (t == NT_BAREWORD) {
            BarewordNode* b = reinterpret_cast<BarewordNode*>(n);
            if (!bareok)
               parse_error("global variable '%s' in global variable declaration list declared without '$' prefix, but parse option 'allow-bare-refs' is not set", b->str);
         }
         else if (t == NT_VARREF) {
            VarRefNode* vrn = reinterpret_cast<VarRefNode*>(n);
            if (vrn->explicitScope()) {
               if (vrn->getType() == VT_LOCAL)
                  parse_error("illegal use of 'my %s' in global variable declaration list", vrn->getName());
               else if (vrn->getType() == VT_GLOBAL)
                  parse_error("illegal use of 'our %s' in global variable declaration list", vrn->getName());
            }
         }
         else
            parse_error("element %d in list following 'our' is not a variable reference (%s)", li.index(), get_node_type(n));
      }
   }

   DLLLOCAL virtual ~GVarListDecl() {
      if (l)
         l->deref(0);
   }

   DLLLOCAL QoreListNode* takeList() {
      QoreListNode* rv = l;
      l = 0;
      return rv;
   }

   DLLLOCAL virtual void add(qore_ns_private& ns) {
      ListIterator li(l);
      while (li.next()) {
         AbstractQoreNode* n = li.getValue();
         qore_type_t t = get_node_type(n);
         if (t == NT_BAREWORD) {
            BarewordNode* b = reinterpret_cast<BarewordNode*>(n);
            ns.parseAddGlobalVarDecl(b->takeString(), 0, 0, pub);
         }
         else if (t == NT_VARREF) {
            VarRefNode* vrn = reinterpret_cast<VarRefNode*>(n);
            if (!vrn->explicitScope()) {
               VarRefDeclNode* vrdn = dynamic_cast<VarRefDeclNode*>(vrn);
               if (vrdn)
                  ns.parseAddGlobalVarDecl(vrn->takeName(), vrdn->getTypeInfo(), vrdn->takeParseTypeInfo(), pub);
               else
                  ns.parseAddGlobalVarDecl(vrn->takeName(), 0, 0, pub);
            }
         }
      }

      delete this;
   }

   DLLLOCAL virtual AbstractQoreNode* makeVar() {
      l->setVariableList();
      ListIterator li(l);
      while (li.next()) {
         AbstractQoreNode* n = li.getValue();
         qore_type_t t = get_node_type(n);
         VarRefNode* vrn = 0;
         if (t == NT_BAREWORD) {
            BarewordNode* b = reinterpret_cast<BarewordNode*>(n);
            GlobalVarRefNode* v = new GlobalVarRefNode(b->takeString());
            b->deref();
            AbstractQoreNode** p = li.getValuePtr();
            *p = vrn = v;
         }
         else if (t == NT_VARREF) {
            vrn = reinterpret_cast<VarRefNode*>(n);
            if (!vrn->explicitScope()) {
               vrn->makeGlobal();
               vrn->setExplicitScope();
            }
         }

         if (vrn && pub)
            vrn->setPublic();
      }

      QoreListNode* rv = takeList();
      delete this;
      return rv;
   }
};

#define NSN_NONE  0
#define NSN_OCD   1
#define NSN_CONST 2
#define NSN_NS    3
#define NSN_FUNC  4
#define NSN_SFUNC 5
#define NSN_VAR   6

struct NSNode {
   int type;
   union {
      ObjClassDef *ocd;
      ConstNode* cn;
      QoreNamespace *ns;
      ParseUserFunction* func;
      ParseScopedUserFunction* sfunc;
      GVarDecl *gv;
   } n;

   DLLLOCAL NSNode(ObjClassDef *o) { type = NSN_OCD; n.ocd = o; }
   DLLLOCAL NSNode(ConstNode  *c) { type = NSN_CONST; n.cn = c; }
   DLLLOCAL NSNode(QoreNamespace  *s) { type = NSN_NS; n.ns = s; }
   DLLLOCAL NSNode(ParseUserFunction* f) : type(NSN_FUNC) {
      n.func = f;
   }
   DLLLOCAL NSNode(ParseScopedUserFunction* f) : type(NSN_SFUNC) {
      n.sfunc = f;
   }

   DLLLOCAL NSNode(GVarDecl* gv) : type(NSN_VAR) {
      n.gv = gv;
   }

   DLLLOCAL void deref() {
      switch (type) {
         case NSN_OCD:
            delete n.ocd;
            break;
         case NSN_CONST:
            delete n.cn;
            break;
         case NSN_NS:
            delete n.ns;
            break;
         case NSN_FUNC:
            delete n.func;
            break;
         case NSN_SFUNC:
            delete n.sfunc;
            break;
         case NSN_VAR:
            delete n.gv;
            break;
         default:
            assert(false);
            // no break
      }
      delete this;
   }

   DLLLOCAL void add(qore_ns_private& ns) {
      switch (type) {
         case NSN_OCD:
            ns.parseAddPendingClass(*(n.ocd->name), n.ocd->oc);
            delete n.ocd;
            break;
         case NSN_CONST:
            ns.parseAddConstant(n.cn->name, n.cn->value, n.cn->pub);
            delete n.cn;
            break;
         case NSN_NS:
            ns.parseAddNamespace(n.ns);
            break;
         case NSN_FUNC:
            n.func->add(ns);
            break;
         case NSN_SFUNC:
            n.sfunc->add(ns);
            break;
         case NSN_VAR:
            n.gv->add(ns);
            break;
         default:
            assert(false);
            // no break
      }
      delete this;
   }
};

typedef std::vector<NSNode*>nsnode_list_t;

struct NSNodeList : public nsnode_list_t {
   DLLLOCAL void deref() {
      for (nsnode_list_t::iterator i = begin(), e = end(); i != e; ++i)
         (*i)->deref();

      delete this;
   }

   DLLLOCAL void add(qore_ns_private& ns) {
      for (nsnode_list_t::iterator i = begin(), e = end(); i != e; ++i)
         (*i)->add(ns);
   }
};

static QoreListNode* make_list(AbstractQoreNode* a1, AbstractQoreNode* a2) {
   QoreListNode* l = new QoreListNode;
   l->push(a1);
   l->push(a2);
   return l;
}

static QoreListNode* splice_expressions(AbstractQoreNode* a1, AbstractQoreNode* a2) {
   //tracein("splice_expressions()");
   if (a1 && a1->getType() == NT_LIST) {
      QoreListNode* l = reinterpret_cast<QoreListNode*>(a1);
      if (!l->isFinalized()) {
	 //printd(5, "LIST x\n");
	 l->push(a2);
	 return l;
      }
   }
   return make_list(a1, a2);
}

typedef std::pair<char*, QoreMemberInfo*> member_pair_t;
typedef std::pair<char*, QoreVarInfo*> var_pair_t;

struct MemberInfo {
protected:
   DLLLOCAL MemberInfo() {
   }

public:
   enum mi_e { Member, Constant, Var };

   char* name;
   mi_e type;
   union {
      QoreMemberInfo* memberInfo;
      QoreVarInfo* varInfo;
      AbstractQoreNode* exp;
   } u;

   DLLLOCAL MemberInfo(char* n, QoreMemberInfo* mi) : name(n), type(Member)  {
      u.memberInfo = mi; 
      if (!mi->parseHasTypeInfo() && getProgram()->getParseOptions64() & PO_REQUIRE_TYPES)
	 parse_error("member '%s' declared without type information, but parse options require type information for all declarations", name);
   }
   DLLLOCAL MemberInfo(char* n) : name(n), type(Member)  {
      u.memberInfo = 0; 
      if (getProgram()->getParseOptions64() & PO_REQUIRE_TYPES)
	 parse_error("member '%s' declared without type information, but parse options require type information for all declarations", name);
   }
   DLLLOCAL MemberInfo(char* n, AbstractQoreNode* exp) : name(n), type(Constant) {
      u.exp = exp;
   }
   DLLLOCAL ~MemberInfo() {
      if (name)
	 free(name);
      switch (type) {
	 case Member:
	    delete u.memberInfo;
	    break;
	 case Var:
	    delete u.varInfo;
	    break;
	 case Constant:
	    if (u.exp)
	       u.exp->deref(0);
	    break;
      }
   }
   DLLLOCAL member_pair_t getPair() {
      assert(type == Member);
      member_pair_t m = std::make_pair(name, u.memberInfo);
      name = 0;
      u.memberInfo = 0;
      return m;
   }
   DLLLOCAL var_pair_t getVarPair() {
      assert(type == Var);
      var_pair_t m = std::make_pair(name, u.varInfo);
      name = 0;
      u.varInfo = 0;
      return m;
   }
   DLLLOCAL AbstractQoreNode* takeExp() {
      assert(type == Constant);
      AbstractQoreNode* rv = u.exp;
      u.exp = 0;
      return rv;
   }
};

struct ClassVarInfo : public MemberInfo {
   DLLLOCAL ClassVarInfo(char* n, QoreVarInfo* vi) {
      name = n;
      type = Var;
      u.varInfo = vi; 
      if (!vi->parseHasTypeInfo() && getProgram()->getParseOptions64() & PO_REQUIRE_TYPES)
	 parse_error("class static variable '%s' declared without type information, but parse options require type information for all declarations", name);
   }
/*
   DLLLOCAL ClassVarInfo(char* n) {
      name = n;
      type = Var;
      u.varInfo = 0; 
      if (getProgram()->getParseOptions64() & PO_REQUIRE_TYPES)
	 parse_error("class static variable '%s' declared without type information, but parse options require type information for all declarations", name);
   }
*/
   DLLLOCAL char* takeName() {
      char* n = name;
      name = 0;
      return n;
   }
   DLLLOCAL QoreVarInfo* takeVarInfo() {
      assert(u.varInfo);
      QoreVarInfo* rv = u.varInfo;
      u.varInfo = 0;
      return rv;
   }
};

class MemberList {
protected:
   // for new class members
   QoreMemberMap mmap;
   // for new class constants
   ConstantList cmap;
   // for new class static variables
   QoreVarMap vmap;
   
   DLLLOCAL MemberList() : cmap((qore_class_private*)0) {
   }

public:
   DLLLOCAL MemberList(MemberInfo* member) : cmap((qore_class_private*)0) {
      if (!member)
	 return;

      if (member->type == MemberInfo::Member)
	 mmap.insert(member->getPair());
      else if (member->type == MemberInfo::Constant)
	 cmap.parseAdd(member->name, member->takeExp());
      else
	 vmap.insert(member->getVarPair());

      delete member;
   }

   DLLLOCAL ~MemberList() {
   }

   // takes over ownership of name and typeInfo
   DLLLOCAL int add(MemberInfo* member) {
      if (!member)
	 return -1;

      std::auto_ptr<MemberInfo> mem(member);

      if (member->type == MemberInfo::Member) {
	 if (mmap.find(member->name) != mmap.end()) {
	    parse_error("duplicate member declaration '%s'", member->name);
	    return -1;
	 }

	 // add new member to list
	 mmap.insert(member->getPair());
      }
      else if (member->type == MemberInfo::Constant) {
	 if (cmap.inList(member->name)) {
	    parse_error("duplicate constant declaration '%s'", member->name);
	    return -1;
	 }
	 if (vmap.find(member->name)) {
	    parse_error("constant declaration collides with static class variable declaration '%s'", member->name);
	    return -1;
	 }	 

	 // add new constant to list
	 cmap.parseAdd(member->name, member->takeExp());
      }
      else {
	 assert(member->type == MemberInfo::Var);
	 if (vmap.find(member->name)) {
	    parse_error("duplicate static class variable declaration '%s'", member->name);
	    return -1;
	 }
	 if (cmap.inList(member->name)) {
	    parse_error("static class variable declaration collides with constant declaration '%s'", member->name);
	    return -1;
	 }

	 // add new member to list
	 vmap.insert(member->getVarPair());
      }

      return 0;
   }

   DLLLOCAL void mergePrivate(QoreClass *qc) {
      {
	 member_map_t::iterator i;
	 // merge private members
	 while ((i = mmap.begin()) != mmap.end()) {
	    qore_class_private::parseAddPrivateMember(*qc, i->first, i->second);
	    mmap.erase(i);
	 }
      }

      {
	 var_map_t::iterator i;
	 // merge private static class variables
	 while ((i = vmap.begin()) != vmap.end()) {
	    qore_class_private::parseAddPrivateStaticVar(qc, i->first, i->second);
	    vmap.erase(i);
	 }
      }

      // merge private constants
      qc->parseAssimilatePrivateConstants(cmap);
   }

   DLLLOCAL void mergePublic(QoreClass *qc) {
      // merge public members
      if (mmap.empty())
	 qc->parseSetEmptyPublicMemberDeclaration();
      else {
	 member_map_t::iterator i;

	 while ((i = mmap.begin()) != mmap.end()) {
	    qore_class_private::parseAddPublicMember(*qc, i->first, i->second);
	    mmap.erase(i);
	 }
      }

      {
	 var_map_t::iterator i;
	 // merge public static class variables
	 while ((i = vmap.begin()) != vmap.end()) {
	    qore_class_private::parseAddPublicStaticVar(qc, i->first, i->second);
	    vmap.erase(i);
	 }
      }

      // merge public constants
      qc->parseAssimilatePublicConstants(cmap);
   }
};

class EmptyPublicMemberList : public MemberList {
public:
   DLLLOCAL EmptyPublicMemberList() {
   }
};

struct ParserTypeStruct {
protected:
   DLLLOCAL ParserTypeStruct(QoreParseTypeInfo* n_parseTypeInfo) : typeInfo(0), parseTypeInfo(n_parseTypeInfo) {
   }

   DLLLOCAL ParserTypeStruct() {
   }

public:
   const QoreTypeInfo* typeInfo;
   QoreParseTypeInfo* parseTypeInfo;

   DLLLOCAL ParserTypeStruct(const QoreTypeInfo* n_typeInfo) : typeInfo(n_typeInfo), parseTypeInfo(0) {
   }

   DLLLOCAL ParserTypeStruct(char* id) {
      const QoreTypeInfo* t = getBuiltinUserTypeInfo(id);
      //printd(0, "ParserTypeStruct::ParserTypeStruct('%s') t: %p %s\n", id, t, t->getName());
      if (t) {
	 free(id);
	 typeInfo = t;
	 parseTypeInfo = 0;
	 return;
      }

      typeInfo = 0;
      parseTypeInfo = new QoreParseTypeInfo(id);
   }

   DLLLOCAL ~ParserTypeStruct() {
      delete parseTypeInfo;
   }

   DLLLOCAL const QoreTypeInfo* getTypeInfo() const {
      if (!this)
	 return 0;

      return typeInfo;
   }

   DLLLOCAL QoreParseTypeInfo* getParseTypeInfo() {
      if (!this)
	 return 0;

      QoreParseTypeInfo* rv = parseTypeInfo;
      parseTypeInfo = 0;
      return rv;
   }

   DLLLOCAL const char* getClassName() {
      assert(this);
      assert(parseTypeInfo);
      return parseTypeInfo->cscope->ostr;
   }
};

struct ParserScopedTypeStruct : public ParserTypeStruct {
   DLLLOCAL ParserScopedTypeStruct(char* sr) : ParserTypeStruct(new QoreParseTypeInfo(sr)) {
   }
};

struct ParserOrNothingTypeStruct : public ParserTypeStruct {
   DLLLOCAL ParserOrNothingTypeStruct(char* id) {
      const QoreTypeInfo* t = getBuiltinUserOrNothingTypeInfo(id);
      if (t) {
	 free(id);
	 typeInfo = t;
	 parseTypeInfo = 0;
	 return;
      }

      typeInfo = 0;
      parseTypeInfo = new QoreParseTypeInfo(id, true);
   }
};

struct ParserScopedOrNothingTypeStruct : public ParserTypeStruct {
   DLLLOCAL ParserScopedOrNothingTypeStruct(char* sr) : ParserTypeStruct(new QoreParseTypeInfo(sr, true)) {
   }
};

static AbstractQoreNode* process_dot(AbstractQoreNode* l, AbstractQoreNode* r) {
   qore_type_t rtype = r->getType();
   if (rtype == NT_BAREWORD) {
      BarewordNode* b = reinterpret_cast<BarewordNode*>(r);
      AbstractQoreNode* rv = new QoreTreeNode(l, OP_OBJECT_REF, b->makeQoreStringNode());
      b->deref();
      return rv;
   }

   if (rtype == NT_FUNCTION_CALL) {
      FunctionCallNode* f = reinterpret_cast<FunctionCallNode*>(r);
      assert(!f->getFunction());
      if (!f->isFinalized()) {
         MethodCallNode* m = new MethodCallNode(f->takeName(), f->take_args());
         f->deref();

         return new QoreDotEvalOperatorNode(l, m);
      }
   }

   return new QoreTreeNode(l, OP_OBJECT_REF, r);
}

// returns true if the node needs run-time evaluation, false if not
static bool needsEval(AbstractQoreNode* n) {
   if (!n)
      return false;

   qore_type_t ntype = n->getType();

   // if it's a constant or a function reference
   if (ntype == NT_BAREWORD || ntype == NT_CONSTANT || ntype == NT_FUNCREF)
      return false;

   if (ntype == NT_LIST) {
      QoreListNode* l = reinterpret_cast<QoreListNode*>(n);
      if (l->needs_eval()) {
	 for (unsigned i = 0; i <l->size(); i++) {
	    if (needsEval(l->retrieve_entry(i)))
	       return true;
	 }
	 // here we set needs_eval to false so the list won't be evaluated again
	 l->clearNeedsEval();
      }
      return false;
   }

   if (ntype == NT_HASH) {
      QoreHashNode* h = reinterpret_cast<QoreHashNode*>(n);
      if (h->needs_eval()) {
	 HashIterator hi(h);
	 while (hi.next())
	    if (needsEval(hi.getValue()))
	       return true;
	 // here we set needs_eval to false so the hash won't be evaluated again
	 h->clearNeedsEval();
      }
      return false;
   }
   
   if (ntype == NT_TREE) {
      QoreTreeNode* tree = reinterpret_cast<QoreTreeNode*>(n);

      if (needsEval(tree->left) || (tree->right && needsEval(tree->right)))
	 return true;
      return tree->getOp()->hasEffect();
   }

   //printd(5, "needsEval() type %s = true\n", n->getTypeName());
   // we don't return needs_eval() here because some node types are not meant to be evaluated directly but are also not values
   return !n->is_value();
}

static int check_case(const char* op, AbstractQoreNode* exp) {
   // ignore if NULL (= NOTHING)
   if (exp && needsEval(exp)) {
      if (op)
	 parse_error("case expression with '%s' needs run-time evaluation", op);
      else
	 parse_error("case expression needs run-time evaluation", op);
      return -1;
   }
   return 0;
}

#define OFM_PRIVATE    (1 << 0)
#define OFM_SYNCED     (1 << 1)
#define OFM_STATIC     (1 << 2)
#define OFM_DEPRECATED (1 << 3)
#define OFM_PUBLIC     (1 << 4)
#define OFM_FINAL      (1 << 5)
#define OFM_ABSTRACT   (1 << 6)

static void check_funcmod(int mod) {
   if (mod & OFM_PRIVATE)
      parse_error("illegal 'private' modifier in function declaration");
   if (mod & OFM_STATIC)
      parse_error("illegal 'static' modifier in function declaration");
   if (mod & OFM_FINAL)
      parse_error("illegal 'final' modifier in function declaration");
   if (mod & OFM_ABSTRACT)
      parse_error("illegal 'abstract' modifier in function declaration");
}

static void check_classmod(int mod, QoreClass& qc) {
   if (mod & OFM_PRIVATE)
      parse_error("illegal 'private' modifier in class declaration");
   if (mod & OFM_SYNCED)
      parse_error("illegal 'synchronized' modifier in class declaration");
   if (mod & OFM_STATIC)
      parse_error("illegal 'static' modifier in class declaration");
   if (mod & OFM_PUBLIC)
      qore_class_private::setPublic(qc);
   if (mod & OFM_DEPRECATED)
      parse_error("illegal 'deprecated' modifier in class declaration");
   if (mod & OFM_FINAL)
      qore_class_private::setFinal(qc);
   if (mod & OFM_ABSTRACT)
      parse_error("illegal 'abstract' modifier in class declaration");
}

static void check_nsmod(int mod, qore_ns_private& ns) {
   if (mod & OFM_PRIVATE)
      parse_error("illegal 'private' modifier in namespace declaration");
   if (mod & OFM_SYNCED)
      parse_error("illegal 'synchronized' modifier in namespace declaration");
   if (mod & OFM_STATIC)
      parse_error("illegal 'static' modifier in namespace declaration");
   if (mod & OFM_PUBLIC)
      ns.setPublic();
   if (mod & OFM_DEPRECATED)
      parse_error("illegal 'deprecated' modifier in namespace declaration");
   if (mod & OFM_FINAL)
      parse_error("illegal 'final' modifier in namespace declaration");
   if (mod & OFM_ABSTRACT)
      parse_error("illegal 'abstract' modifier in namespace declaration");
}

static bool hasEffect(AbstractQoreNode* n) {
   if (!n || n->is_value())
      return false;

   if (n->getType() == NT_OPERATOR)
      return reinterpret_cast<const QoreOperatorNode*>(n)->hasEffect();

   ParseNode* pn = dynamic_cast<ParseNode*>(n);
   return pn ? pn->has_effect() : true;
}

static int checkMethod(const char* name, BCAList* bcal, RetTypeInfo* returnTypeInfo) {
   bool con = !strcmp(name, "constructor");
   bool dst = !con && !strcmp(name, "destructor");

   // see if a return type is given for special methods
   if (returnTypeInfo && (con || dst)) {
      parse_error("%s methods may not declare a return type", name);
      return -1;
   }

   if (bcal && !con) {
      parse_error("base class constructor lists are only legal when defining constructor() methods");
      return -1;
   }

   return 0;
}

static inline MethodVariantBase* newMethodVariant(const char* name, int mod, int n_sig_first_line, int n_sig_last_line, AbstractQoreNode* params, BCAList* bcal, RetTypeInfo* returnTypeInfo, StatementBlock *b, int64 flags = QC_NO_FLAGS) {
   //printd(5, "newMethodVariant() '%s' b: %p\n", name, b);

   if (get_pop_argv_ref())
      flags |= QC_USES_EXTRA_ARGS;

   if (!strcmp(name, "constructor")) {
      if (mod & OFM_SYNCED)
         parse_error("%s() methods cannot be synchronized", name);
      if (mod & OFM_FINAL)
         parse_error("%s() methods cannot be declared final; declare the class final instead", name);
      if (mod & OFM_ABSTRACT)
         parse_error("%s() methods cannot be declared abstract", name);
      if (returnTypeInfo) {
         parse_error("return type information cannot be defined for %s() methods", name);
         delete returnTypeInfo;
      }
      return new UserConstructorVariant(mod & OFM_PRIVATE, b, n_sig_first_line, n_sig_last_line, params, bcal, flags);
   }
   if (bcal) {
      parse_error("only constructors may have base class constructor arguments");
      delete bcal;
      bcal = 0;
   }
   if (!strcmp(name, "destructor")) {
      if (params) {
	 parse_error("parameters cannot be defined for destructors");
	 params->deref(0);
      }
      if (mod & OFM_SYNCED)
         parse_error("%s() methods cannot be synchronized", name);
      if (mod & OFM_FINAL)
         parse_error("%s() methods cannot be declared final; declare the class final instead", name);
      if (mod & OFM_ABSTRACT)
         parse_error("%s() methods cannot be declared abstract", name);
      if (returnTypeInfo) {
         parse_error("return type information cannot be defined for %s() methods", name);
         delete returnTypeInfo;
      }
      if (mod & OFM_PRIVATE)
	 parse_error("destructors cannot be private");
      return new UserDestructorVariant(b, n_sig_first_line, n_sig_last_line);
   }
   if (!strcmp(name, "copy")) {
      if (mod & OFM_FINAL)
         parse_error("%s() methods cannot be declared final; declare the class final instead", name);
      if (!(mod & OFM_SYNCED))
         return new UserCopyVariant(mod & OFM_PRIVATE, b, n_sig_first_line, n_sig_last_line, params, returnTypeInfo, mod & OFM_SYNCED);
   }

   if (!strcmp(name, "methodGate") || !strcmp(name, "memberGate") || !strcmp(name, "memberNotification")) {
      if (mod & OFM_FINAL)
         parse_error("%s() methods cannot be declared final; they are not inherited anyway", name);
      if (mod & OFM_ABSTRACT)
         parse_error("%s() methods cannot be declared abstract; they are not inherited anyway", name);
   }

   if (mod & OFM_FINAL && mod & OFM_ABSTRACT)
      parse_error("method '%s()' is declared both final and abstract", name);

   return new UserMethodVariant(mod & OFM_PRIVATE, mod & OFM_FINAL, b, n_sig_first_line, n_sig_last_line, params, returnTypeInfo, mod & OFM_SYNCED, flags, mod & OFM_ABSTRACT);
}

static inline void tryAddMethod(int mod, char* n, int n_sig_first_line, int n_sig_last_line, AbstractQoreNode* params, BCAList* bcal, RetTypeInfo* returnTypeInfo, StatementBlock *b) {
   std::auto_ptr<NamedScope> name(new NamedScope(n));

   if (checkMethod(name->getIdentifier(), bcal, returnTypeInfo)) {
      if (params)
	 params->deref(0);
      delete bcal;
      delete b;
      delete returnTypeInfo;
   }
   else {
      MethodVariantBase *m = newMethodVariant(name->getIdentifier(), mod, n_sig_first_line, n_sig_last_line, params, bcal, returnTypeInfo, b, mod & OFM_DEPRECATED);
      // if there are any errors, the function below will delete memory
      qore_root_ns_private::parseAddMethodToClass(*(name.get()), m, mod & OFM_STATIC);
   }
}

struct MethodNode {
public:
   // name of method
   char* name;
   // method variant to add to class
   MethodVariantBase *m;
   // static flag
   bool static_flag;

   DLLLOCAL inline MethodNode(char* mname, MethodVariantBase *v, bool n_static) : name(mname), m(v), static_flag(n_static) {
   }
   DLLLOCAL inline ~MethodNode() {
      free(name);
      delete m;
   }
   DLLLOCAL inline void addAndDelete(QoreClass *qc) {
      qore_class_private::addUserMethod(*qc, name, m, static_flag);
      m = 0;
      delete this;
   }
};

static AbstractQoreNode* is_rewritable_op(AbstractQoreNode* n) {
   qore_type_t nt = get_node_type(n);
   if (nt == NT_OPERATOR) {
      QoreBinaryLValueOperatorNode* op = dynamic_cast<QoreBinaryLValueOperatorNode*>(n);
      if (op)
         return op->getRight();
   }

   return 0;
}

static AbstractQoreNode* checkRewriteList(QoreListNode* l) {
   // rewrite expression if it's a list without parentheses and
   // the first expression has one of the following operators:
   // =, +=, -=
   if (l->isFinalized())
      return l;

   AbstractQoreNode* e0 = l->retrieve_entry(0);

   AbstractQoreNode* r = is_rewritable_op(e0);
   if (r) {
      AbstractQoreNode* last = e0;
      AbstractQoreNode* top = e0;
      while (true) {
         AbstractQoreNode* nr = is_rewritable_op(r);
         if (!nr)
            break;
         last = r;
         r = nr;
      }
      assert(dynamic_cast<QoreBinaryLValueOperatorNode*>(last));
      // take first element from list (the tree) and make it the new expression
      QoreBinaryLValueOperatorNode* op = reinterpret_cast<QoreBinaryLValueOperatorNode*>(last);
      l->swap(0, op->swapRight(l));
      return top;
   }

   return l;
}

void ignore_return_value(AbstractQoreNode* n) {
   qore_type_t t = get_node_type(n);
   if (t == NT_TREE)
      reinterpret_cast<QoreTreeNode*>(n)->ignoreReturnValue();
   else if (t == NT_OPERATOR)
      reinterpret_cast<QoreOperatorNode*>(n)->ignoreReturnValue();
}

static qore_var_t get_var_type() {
   return checkParseOption(PO_ASSUME_LOCAL) ? VT_LOCAL : VT_UNRESOLVED;
}


/* Line 371 of yacc.c  */
#line 1205 "parser.cpp"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_PARSER_HPP_INCLUDED
# define YY_YY_PARSER_HPP_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOK_RETURN = 258,
     TOK_RETURNS = 259,
     TOK_MY = 260,
     TOK_DO = 261,
     TOK_TRY = 262,
     TOK_THROW = 263,
     TOK_CATCH = 264,
     TOK_WHERE = 265,
     TOK_WHILE = 266,
     TOK_IF = 267,
     TOK_FOR = 268,
     TOK_SUB = 269,
     TOK_THREAD_EXIT = 270,
     TOK_BREAK = 271,
     TOK_CONTINUE = 272,
     TOK_CONTEXT_ROW = 273,
     TOK_FIND = 274,
     TOK_FOREACH = 275,
     TOK_IN = 276,
     TOK_DELETE = 277,
     TOK_REMOVE = 278,
     TOK_PRIVATE = 279,
     TOK_PUBLIC = 280,
     TOK_SYNCHRONIZED = 281,
     TOK_DEPRECATED = 282,
     TOK_CONTEXT = 283,
     TOK_SORT_BY = 284,
     TOK_SORT_DESCENDING_BY = 285,
     TOK_SUB_CONTEXT = 286,
     TOK_CONST = 287,
     TOK_SUMMARIZE = 288,
     TOK_BY = 289,
     TOK_OUR = 290,
     TOK_RETHROW = 291,
     TOK_SWITCH = 292,
     TOK_CASE = 293,
     TOK_DEFAULT = 294,
     TOK_INHERITS = 295,
     TOK_ELSE = 296,
     TOK_STATIC = 297,
     TOK_NAMESPACE = 298,
     TOK_MODULE = 299,
     TOK_FINAL = 300,
     TOK_ABSTRACT = 301,
     TOK_UNREFERENCE = 302,
     P_INCREMENT = 303,
     P_DECREMENT = 304,
     PLUS_EQUALS = 305,
     MINUS_EQUALS = 306,
     AND_EQUALS = 307,
     OR_EQUALS = 308,
     MODULA_EQUALS = 309,
     MULTIPLY_EQUALS = 310,
     DIVIDE_EQUALS = 311,
     XOR_EQUALS = 312,
     SHIFT_LEFT_EQUALS = 313,
     SHIFT_RIGHT_EQUALS = 314,
     TOK_UNSHIFT = 315,
     TOK_PUSH = 316,
     TOK_POP = 317,
     TOK_SHIFT = 318,
     TOK_CHOMP = 319,
     TOK_TRIM = 320,
     LOGICAL_AND = 321,
     LOGICAL_OR = 322,
     LOGICAL_EQ = 323,
     LOGICAL_NE = 324,
     LOGICAL_LE = 325,
     LOGICAL_GE = 326,
     LOGICAL_CMP = 327,
     ABSOLUTE_EQ = 328,
     ABSOLUTE_NE = 329,
     REGEX_MATCH = 330,
     REGEX_NMATCH = 331,
     TOK_EXISTS = 332,
     TOK_INSTANCEOF = 333,
     SHIFT_RIGHT = 334,
     SHIFT_LEFT = 335,
     TOK_ELEMENTS = 336,
     TOK_KEYS = 337,
     TOK_NEW = 338,
     TOK_BACKGROUND = 339,
     TOK_ON_EXIT = 340,
     TOK_ON_SUCCESS = 341,
     TOK_ON_ERROR = 342,
     TOK_MAP = 343,
     TOK_FOLDR = 344,
     TOK_FOLDL = 345,
     TOK_SELECT = 346,
     TOK_SPLICE = 347,
     TOK_EXTRACT = 348,
     IMPLICIT_ELEMENT = 349,
     INTEGER = 350,
     QFLOAT = 351,
     NUMBER = 352,
     IDENTIFIER = 353,
     VAR_REF = 354,
     BACKQUOTE = 355,
     SELF_REF = 356,
     KW_IDENTIFIER_OPENPAREN = 357,
     SCOPED_REF = 358,
     SCOPED_VREF = 359,
     CONTEXT_REF = 360,
     COMPLEX_CONTEXT_REF = 361,
     QORE_CAST = 362,
     CLASS_STRING = 363,
     DATETIME = 364,
     QUOTED_WORD = 365,
     BINARY = 366,
     REGEX_SUBST = 367,
     REGEX_TRANS = 368,
     CLASS_SCOPED_REF = 369,
     BASE_CLASS_CALL = 370,
     REGEX = 371,
     REGEX_EXTRACT = 372,
     IMPLICIT_ARG_REF = 373,
     DOT_KW_IDENTIFIER = 374,
     TRY_MODULE_ERROR = 375,
     IFX = 376,
     NEG = 377
   };
#endif
/* Tokens.  */
#define TOK_RETURN 258
#define TOK_RETURNS 259
#define TOK_MY 260
#define TOK_DO 261
#define TOK_TRY 262
#define TOK_THROW 263
#define TOK_CATCH 264
#define TOK_WHERE 265
#define TOK_WHILE 266
#define TOK_IF 267
#define TOK_FOR 268
#define TOK_SUB 269
#define TOK_THREAD_EXIT 270
#define TOK_BREAK 271
#define TOK_CONTINUE 272
#define TOK_CONTEXT_ROW 273
#define TOK_FIND 274
#define TOK_FOREACH 275
#define TOK_IN 276
#define TOK_DELETE 277
#define TOK_REMOVE 278
#define TOK_PRIVATE 279
#define TOK_PUBLIC 280
#define TOK_SYNCHRONIZED 281
#define TOK_DEPRECATED 282
#define TOK_CONTEXT 283
#define TOK_SORT_BY 284
#define TOK_SORT_DESCENDING_BY 285
#define TOK_SUB_CONTEXT 286
#define TOK_CONST 287
#define TOK_SUMMARIZE 288
#define TOK_BY 289
#define TOK_OUR 290
#define TOK_RETHROW 291
#define TOK_SWITCH 292
#define TOK_CASE 293
#define TOK_DEFAULT 294
#define TOK_INHERITS 295
#define TOK_ELSE 296
#define TOK_STATIC 297
#define TOK_NAMESPACE 298
#define TOK_MODULE 299
#define TOK_FINAL 300
#define TOK_ABSTRACT 301
#define TOK_UNREFERENCE 302
#define P_INCREMENT 303
#define P_DECREMENT 304
#define PLUS_EQUALS 305
#define MINUS_EQUALS 306
#define AND_EQUALS 307
#define OR_EQUALS 308
#define MODULA_EQUALS 309
#define MULTIPLY_EQUALS 310
#define DIVIDE_EQUALS 311
#define XOR_EQUALS 312
#define SHIFT_LEFT_EQUALS 313
#define SHIFT_RIGHT_EQUALS 314
#define TOK_UNSHIFT 315
#define TOK_PUSH 316
#define TOK_POP 317
#define TOK_SHIFT 318
#define TOK_CHOMP 319
#define TOK_TRIM 320
#define LOGICAL_AND 321
#define LOGICAL_OR 322
#define LOGICAL_EQ 323
#define LOGICAL_NE 324
#define LOGICAL_LE 325
#define LOGICAL_GE 326
#define LOGICAL_CMP 327
#define ABSOLUTE_EQ 328
#define ABSOLUTE_NE 329
#define REGEX_MATCH 330
#define REGEX_NMATCH 331
#define TOK_EXISTS 332
#define TOK_INSTANCEOF 333
#define SHIFT_RIGHT 334
#define SHIFT_LEFT 335
#define TOK_ELEMENTS 336
#define TOK_KEYS 337
#define TOK_NEW 338
#define TOK_BACKGROUND 339
#define TOK_ON_EXIT 340
#define TOK_ON_SUCCESS 341
#define TOK_ON_ERROR 342
#define TOK_MAP 343
#define TOK_FOLDR 344
#define TOK_FOLDL 345
#define TOK_SELECT 346
#define TOK_SPLICE 347
#define TOK_EXTRACT 348
#define IMPLICIT_ELEMENT 349
#define INTEGER 350
#define QFLOAT 351
#define NUMBER 352
#define IDENTIFIER 353
#define VAR_REF 354
#define BACKQUOTE 355
#define SELF_REF 356
#define KW_IDENTIFIER_OPENPAREN 357
#define SCOPED_REF 358
#define SCOPED_VREF 359
#define CONTEXT_REF 360
#define COMPLEX_CONTEXT_REF 361
#define QORE_CAST 362
#define CLASS_STRING 363
#define DATETIME 364
#define QUOTED_WORD 365
#define BINARY 366
#define REGEX_SUBST 367
#define REGEX_TRANS 368
#define CLASS_SCOPED_REF 369
#define BASE_CLASS_CALL 370
#define REGEX 371
#define REGEX_EXTRACT 372
#define IMPLICIT_ARG_REF 373
#define DOT_KW_IDENTIFIER 374
#define TRY_MODULE_ERROR 375
#define IFX 376
#define NEG 377



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 1144 "parser.ypp"

   bool b;
   int i4;
   int64 integer;
   double decimal;
   QoreStringNode* String;
   char* string;
   BinaryNode* binary;
   AbstractQoreNode* node;
   QoreHashNode* hash;
   QoreListNode* list;
   AbstractStatement *statement;
   struct MemberInfo* memberinfo;
   struct ClassVarInfo* classvarinfo;
   StatementBlock *sblock;
   ContextModList* cmods;
   ContextMod *cmod;
   class HashElement *hashelement;
   QoreFunction *userfunc;	
   struct MethodNode* methodnode;
   class MemberList* memberlist;
   QoreClass *qoreclass;
   class ConstNode* constnode;
   QoreNamespace *ns;
   struct NSNodeList* nsnlist;
   struct NSNode* nsn;
   class ObjClassDef *classdef;
   DateTimeNode* datetime;
   RegexSubstNode* RegexSubst;
   RegexTransNode* RegexTrans;
   SwitchStatement *switchstmt;
   CaseNode* casenode;
   BCList* sclist;
   class BCNode* sclnode;
   BCAList* bcalist;
   BCANode* bcanode;
   NamedScope *nscope;
   QoreRegexNode* Regex;
   QoreImplicitArgumentNode* implicit_arg;
   RetTypeInfo* returnTypeInfo;
   struct ParserTypeStruct *parsertype;
   class ParseUserFunction* parsefunc;
   class ParseScopedUserFunction* sparsefunc;
   struct GVarDecl* gv;
   QoreNumberNode* num;
   TryModuleError* trymod;


/* Line 387 of yacc.c  */
#line 1541 "parser.cpp"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (yyscan_t yyscanner);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_YY_PARSER_HPP_INCLUDED  */

/* Copy the second part of user declarations.  */
/* Line 390 of yacc.c  */
#line 1192 "parser.ypp"


#define LEX_PARAMETERS YYSTYPE *lvalp, YYLTYPE *loc, yyscan_t scanner

DLLLOCAL int yylex(LEX_PARAMETERS);

DLLLOCAL void yyerror(YYLTYPE *loc, yyscan_t scanner, const char* str) {
   //printd(5, "yyerror() location: %d-%d: \"%s\"\n", loc->first_line, loc->last_line, str);
   parse_error("%s", str);
}


/* Line 390 of yacc.c  */
#line 1594 "parser.cpp"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  194
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   8556

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  148
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  57
/* YYNRULES -- Number of rules.  */
#define YYNRULES  323
/* YYNRULES -- Number of states.  */
#define YYNSTATES  728

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   377

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   139,     2,     2,     2,   133,   126,     2,
     143,   146,   134,   131,   122,   132,   142,   135,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   125,   145,
     129,   123,   130,   124,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   141,   138,   147,   128,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   140,   127,   144,   137,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   136
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    14,    16,    18,
      20,    22,    26,    28,    33,    35,    37,    40,    45,    46,
      48,    53,    57,    62,    66,    71,    76,    82,    88,    92,
      97,    99,   102,   104,   106,   108,   110,   112,   115,   117,
     123,   130,   136,   143,   147,   150,   152,   154,   156,   158,
     161,   164,   165,   167,   170,   176,   178,   181,   185,   188,
     191,   194,   198,   210,   218,   224,   232,   238,   246,   256,
     264,   267,   270,   273,   276,   278,   281,   282,   285,   290,
     295,   300,   302,   305,   313,   315,   318,   324,   329,   335,
     340,   346,   351,   357,   362,   368,   373,   379,   384,   390,
     395,   400,   404,   409,   413,   417,   420,   428,   429,   431,
     433,   440,   447,   452,   457,   463,   469,   472,   473,   475,
     479,   481,   483,   486,   489,   492,   495,   497,   499,   501,
     503,   506,   509,   512,   515,   517,   519,   522,   525,   526,
     528,   532,   537,   541,   546,   550,   555,   559,   566,   572,
     580,   584,   590,   597,   601,   607,   614,   617,   622,   624,
     626,   628,   631,   633,   637,   639,   642,   645,   647,   655,
     663,   671,   679,   688,   697,   706,   715,   723,   731,   734,
     735,   737,   741,   746,   751,   752,   754,   756,   759,   761,
     763,   765,   767,   769,   771,   773,   776,   777,   784,   791,
     799,   807,   815,   823,   832,   841,   845,   848,   850,   854,
     857,   861,   865,   869,   871,   873,   875,   879,   881,   884,
     887,   890,   894,   897,   901,   906,   908,   910,   912,   914,
     916,   925,   929,   933,   937,   941,   945,   949,   953,   957,
     961,   965,   969,   972,   975,   979,   983,   986,   989,   992,
     995,   998,  1001,  1004,  1007,  1010,  1013,  1016,  1019,  1022,
    1028,  1031,  1034,  1037,  1040,  1045,  1050,  1054,  1056,  1060,
    1064,  1068,  1072,  1076,  1080,  1084,  1088,  1092,  1096,  1100,
    1104,  1108,  1112,  1116,  1120,  1124,  1128,  1132,  1136,  1140,
    1144,  1148,  1152,  1156,  1160,  1163,  1166,  1169,  1172,  1178,
    1184,  1187,  1189,  1194,  1199,  1203,  1206,  1210,  1213,  1220,
    1227,  1235,  1243,  1245,  1247,  1250,  1253,  1258,  1260,  1263,
    1265,  1267,  1269,  1271
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     149,     0,    -1,   150,    -1,   149,   150,    -1,   197,    -1,
     198,    -1,   173,    -1,   159,    -1,   158,    -1,   189,    -1,
     164,    -1,   140,   162,   144,    -1,   155,    -1,    44,   140,
     151,   144,    -1,   120,    -1,   152,    -1,   151,   152,    -1,
      98,   123,   202,   145,    -1,    -1,    25,    -1,   153,    35,
     178,   103,    -1,   153,    35,   103,    -1,   153,    35,   178,
      98,    -1,   153,    35,    98,    -1,   153,    35,   179,   104,
      -1,   153,    35,   179,    99,    -1,   153,    35,   143,   199,
     146,    -1,   193,    43,   140,   156,   144,    -1,   193,    43,
     145,    -1,   193,    43,   140,   144,    -1,   157,    -1,   156,
     157,    -1,   159,    -1,   158,    -1,   173,    -1,   197,    -1,
     198,    -1,   154,   145,    -1,   155,    -1,    32,    98,   123,
     202,   145,    -1,    25,    32,    98,   123,   202,   145,    -1,
      32,   103,   123,   202,   145,    -1,    25,    32,   103,   123,
     202,   145,    -1,   140,   162,   144,    -1,   140,   144,    -1,
     164,    -1,   160,    -1,   164,    -1,   160,    -1,   162,   160,
      -1,   162,   164,    -1,    -1,    98,    -1,   202,   145,    -1,
     103,   143,   172,   146,   145,    -1,   171,    -1,    36,   145,
      -1,     8,   202,   145,    -1,    85,   161,    -1,    86,   161,
      -1,    87,   161,    -1,    31,   165,   161,    -1,    33,   163,
     143,   202,   146,    34,   143,   202,   146,   165,   161,    -1,
      28,   163,   143,   202,   146,   165,   161,    -1,    12,   143,
     202,   146,   161,    -1,    12,   143,   202,   146,   161,    41,
     161,    -1,    11,   143,   202,   146,   161,    -1,     6,   161,
      11,   143,   202,   146,   145,    -1,    13,   143,   172,   145,
     172,   145,   172,   146,   161,    -1,    20,   202,    21,   143,
     202,   146,   161,    -1,   167,   145,    -1,    15,   145,    -1,
      16,   145,    -1,    17,   145,    -1,   168,    -1,     1,   145,
      -1,    -1,   165,   166,    -1,    10,   143,   202,   146,    -1,
      29,   143,   202,   146,    -1,    30,   143,   202,   146,    -1,
       3,    -1,     3,   202,    -1,    37,   143,   202,   146,   140,
     169,   144,    -1,   170,    -1,   169,   170,    -1,    38,    71,
     202,   125,   162,    -1,    38,    71,   202,   125,    -1,    38,
      70,   202,   125,   162,    -1,    38,    70,   202,   125,    -1,
      38,    68,   202,   125,   162,    -1,    38,    68,   202,   125,
      -1,    38,   129,   202,   125,   162,    -1,    38,   129,   202,
     125,    -1,    38,   130,   202,   125,   162,    -1,    38,   130,
     202,   125,    -1,    38,    75,   116,   125,   162,    -1,    38,
      75,   116,   125,    -1,    38,    76,   116,   125,   162,    -1,
      38,    76,   116,   125,    -1,    38,   116,   125,   162,    -1,
      38,   116,   125,    -1,    38,   202,   125,   162,    -1,    38,
     202,   125,    -1,    39,   125,   162,    -1,    39,   125,    -1,
       7,   161,     9,   143,   172,   146,   161,    -1,    -1,   202,
      -1,     1,    -1,   193,   108,   174,   140,   177,   144,    -1,
     193,   114,   174,   140,   177,   144,    -1,   193,   108,   174,
     145,    -1,   193,   114,   174,   145,    -1,   193,   108,   174,
     140,   144,    -1,   193,   114,   174,   140,   144,    -1,    40,
     175,    -1,    -1,   176,    -1,   175,   122,   176,    -1,    98,
      -1,   103,    -1,    25,    98,    -1,    25,   103,    -1,    24,
      98,    -1,    24,   103,    -1,   188,    -1,   180,    -1,   181,
      -1,   158,    -1,   177,   188,    -1,   177,   180,    -1,   177,
     181,    -1,   177,   158,    -1,    98,    -1,   103,    -1,   134,
      98,    -1,   134,   103,    -1,    -1,   178,    -1,    24,   185,
     145,    -1,    24,   140,   186,   144,    -1,    25,   185,   145,
      -1,    25,   140,   186,   144,    -1,    25,   140,   144,    -1,
      42,   178,    98,   145,    -1,    42,    98,   145,    -1,    42,
     178,    98,   123,   202,   145,    -1,    42,    98,   123,   202,
     145,    -1,    42,   178,    98,   143,   172,   146,   145,    -1,
     179,   101,   145,    -1,   179,   101,   123,   202,   145,    -1,
     179,   101,   143,   172,   146,   145,    -1,   178,    98,   145,
      -1,   178,    98,   123,   202,   145,    -1,   178,    98,   143,
     172,   146,   145,    -1,    98,   145,    -1,    98,   123,   202,
     145,    -1,   182,    -1,   158,    -1,   101,    -1,   101,   103,
      -1,   184,    -1,   185,   122,   184,    -1,   183,    -1,   186,
     183,    -1,    98,   143,    -1,   102,    -1,   193,   187,   172,
     146,   190,   196,   160,    -1,   193,   178,   187,   172,   146,
     190,   160,    -1,   193,   187,   172,   146,   190,   196,   145,
      -1,   193,   178,   187,   172,   146,   190,   145,    -1,   194,
     103,   143,   172,   146,   190,   196,   160,    -1,   194,   178,
     103,   143,   172,   146,   190,   160,    -1,   194,   103,   143,
     172,   146,   190,   196,   145,    -1,   194,   178,   103,   143,
     172,   146,   190,   145,    -1,   103,   143,   172,   146,   190,
     196,   160,    -1,   178,   103,   143,   172,   146,   190,   160,
      -1,   125,   191,    -1,    -1,   192,    -1,   191,   122,   192,
      -1,    98,   143,   172,   146,    -1,   103,   143,   172,   146,
      -1,    -1,   194,    -1,   195,    -1,   194,   195,    -1,    24,
      -1,    42,    -1,    26,    -1,    27,    -1,    25,    -1,    45,
      -1,    46,    -1,     4,   179,    -1,    -1,    14,   187,   172,
     146,   196,   160,    -1,   178,    14,   187,   172,   146,   160,
      -1,   194,    14,   187,   172,   146,   196,   160,    -1,   194,
     178,    14,   187,   172,   146,   160,    -1,    14,   103,   143,
     172,   146,   196,   160,    -1,   178,    14,   103,   143,   172,
     146,   160,    -1,   194,    14,   103,   143,   172,   146,   196,
     160,    -1,   194,   178,    14,   103,   143,   172,   146,   160,
      -1,   202,   122,   202,    -1,   202,   122,    -1,   201,    -1,
     200,   122,   201,    -1,   200,   122,    -1,   204,   125,   202,
      -1,    98,   125,   202,    -1,   103,   125,   202,    -1,   204,
      -1,   111,    -1,   199,    -1,   143,   200,   146,    -1,   103,
      -1,   179,    99,    -1,   179,   104,    -1,   178,    98,    -1,
       5,   178,    98,    -1,     5,    98,    -1,     5,   179,    99,
      -1,     5,   143,   199,   146,    -1,   154,    -1,    98,    -1,
     105,    -1,    18,    -1,   106,    -1,    19,   202,    21,   202,
      10,   143,   202,   146,    -1,   202,    50,   202,    -1,   202,
      51,   202,    -1,   202,    52,   202,    -1,   202,    53,   202,
      -1,   202,    54,   202,    -1,   202,    55,   202,    -1,   202,
      56,   202,    -1,   202,    57,   202,    -1,   202,    58,   202,
      -1,   202,    59,   202,    -1,   202,   123,   202,    -1,    77,
     202,    -1,    81,   202,    -1,   202,    78,    98,    -1,   202,
      78,   103,    -1,    82,   202,    -1,    60,   202,    -1,    63,
     202,    -1,    61,   202,    -1,    62,   202,    -1,    64,   202,
      -1,    65,   202,    -1,    92,   202,    -1,    93,   202,    -1,
      88,   202,    -1,    89,   202,    -1,    90,   202,    -1,    91,
     202,    -1,   202,   124,   202,   125,   202,    -1,    48,   202,
      -1,   202,    48,    -1,    49,   202,    -1,   202,    49,    -1,
     202,   143,   172,   146,    -1,   115,   143,   172,   146,    -1,
     102,   172,   146,    -1,   101,    -1,   202,    66,   202,    -1,
     202,    67,   202,    -1,   202,   127,   202,    -1,   202,   126,
     202,    -1,   202,   128,   202,    -1,   202,    75,   116,    -1,
     202,    76,   116,    -1,   202,    75,   112,    -1,   202,    75,
     113,    -1,   202,    75,   117,    -1,   202,   130,   202,    -1,
     202,   129,   202,    -1,   202,    72,   202,    -1,   202,    68,
     202,    -1,   202,    73,   202,    -1,   202,    74,   202,    -1,
     202,    69,   202,    -1,   202,    70,   202,    -1,   202,    71,
     202,    -1,   202,    80,   202,    -1,   202,    79,   202,    -1,
     202,   131,   202,    -1,   202,   132,   202,    -1,   202,   133,
     202,    -1,   202,   135,   202,    -1,   202,   134,   202,    -1,
     132,   202,    -1,   137,   202,    -1,   139,   202,    -1,   138,
     202,    -1,    83,    98,   143,   172,   146,    -1,    83,   103,
     143,   172,   146,    -1,    84,   202,    -1,   100,    -1,   202,
     141,   202,   147,    -1,   202,   140,   202,   144,    -1,   202,
     142,   202,    -1,   202,   119,    -1,   143,   202,   146,    -1,
     143,   146,    -1,    14,   143,   172,   146,   196,   160,    -1,
     178,    14,   143,   172,   146,   160,    -1,   194,    14,   143,
     172,   146,   196,   160,    -1,   194,   178,    14,   143,   172,
     146,   160,    -1,   118,    -1,    94,    -1,    22,   202,    -1,
      23,   202,    -1,   107,   143,   202,   146,    -1,   110,    -1,
     110,   203,    -1,    96,    -1,    95,    -1,   203,    -1,   109,
      -1,    97,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,  1420,  1420,  1421,  1425,  1428,  1431,  1439,  1443,  1447,
    1448,  1456,  1462,  1468,  1475,  1500,  1502,  1507,  1520,  1521,
    1527,  1532,  1535,  1540,  1543,  1548,  1553,  1559,  1566,  1571,
    1579,  1583,  1590,  1593,  1596,  1602,  1605,  1608,  1611,  1619,
    1622,  1628,  1631,  1637,  1640,  1645,  1648,  1653,  1655,  1657,
    1659,  1665,  1666,  1670,  1689,  1695,  1697,  1700,  1703,  1706,
    1709,  1712,  1715,  1718,  1721,  1724,  1727,  1730,  1733,  1736,
    1739,  1740,  1747,  1750,  1753,  1754,  1759,  1760,  1771,  1773,
    1775,  1780,  1782,  1786,  1796,  1800,  1808,  1813,  1819,  1824,
    1830,  1835,  1841,  1846,  1852,  1857,  1863,  1867,  1872,  1876,
    1881,  1885,  1890,  1895,  1901,  1905,  1912,  1930,  1931,  1932,
    1936,  1941,  1946,  1953,  1960,  1967,  1977,  1980,  1986,  1989,
    1996,  1999,  2002,  2005,  2008,  2011,  2017,  2021,  2026,  2031,
    2036,  2040,  2045,  2050,  2071,  2074,  2077,  2080,  2087,  2088,
    2094,  2097,  2103,  2106,  2109,  2115,  2119,  2122,  2127,  2130,
    2145,  2152,  2159,  2177,  2184,  2191,  2209,  2215,  2221,  2224,
    2233,  2238,  2246,  2249,  2256,  2259,  2266,  2269,  2275,  2285,
    2299,  2305,  2318,  2327,  2339,  2344,  2352,  2355,  2364,  2367,
    2373,  2376,  2383,  2386,  2393,  2394,  2399,  2400,  2408,  2409,
    2410,  2411,  2412,  2413,  2414,  2418,  2429,  2434,  2439,  2448,
    2459,  2475,  2480,  2489,  2500,  2517,  2519,  2534,  2539,  2546,
    2551,  2553,  2555,  2559,  2561,  2563,  2565,  2567,  2569,  2582,
    2595,  2599,  2607,  2617,  2634,  2672,  2675,  2682,  2684,  2686,
    2688,  2690,  2693,  2696,  2699,  2702,  2705,  2708,  2711,  2714,
    2717,  2720,  2729,  2731,  2733,  2736,  2739,  2741,  2753,  2756,
    2768,  2771,  2774,  2777,  2797,  2817,  2836,  2850,  2864,  2878,
    2880,  2883,  2886,  2889,  2892,  2971,  2978,  2982,  2988,  2989,
    2990,  2991,  2992,  2993,  2996,  2999,  3003,  3006,  3008,  3009,
    3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,  3018,  3019,
    3020,  3021,  3022,  3023,  3024,  3030,  3031,  3032,  3062,  3067,
    3072,  3080,  3085,  3086,  3087,  3090,  3093,  3106,  3107,  3111,
    3118,  3126,  3138,  3142,  3145,  3148,  3151,  3157,  3160,  3167,
    3168,  3169,  3170,  3171
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "\"return\"", "\"returns\"", "\"my\"",
  "\"do\"", "\"try\"", "\"throw\"", "\"catch\"", "\"where\"", "\"while\"",
  "\"if\"", "\"for\"", "\"sub\"", "\"thread_exit\"", "\"break\"",
  "\"continue\"", "\"%%\"", "\"find\"", "\"foreach\"", "\"in\"",
  "\"delete\"", "\"remove\"", "\"private\"", "\"public\"",
  "\"synchronized\"", "\"deprecated\"", "\"context\"", "\"sortBy\"",
  "\"sortDescendingBy\"", "\"subcontext\"", "\"const\"", "\"summarize\"",
  "\"by\"", "\"our\"", "\"rethrow\"", "\"switch\"", "\"case\"",
  "\"default\"", "\"inherits\"", "\"else\"", "\"static\"", "\"namespace\"",
  "\"module\"", "\"final\"", "\"abstract\"", "\"unreference\"",
  "\"++ operator\"", "\"-- operator\"", "\"+= operator\"",
  "\"-= operator\"", "\"&= operator\"", "\"|= operator\"",
  "\"%= operator\"", "\"*= operator\"", "\"/= operator\"",
  "\"^= operator\"", "\"<<= operator\"", "\">>= operator\"", "\"unshift\"",
  "\"push\"", "\"pop\"", "\"shift\"", "\"chomp\"", "\"trim\"",
  "\"&& operator\"", "\"|| operator\"", "\"== operator\"",
  "\"!= operator\"", "\"<= operator\"", "\">= operator\"",
  "\"<=> operator\"", "\"=== operator\"", "\"!== operator\"",
  "\"=~ operator\"", "\"!~ operator\"", "\"exists\"", "\"instanceof\"",
  "\">> operator\"", "\"<< operator\"", "\"elements\"", "\"keys\"",
  "\"new\"", "\"background\"", "\"on_exit\"", "\"on_success\"",
  "\"on_error\"", "\"map\"", "\"foldr\"", "\"foldl\"", "\"select\"",
  "\"splice\"", "\"extract\"", "\"$#\"", "\"integer value\"",
  "\"floating-point value\"", "\"arbitrary-precision number\"",
  "\"identifier\"", "\"variable reference\"", "\"backquote expression\"",
  "\"in-object member reference\"",
  "\"identifier or keyword used as function or method identifier\"",
  "\"namespace or class-scoped reference\"",
  "\"namespace-scoped global variable reference\"",
  "\"context reference\"", "\"named context reference\"",
  "\"cast operator\"", "\"simple class declaration\"",
  "\"date/time value\"", "\"quoted string\"", "\"binary constant value\"",
  "\"regular expression substitution expression\"",
  "\"transliteration expression\"", "\"scoped class declaration\"",
  "\"call to base class method\"", "\"regular expression\"",
  "\"regular expression extraction expression\"",
  "\"implicit argument reference\"",
  "\"keyword used as hash key or object member reference\"",
  "\"%try-module error token\"", "IFX", "','", "'='", "'?'", "':'", "'&'",
  "'|'", "'^'", "'<'", "'>'", "'+'", "'-'", "'%'", "'*'", "'/'", "NEG",
  "'~'", "'\\\\'", "'!'", "'{'", "'['", "'.'", "'('", "'}'", "';'", "')'",
  "']'", "$accept", "top_level_commands", "top_level_command",
  "module_decls", "module_decl", "ppub", "gvardecl", "top_namespace_decl",
  "namespace_decls", "namespace_decl", "unscoped_const_decl",
  "scoped_const_decl", "block", "statement_or_block", "statements",
  "optname", "statement", "context_mods", "context_mod",
  "return_statement", "switch_statement", "case_block", "case_code",
  "try_statement", "myexp", "class_def", "inheritance_list",
  "superclass_list", "superclass", "class_attributes", "uncqtypedef",
  "qtypedef", "private_member_list", "public_member_list", "classvardecl",
  "member2", "member", "member_list", "member_list2", "ident_openparen",
  "method_definition", "object_outofline_function_def",
  "base_constructor_list", "base_constructors", "base_constructor",
  "nsc_modifiers", "method_modifiers", "method_modifier", "return_value",
  "sub_def", "scoped_sub_def", "list", "hash", "hash_element", "exp",
  "string", "scalar", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,    44,    61,    63,    58,    38,   124,    94,    60,
      62,    43,    45,    37,    42,    47,   377,   126,    92,    33,
     123,    91,    46,    40,   125,    59,    41,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   148,   149,   149,   150,   150,   150,   150,   150,   150,
     150,   150,   150,   150,   150,   151,   151,   152,   153,   153,
     154,   154,   154,   154,   154,   154,   154,   155,   155,   155,
     156,   156,   157,   157,   157,   157,   157,   157,   157,   158,
     158,   159,   159,   160,   160,   161,   161,   162,   162,   162,
     162,   163,   163,   164,   164,   164,   164,   164,   164,   164,
     164,   164,   164,   164,   164,   164,   164,   164,   164,   164,
     164,   164,   164,   164,   164,   164,   165,   165,   166,   166,
     166,   167,   167,   168,   169,   169,   170,   170,   170,   170,
     170,   170,   170,   170,   170,   170,   170,   170,   170,   170,
     170,   170,   170,   170,   170,   170,   171,   172,   172,   172,
     173,   173,   173,   173,   173,   173,   174,   174,   175,   175,
     176,   176,   176,   176,   176,   176,   177,   177,   177,   177,
     177,   177,   177,   177,   178,   178,   178,   178,   179,   179,
     180,   180,   181,   181,   181,   182,   182,   182,   182,   182,
     183,   183,   183,   183,   183,   183,   183,   183,   183,   183,
     184,   184,   185,   185,   186,   186,   187,   187,   188,   188,
     188,   188,   189,   189,   189,   189,   189,   189,   190,   190,
     191,   191,   192,   192,   193,   193,   194,   194,   195,   195,
     195,   195,   195,   195,   195,   196,   196,   197,   197,   197,
     197,   198,   198,   198,   198,   199,   199,   200,   200,   200,
     201,   201,   201,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   203,   203,   204,
     204,   204,   204,   204
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     4,     1,     1,     2,     4,     0,     1,
       4,     3,     4,     3,     4,     4,     5,     5,     3,     4,
       1,     2,     1,     1,     1,     1,     1,     2,     1,     5,
       6,     5,     6,     3,     2,     1,     1,     1,     1,     2,
       2,     0,     1,     2,     5,     1,     2,     3,     2,     2,
       2,     3,    11,     7,     5,     7,     5,     7,     9,     7,
       2,     2,     2,     2,     1,     2,     0,     2,     4,     4,
       4,     1,     2,     7,     1,     2,     5,     4,     5,     4,
       5,     4,     5,     4,     5,     4,     5,     4,     5,     4,
       4,     3,     4,     3,     3,     2,     7,     0,     1,     1,
       6,     6,     4,     4,     5,     5,     2,     0,     1,     3,
       1,     1,     2,     2,     2,     2,     1,     1,     1,     1,
       2,     2,     2,     2,     1,     1,     2,     2,     0,     1,
       3,     4,     3,     4,     3,     4,     3,     6,     5,     7,
       3,     5,     6,     3,     5,     6,     2,     4,     1,     1,
       1,     2,     1,     3,     1,     2,     2,     1,     7,     7,
       7,     7,     8,     8,     8,     8,     7,     7,     2,     0,
       1,     3,     4,     4,     0,     1,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     2,     0,     6,     6,     7,
       7,     7,     7,     8,     8,     3,     2,     1,     3,     2,
       3,     3,     3,     1,     1,     1,     3,     1,     2,     2,
       2,     3,     2,     3,     4,     1,     1,     1,     1,     1,
       8,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     3,     3,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     5,
       2,     2,     2,     2,     4,     4,     3,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     2,     2,     2,     5,     5,
       2,     1,     4,     4,     3,     2,     3,     2,     6,     6,
       7,     7,     1,     1,     2,     2,     4,     1,     2,     1,
       1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,   138,   138,     0,     0,   138,     0,     0,     0,
       0,     0,     0,     0,   228,   138,   138,   138,   138,   188,
     192,   190,   191,    51,    76,     0,    51,     0,     0,   189,
       0,   193,   194,   138,   138,   138,   138,   138,   138,   138,
     138,   138,   138,   138,     0,   138,     0,     0,     0,   138,
     138,   138,   138,   138,   138,   313,   320,   319,   323,   226,
     301,   267,     0,   217,   227,   229,     0,   322,   317,   214,
       0,   312,    14,   138,     0,   138,   138,   138,     0,   138,
       0,     2,     0,   225,    12,     8,     7,    10,     0,    74,
      55,     6,   139,     0,     9,     0,   185,   186,     4,     5,
     215,     0,   321,   213,    75,     0,   192,   217,   139,     0,
      82,   222,   135,   138,   139,     0,   217,     0,    46,     0,
      45,     0,     0,   138,   138,     0,     0,   167,     0,     0,
       0,    71,    72,    73,     0,     0,   314,   315,     0,    52,
       0,     0,     0,     0,     0,    56,   138,     0,   260,   262,
     247,   249,   250,   248,   251,   252,   242,   243,   246,     0,
       0,   300,    58,    59,    60,   255,   256,   257,   258,   253,
     254,   109,     0,   108,     0,   138,   318,     0,   294,   136,
     137,   295,   297,   296,    48,     0,    47,   226,   217,   307,
       0,   207,     0,   213,     1,     3,   138,    70,     0,   220,
       0,   218,   219,     0,   117,   117,     0,   192,   134,   135,
       0,   187,   261,   263,   138,   138,   138,   138,   138,   138,
     138,   138,   138,   138,   138,   138,   138,   138,   138,   138,
     138,   138,   138,     0,     0,     0,   138,   138,   305,   206,
     138,   138,   138,   138,   138,   138,   138,   138,   138,   138,
     138,   138,   138,   138,   138,     0,    53,     0,     0,     0,
     215,     0,   221,   223,     0,    44,     0,     0,     0,    57,
       0,     0,     0,   166,     0,     0,     0,   138,     0,     0,
       0,   138,     0,     0,     0,    61,    77,   138,   138,   138,
       0,     0,     0,    15,     0,     0,   266,     0,     0,     0,
      11,    49,    50,   138,   138,   209,   216,   306,   138,    23,
      21,   138,   139,     0,     0,     0,     0,     0,   184,    28,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   268,
     269,   281,   284,   285,   286,   280,   282,   283,   275,   276,
     273,   277,   274,   244,   245,   288,   287,   205,   241,     0,
     271,   270,   272,   279,   278,   289,   290,   291,   293,   292,
       0,     0,   304,     0,     0,   224,     0,    43,   138,     0,
       0,     0,     0,     0,   196,   196,     0,   138,   138,   138,
       0,   138,   138,   138,     0,     0,     0,     0,   138,    13,
      16,     0,     0,   179,   316,   265,   211,   212,     0,     0,
     208,     0,   210,   215,    22,    20,    25,    24,     0,     0,
       0,     0,     0,    29,     0,    38,   184,    30,    33,    32,
      34,     0,   185,    35,    36,     0,     0,   120,   121,   116,
     118,   184,   112,   184,   113,     0,     0,     0,     0,     0,
       0,     0,     0,   138,   303,   302,   264,     0,     0,     0,
      66,    64,     0,   196,   138,     0,     0,     0,     0,     0,
       0,    76,     0,     0,     0,    39,    41,     0,     0,     0,
     298,   299,     0,    54,   196,    26,     0,     0,     0,   179,
      37,    27,    31,     0,     0,     0,   124,   125,   122,   123,
       0,   188,   192,     0,   114,   129,   184,   127,   128,   126,
       0,   185,   115,   184,     0,   196,   196,   179,     0,     0,
       0,     0,   259,     0,     0,     0,     0,     0,   139,   195,
     308,   197,   138,     0,    40,    42,     0,    78,    79,    80,
       0,   138,     0,     0,    84,    17,     0,     0,   178,   180,
       0,     0,   309,   198,     0,     0,   119,   160,   138,   162,
       0,     0,   138,     0,   110,   133,   131,   132,   130,   134,
       0,     0,   111,   196,     0,     0,   196,     0,     0,     0,
     179,    67,   106,    65,     0,   201,     0,    69,    63,   138,
     138,   138,   138,     0,     0,     0,   138,   138,     0,     0,
      83,    85,     0,     0,     0,   176,   202,   177,   161,     0,
       0,   134,   159,   139,     0,   158,   164,   138,     0,   140,
     144,   138,   142,     0,     0,     0,   310,   199,     0,     0,
     311,   200,     0,     0,   230,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   181,   134,
       0,   138,   156,     0,     0,   141,   165,   163,   143,     0,
     179,   203,   174,   172,   204,   175,   173,    68,    76,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   182,   183,
     138,   146,     0,     0,   138,     0,   153,   138,     0,   150,
     179,   196,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   138,     0,   145,   157,     0,     0,     0,     0,     0,
       0,    62,   148,     0,     0,   154,     0,   151,     0,   171,
     169,   170,   168,   147,     0,   155,   152,   149
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    80,    81,   292,   293,    82,    83,    84,   426,   427,
     612,    86,   118,   119,   185,   140,   120,   141,   286,    88,
      89,   543,   544,    90,   172,    91,   321,   439,   440,   506,
     108,    93,   507,   508,   615,   616,   559,   560,   617,   130,
     509,    94,   484,   548,   549,    95,   109,    97,   465,    98,
      99,   100,   190,   191,   101,   102,   103
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -462
static const yytype_int16 yypact[] =
{
    4626,  -117,  5162,   197,  4908,  4908,  5534,  -113,   -98,   -73,
     162,   -54,   -33,   -20,  -462,  5534,  5534,  5534,  5534,  -462,
     152,  -462,  -462,    53,  -462,   185,    53,    51,    56,  -462,
      68,  -462,  -462,  5534,  5534,  5534,  5534,  5534,  5534,  5534,
    5534,  5534,  5534,  5534,   222,  5534,  4908,  4908,  4908,  5534,
    5534,  5534,  5534,  5534,  5534,  -462,  -462,  -462,  -462,    87,
    -462,  -462,   802,    10,  -462,  -462,    63,  -462,   123,  -462,
     111,  -462,  -462,  5534,   252,  5534,  5534,  5534,  4908,  5036,
    1173,  -462,   255,  -462,  -462,  -462,  -462,  -462,   146,  -462,
    -462,  -462,    -6,   253,  -462,    86,   412,  -462,  -462,  -462,
    -462,  6881,  -462,  -462,  -462,   154,   269,   178,    28,   598,
    8183,   -40,  -462,  5534,   214,   219,    39,  4194,  -462,   315,
    -462,   323,  6914,  5534,  5534,   942,   199,  -462,   215,   802,
     802,  -462,  -462,  -462,  5728,  5824,   262,   262,   266,  -462,
     228,  4767,   239,   261,   232,  -462,  5534,   290,   440,   440,
    8183,  8183,   262,   262,   262,   262,   649,   262,   262,   249,
     268,   262,  -462,  -462,  -462,  8183,  8183,  8183,  8183,  8183,
    8183,  -462,   274,  8183,   802,  5534,  -462,   802,   262,  -462,
    -462,   262,   262,   262,  -462,  4338,  -462,    32,    79,  -462,
     -60,  -462,  5957,   289,  -462,  -462,   361,  -462,   435,  -462,
     278,  -462,  -462,   220,   391,   391,   449,  -462,  -462,   280,
      -8,  -462,  -462,  -462,  5534,  5534,  5534,  5534,  5534,  5534,
    5534,  5534,  5534,  5534,  5534,  5534,  5534,  5534,  5534,  5534,
    5534,  5534,  5534,   157,   317,   276,  5534,  5534,  -462,  5412,
    5534,  5534,  5534,  5534,  5534,  5534,  5534,  5534,  5534,  5534,
    5534,  5534,  5534,  5534,  5534,   802,  -462,   291,   303,   418,
     326,  8183,  -462,  -462,   802,  -462,  4482,   320,   336,  -462,
    5990,  6089,   338,  -462,   802,   350,   351,  5534,   355,   394,
     397,  5534,   362,   363,   402,  -462,  -462,  5534,  5534,  5534,
    6122,   411,   -75,  -462,   802,   802,  -462,   403,  6221,   416,
    -462,  -462,  -462,  5534,  5534,   918,  -462,  -462,  5534,   314,
     382,  5534,   297,   302,   405,   802,   802,   802,   321,  -462,
     256,   307,   316,   421,   802,   802,   802,   495,   434,  8216,
    8216,  8216,  8216,  8216,  8216,  8216,  8216,  8216,  8216,  8337,
    8337,   649,   649,   649,   649,   649,   649,   649,  -462,  -462,
    -462,  -462,  -462,  -462,  -462,   839,   839,  8216,  1029,  7700,
    8413,  8413,  8413,   649,   649,   334,   334,   949,   262,   262,
    7667,  5857,  -462,   427,   441,  -462,   439,  -462,  5534,   802,
    4908,  4908,   942,   450,   595,   595,  5632,  5534,  5534,  5534,
    6254,  5534,  5534,  5534,  7012,  7045,  6353,   462,  5534,  -462,
    -462,   458,   460,    16,  -462,  -462,  8216,  8216,   484,   488,
    -462,   289,  8216,   468,  -462,  -462,  -462,  -462,   802,   469,
     470,   472,     4,  -462,   482,  -462,   476,  -462,  -462,  -462,
    -462,   619,   719,  -462,  -462,   384,   425,  -462,  -462,   512,
    -462,    58,  -462,   122,  -462,   802,   490,   491,   496,   498,
     802,   802,   802,  5534,  -462,  -462,  -462,   500,  6386,   502,
    -462,   605,   506,   595,   196,   515,   515,   517,  6485,  7143,
    7176,  -462,  6518,  6617,  6650,  -462,  -462,   624,   218,  7274,
    -462,  -462,   433,  -462,   595,  -462,   519,   515,   515,   536,
    -462,  -462,  -462,    57,   205,   652,  -462,  -462,  -462,  -462,
     256,   -25,   -21,   569,  -462,  -462,   383,  -462,  -462,  -462,
     505,   769,  -462,   467,   522,   595,   595,   536,   802,   524,
     525,   526,  8304,   530,  4908,  4908,   802,   515,  -462,  -462,
    -462,  -462,  5534,  4908,  -462,  -462,  4767,  -462,  -462,  -462,
     533,  5290,   554,   -12,  -462,  -462,   537,   538,   562,  -462,
     515,   515,  -462,  -462,   515,   368,  -462,   599,   236,  -462,
     -66,   606,    36,   -35,  -462,  -462,  -462,  -462,  -462,   199,
     134,   802,  -462,   595,   515,   515,   595,   559,   515,   515,
     536,  -462,  -462,  -462,   578,  -462,  6749,  -462,  -462,  5534,
    5534,  5534,  5534,   592,   610,   609,  5534,  5534,  7796,  1314,
    -462,  -462,   802,   802,   433,  -462,  -462,  -462,  -462,   698,
     238,   -51,  -462,   633,   634,  -462,  -462,   296,   635,  -462,
    -462,   622,  -462,   802,   591,   515,  -462,  -462,   395,   515,
    -462,  -462,   423,  4908,  -462,  6782,  7829,  7925,  7958,   613,
     614,  1458,  8054,  8087,  1602,  1746,   594,   596,  -462,    48,
     643,  5534,  -462,    -3,    66,  -462,  -462,  -462,  -462,   611,
     536,  -462,  -462,  -462,  -462,  -462,  -462,  -462,  -462,  1890,
    2034,  2178,  2322,  2466,  2610,  2754,  2898,  3042,  -462,  -462,
    5534,  -462,   206,  7307,  5534,   802,  -462,  5534,   802,  -462,
     536,   595,  4767,  3186,  3330,  3474,  3618,  3762,  3906,  4050,
    7405,  5534,   802,  -462,  -462,  7438,   612,  7536,   616,   430,
     446,  -462,  -462,  7569,   617,  -462,   615,  -462,   625,  -462,
    -462,  -462,  -462,  -462,   640,  -462,  -462,  -462
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -462,  -462,   679,  -462,   475,  -462,  -293,  -274,  -462,   343,
       1,  -264,    78,    17,  -115,   752,    18,  -461,  -462,  -462,
    -462,  -462,   243,  -462,   544,  -263,   574,  -462,   298,   354,
       9,    14,  -389,  -337,  -462,  -350,   182,   299,   240,  -177,
    -325,  -462,  -401,  -462,   200,  -145,    19,   -89,  -318,  -261,
    -252,  -110,  -462,   501,    -2,   737,   -74
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -185
static const yytype_int16 yytable[] =
{
     110,    85,   266,   260,   122,   193,   327,   211,   198,    92,
     536,   561,   114,   134,   135,   136,   137,   115,    87,    96,
     211,   316,   121,   291,  -135,   424,   541,   542,   104,   325,
     123,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   257,   161,   425,   124,  -134,   165,   166,   167,
     168,   169,   170,  -135,   429,   430,   618,   433,  -134,  -134,
     173,   609,   305,   162,   163,   164,   434,   466,   503,   399,
     125,   178,   651,   181,   182,   183,   557,   192,   610,   619,
     557,    85,   501,   502,    21,    22,   306,   618,   554,    92,
     503,   131,   199,  -135,   652,   328,   186,   200,    87,    96,
      29,  -134,   126,    31,    32,   210,   127,   128,  -135,  -135,
     622,   261,   132,  -135,  -135,   558,   576,   566,   259,   562,
     684,   270,   271,   173,   566,   133,   199,   173,   173,   203,
    -134,  -134,   600,   424,   611,   186,  -134,  -135,  -135,   112,
     685,   482,   686,  -135,   290,   527,   501,   502,    21,    22,
     451,   139,   425,   174,   503,   126,   184,   303,   285,   127,
     314,   483,   429,   430,    29,   433,   550,    31,    32,   567,
      74,   680,   173,   298,   434,   173,   567,  -135,  -135,   632,
     620,   568,   264,  -135,   138,  -134,  -134,   -19,   568,   687,
    -134,  -134,  -135,   681,   204,   184,   145,   574,   575,   146,
     205,   413,   504,   302,   304,   312,   175,   692,   147,   688,
     313,   689,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   411,   126,    68,   355,   356,   127,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   173,   177,   625,   541,   542,   628,   691,
     126,   609,   173,   301,   127,   128,   512,   656,   503,   348,
     349,   656,   173,   350,   351,   386,  -135,  -135,   610,   390,
     435,   436,  -135,   142,   302,   394,   395,   396,   143,   709,
     196,   197,   173,   173,   208,   111,   510,   129,   510,   112,
     112,   406,   407,   126,   -19,   129,   412,   127,   323,   261,
     212,   213,   262,   173,   173,   173,   316,   325,   263,   428,
     159,   609,   173,   173,   173,   160,   267,   431,   503,   701,
      74,    74,   268,   571,   611,   422,   649,   432,   610,   112,
     113,   112,   273,   211,   301,    19,    20,    21,    22,   702,
     179,   703,   201,    25,   437,   180,   -18,   202,   274,   438,
     318,   510,   287,    29,   279,   319,    31,    32,   510,   280,
      74,   281,    74,   710,   353,   289,   458,   173,   451,   354,
     173,   238,   212,   213,   288,   468,   469,   470,   291,   472,
     473,   474,   294,   623,   611,   414,   479,   460,   461,   112,
     415,   416,   252,   253,   254,   255,   417,   501,   502,    21,
      22,   295,  -134,  -134,   308,   503,   173,  -134,  -134,   208,
     296,   317,   211,   326,   112,    29,   206,   428,    31,    32,
      74,   320,   374,   352,   315,   431,    19,   207,    21,    22,
     655,   495,   505,   173,   505,   432,   324,   441,   173,   173,
     173,   522,   442,   238,    29,    74,   443,    31,    32,   309,
     511,   444,   511,   378,   310,   423,   126,   249,   250,   251,
     127,   449,   375,   528,   252,   253,   254,   255,   529,   379,
    -135,  -135,   496,   382,   645,  -135,  -135,   497,  -185,  -185,
     422,   501,   502,    21,    22,    74,   384,   385,   387,   503,
      19,    20,    21,    22,   311,   391,   392,   565,    25,    29,
     208,   -18,    31,    32,   565,   209,   173,   388,    29,   570,
     389,    31,    32,   498,   173,   511,   674,   564,   499,   677,
     586,   546,   511,   126,   398,   117,   547,   127,   314,   598,
     662,   582,   583,   530,   531,   393,    74,   126,   418,   403,
     587,   127,   323,   588,   693,   694,   695,   696,   697,   238,
     698,   699,   405,   117,   445,   552,   553,   613,   665,   173,
     117,   613,   614,   456,   208,   719,   614,   452,   315,   112,
     252,   253,   254,   255,   450,   457,   117,   635,   636,   637,
     638,   721,   324,   126,   642,   643,   463,   127,   449,   464,
     173,   173,   478,   569,   480,   585,   481,   127,   112,   303,
      74,   572,   258,   304,   485,   487,   488,   186,   489,   650,
     491,   173,    19,   207,    21,    22,   613,   490,   605,   606,
     613,   614,   607,   493,   500,   614,   515,   516,   450,    74,
      29,   518,   517,    31,    32,   483,   525,   609,   524,   683,
     667,   526,   626,   627,   503,   117,   630,   631,   540,   186,
     532,   482,   186,   302,   610,   551,   555,   142,   573,   272,
     578,   579,   580,   275,   276,   581,   589,   184,   700,   599,
     602,   603,   705,   173,   604,   707,   173,   186,   186,   186,
     186,   186,   302,   186,   186,   302,   208,   212,   213,   713,
     173,   112,   608,   661,   279,   629,   663,   664,   639,   711,
     666,   302,   302,   302,   302,   302,   302,   302,   297,   184,
     611,   299,   184,   301,   633,   112,   640,   235,   236,   237,
     561,   653,    74,   494,   641,   654,   557,   660,   672,   673,
     678,   682,   679,    19,   207,    21,    22,   184,   184,   184,
     184,   184,   301,   184,   184,   301,    74,   690,   716,   195,
     725,    29,   718,   724,    31,    32,   658,   400,   238,   492,
     726,   301,   301,   301,   301,   301,   301,   301,   144,   322,
     247,   248,   249,   250,   251,   727,   601,   720,   722,   252,
     253,   254,   255,    19,   207,    21,    22,   513,   556,   373,
     657,   563,   621,   171,   648,   176,   410,     3,   376,     0,
       0,    29,     0,     0,    31,    32,   105,   208,   383,     0,
      14,    15,   112,     0,    17,    18,    19,   106,    21,    22,
       0,     0,     0,     0,     0,     0,     0,   -18,   401,   402,
       0,     0,     0,     0,    29,     0,     0,    31,    32,     0,
      33,    34,     0,    74,     0,     0,     0,     0,     0,   419,
     420,   421,    35,    36,    37,    38,    39,    40,   446,   447,
     448,     0,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,    42,    43,    44,    45,   212,   213,     0,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,  -138,    60,    61,    62,   107,  -138,    64,    65,    66,
       0,    67,    68,    69,     0,     0,     0,    70,     0,     0,
      71,     0,     0,   459,     0,     0,   462,     0,     0,     0,
       0,     0,     0,     0,    73,     0,    74,     0,     0,    75,
      76,    77,     0,   171,     0,    79,     0,     3,  -107,     0,
       0,     0,     0,     0,     0,     0,   105,     0,   238,     0,
      14,    15,   486,     0,    17,    18,    19,   106,    21,    22,
     247,   248,   249,   250,   251,     0,     0,   -18,     0,   252,
     253,   254,   255,     0,    29,     0,     0,    31,    32,   514,
      33,    34,     0,     0,   519,   520,   521,   212,   213,     0,
       0,     0,    35,    36,    37,    38,    39,    40,     0,     0,
       0,     0,     0,    56,    57,    58,   408,     0,     0,    41,
       0,   409,     0,    42,    43,    44,    45,    67,    68,     0,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,  -138,    60,    61,    62,   107,  -138,    64,    65,    66,
       0,    67,    68,    69,     0,     0,     0,    70,     0,     0,
      71,     0,   577,     0,     0,     0,     0,     0,   238,     0,
     584,     0,     0,     0,    73,     0,    74,   212,   213,    75,
      76,    77,     0,   250,   251,    79,     0,  -107,     0,   252,
     253,   254,   255,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,     0,   235,   236,   237,
       0,     0,     0,     0,     0,   624,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   646,   647,   238,     0,
       0,     0,   240,   241,     0,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,     0,     0,   659,     0,   252,
     253,   254,   255,   194,     1,     0,     2,     0,     3,     4,
       5,     6,     0,     0,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,     0,    17,    18,    19,    20,    21,
      22,    23,     0,     0,    24,    25,    26,     0,   -18,    27,
      28,     0,     0,     0,     0,    29,  -184,    30,    31,    32,
       0,    33,    34,     0,     0,     0,     0,     0,     0,   706,
       0,     0,   708,    35,    36,    37,    38,    39,    40,     0,
       0,     0,     0,     0,     0,     0,   714,     0,     0,     0,
      41,     0,     0,     0,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,  -138,    60,    61,    62,    63,  -138,    64,    65,
      66,  -184,    67,    68,    69,     0,     0,  -184,    70,     0,
       0,    71,     0,    72,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    73,     0,    74,     0,     0,
      75,    76,    77,    78,     0,     1,    79,     2,     0,     3,
       4,     5,     6,     0,     0,     7,     8,     9,   105,    11,
      12,    13,    14,    15,    16,     0,    17,    18,    19,   106,
      21,    22,    23,     0,     0,    24,     0,    26,     0,   -18,
      27,    28,  -105,  -105,     0,     0,    29,     0,     0,    31,
      32,     0,    33,    34,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,    36,    37,    38,    39,    40,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    41,     0,     0,     0,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,  -138,    60,    61,    62,   116,  -138,    64,
      65,    66,     0,    67,    68,    69,     0,     0,     0,    70,
       0,     0,    71,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    73,     0,    74,     0,
       0,    75,    76,    77,   117,     0,     0,    79,  -105,     1,
       0,     2,     0,     3,     4,     5,     6,     0,     0,     7,
       8,     9,   105,    11,    12,    13,    14,    15,    16,     0,
      17,    18,    19,   106,    21,    22,    23,     0,     0,    24,
       0,    26,     0,   -18,    27,    28,  -101,  -101,     0,     0,
      29,     0,     0,    31,    32,     0,    33,    34,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    41,     0,     0,     0,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,  -138,    60,    61,
      62,   116,  -138,    64,    65,    66,     0,    67,    68,    69,
       0,     0,     0,    70,     0,     0,    71,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      73,     0,    74,     0,     0,    75,    76,    77,   117,     0,
       0,    79,  -101,     1,     0,     2,     0,     3,     4,     5,
       6,     0,     0,     7,     8,     9,   105,    11,    12,    13,
      14,    15,    16,     0,    17,    18,    19,   106,    21,    22,
      23,     0,     0,    24,     0,    26,     0,   -18,    27,    28,
    -103,  -103,     0,     0,    29,     0,     0,    31,    32,     0,
      33,    34,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,    36,    37,    38,    39,    40,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,  -138,    60,    61,    62,   116,  -138,    64,    65,    66,
       0,    67,    68,    69,     0,     0,     0,    70,     0,     0,
      71,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    73,     0,    74,     0,     0,    75,
      76,    77,   117,     0,     0,    79,  -103,     1,     0,     2,
       0,     3,     4,     5,     6,     0,     0,     7,     8,     9,
     105,    11,    12,    13,    14,    15,    16,     0,    17,    18,
      19,   106,    21,    22,    23,     0,     0,    24,     0,    26,
       0,   -18,    27,    28,  -104,  -104,     0,     0,    29,     0,
       0,    31,    32,     0,    33,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    41,     0,     0,     0,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,  -138,    60,    61,    62,   116,
    -138,    64,    65,    66,     0,    67,    68,    69,     0,     0,
       0,    70,     0,     0,    71,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    73,     0,
      74,     0,     0,    75,    76,    77,   117,     0,     0,    79,
    -104,     1,     0,     2,     0,     3,     4,     5,     6,     0,
       0,     7,     8,     9,   105,    11,    12,    13,    14,    15,
      16,     0,    17,    18,    19,   106,    21,    22,    23,     0,
       0,    24,     0,    26,     0,   -18,    27,    28,   -91,   -91,
       0,     0,    29,     0,     0,    31,    32,     0,    33,    34,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      35,    36,    37,    38,    39,    40,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    41,     0,     0,
       0,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,  -138,
      60,    61,    62,   116,  -138,    64,    65,    66,     0,    67,
      68,    69,     0,     0,     0,    70,     0,     0,    71,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    73,     0,    74,     0,     0,    75,    76,    77,
     117,     0,     0,    79,   -91,     1,     0,     2,     0,     3,
       4,     5,     6,     0,     0,     7,     8,     9,   105,    11,
      12,    13,    14,    15,    16,     0,    17,    18,    19,   106,
      21,    22,    23,     0,     0,    24,     0,    26,     0,   -18,
      27,    28,   -89,   -89,     0,     0,    29,     0,     0,    31,
      32,     0,    33,    34,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,    36,    37,    38,    39,    40,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    41,     0,     0,     0,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,  -138,    60,    61,    62,   116,  -138,    64,
      65,    66,     0,    67,    68,    69,     0,     0,     0,    70,
       0,     0,    71,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    73,     0,    74,     0,
       0,    75,    76,    77,   117,     0,     0,    79,   -89,     1,
       0,     2,     0,     3,     4,     5,     6,     0,     0,     7,
       8,     9,   105,    11,    12,    13,    14,    15,    16,     0,
      17,    18,    19,   106,    21,    22,    23,     0,     0,    24,
       0,    26,     0,   -18,    27,    28,   -87,   -87,     0,     0,
      29,     0,     0,    31,    32,     0,    33,    34,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    41,     0,     0,     0,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,  -138,    60,    61,
      62,   116,  -138,    64,    65,    66,     0,    67,    68,    69,
       0,     0,     0,    70,     0,     0,    71,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      73,     0,    74,     0,     0,    75,    76,    77,   117,     0,
       0,    79,   -87,     1,     0,     2,     0,     3,     4,     5,
       6,     0,     0,     7,     8,     9,   105,    11,    12,    13,
      14,    15,    16,     0,    17,    18,    19,   106,    21,    22,
      23,     0,     0,    24,     0,    26,     0,   -18,    27,    28,
     -97,   -97,     0,     0,    29,     0,     0,    31,    32,     0,
      33,    34,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,    36,    37,    38,    39,    40,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,  -138,    60,    61,    62,   116,  -138,    64,    65,    66,
       0,    67,    68,    69,     0,     0,     0,    70,     0,     0,
      71,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    73,     0,    74,     0,     0,    75,
      76,    77,   117,     0,     0,    79,   -97,     1,     0,     2,
       0,     3,     4,     5,     6,     0,     0,     7,     8,     9,
     105,    11,    12,    13,    14,    15,    16,     0,    17,    18,
      19,   106,    21,    22,    23,     0,     0,    24,     0,    26,
       0,   -18,    27,    28,   -99,   -99,     0,     0,    29,     0,
       0,    31,    32,     0,    33,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    41,     0,     0,     0,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,  -138,    60,    61,    62,   116,
    -138,    64,    65,    66,     0,    67,    68,    69,     0,     0,
       0,    70,     0,     0,    71,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    73,     0,
      74,     0,     0,    75,    76,    77,   117,     0,     0,    79,
     -99,     1,     0,     2,     0,     3,     4,     5,     6,     0,
       0,     7,     8,     9,   105,    11,    12,    13,    14,    15,
      16,     0,    17,    18,    19,   106,    21,    22,    23,     0,
       0,    24,     0,    26,     0,   -18,    27,    28,  -100,  -100,
       0,     0,    29,     0,     0,    31,    32,     0,    33,    34,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      35,    36,    37,    38,    39,    40,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    41,     0,     0,
       0,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,  -138,
      60,    61,    62,   116,  -138,    64,    65,    66,     0,    67,
      68,    69,     0,     0,     0,    70,     0,     0,    71,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    73,     0,    74,     0,     0,    75,    76,    77,
     117,     0,     0,    79,  -100,     1,     0,     2,     0,     3,
       4,     5,     6,     0,     0,     7,     8,     9,   105,    11,
      12,    13,    14,    15,    16,     0,    17,    18,    19,   106,
      21,    22,    23,     0,     0,    24,     0,    26,     0,   -18,
      27,    28,   -93,   -93,     0,     0,    29,     0,     0,    31,
      32,     0,    33,    34,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,    36,    37,    38,    39,    40,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    41,     0,     0,     0,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,  -138,    60,    61,    62,   116,  -138,    64,
      65,    66,     0,    67,    68,    69,     0,     0,     0,    70,
       0,     0,    71,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    73,     0,    74,     0,
       0,    75,    76,    77,   117,     0,     0,    79,   -93,     1,
       0,     2,     0,     3,     4,     5,     6,     0,     0,     7,
       8,     9,   105,    11,    12,    13,    14,    15,    16,     0,
      17,    18,    19,   106,    21,    22,    23,     0,     0,    24,
       0,    26,     0,   -18,    27,    28,   -95,   -95,     0,     0,
      29,     0,     0,    31,    32,     0,    33,    34,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    41,     0,     0,     0,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,  -138,    60,    61,
      62,   116,  -138,    64,    65,    66,     0,    67,    68,    69,
       0,     0,     0,    70,     0,     0,    71,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      73,     0,    74,     0,     0,    75,    76,    77,   117,     0,
       0,    79,   -95,     1,     0,     2,     0,     3,     4,     5,
       6,     0,     0,     7,     8,     9,   105,    11,    12,    13,
      14,    15,    16,     0,    17,    18,    19,   106,    21,    22,
      23,     0,     0,    24,     0,    26,     0,   -18,    27,    28,
    -102,  -102,     0,     0,    29,     0,     0,    31,    32,     0,
      33,    34,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,    36,    37,    38,    39,    40,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,  -138,    60,    61,    62,   116,  -138,    64,    65,    66,
       0,    67,    68,    69,     0,     0,     0,    70,     0,     0,
      71,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    73,     0,    74,     0,     0,    75,
      76,    77,   117,     0,     0,    79,  -102,     1,     0,     2,
       0,     3,     4,     5,     6,     0,     0,     7,     8,     9,
     105,    11,    12,    13,    14,    15,    16,     0,    17,    18,
      19,   106,    21,    22,    23,     0,     0,    24,     0,    26,
       0,   -18,    27,    28,   -90,   -90,     0,     0,    29,     0,
       0,    31,    32,     0,    33,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    41,     0,     0,     0,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,  -138,    60,    61,    62,   116,
    -138,    64,    65,    66,     0,    67,    68,    69,     0,     0,
       0,    70,     0,     0,    71,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    73,     0,
      74,     0,     0,    75,    76,    77,   117,     0,     0,    79,
     -90,     1,     0,     2,     0,     3,     4,     5,     6,     0,
       0,     7,     8,     9,   105,    11,    12,    13,    14,    15,
      16,     0,    17,    18,    19,   106,    21,    22,    23,     0,
       0,    24,     0,    26,     0,   -18,    27,    28,   -88,   -88,
       0,     0,    29,     0,     0,    31,    32,     0,    33,    34,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      35,    36,    37,    38,    39,    40,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    41,     0,     0,
       0,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,  -138,
      60,    61,    62,   116,  -138,    64,    65,    66,     0,    67,
      68,    69,     0,     0,     0,    70,     0,     0,    71,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    73,     0,    74,     0,     0,    75,    76,    77,
     117,     0,     0,    79,   -88,     1,     0,     2,     0,     3,
       4,     5,     6,     0,     0,     7,     8,     9,   105,    11,
      12,    13,    14,    15,    16,     0,    17,    18,    19,   106,
      21,    22,    23,     0,     0,    24,     0,    26,     0,   -18,
      27,    28,   -86,   -86,     0,     0,    29,     0,     0,    31,
      32,     0,    33,    34,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,    36,    37,    38,    39,    40,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    41,     0,     0,     0,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,  -138,    60,    61,    62,   116,  -138,    64,
      65,    66,     0,    67,    68,    69,     0,     0,     0,    70,
       0,     0,    71,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    73,     0,    74,     0,
       0,    75,    76,    77,   117,     0,     0,    79,   -86,     1,
       0,     2,     0,     3,     4,     5,     6,     0,     0,     7,
       8,     9,   105,    11,    12,    13,    14,    15,    16,     0,
      17,    18,    19,   106,    21,    22,    23,     0,     0,    24,
       0,    26,     0,   -18,    27,    28,   -96,   -96,     0,     0,
      29,     0,     0,    31,    32,     0,    33,    34,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    41,     0,     0,     0,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,  -138,    60,    61,
      62,   116,  -138,    64,    65,    66,     0,    67,    68,    69,
       0,     0,     0,    70,     0,     0,    71,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      73,     0,    74,     0,     0,    75,    76,    77,   117,     0,
       0,    79,   -96,     1,     0,     2,     0,     3,     4,     5,
       6,     0,     0,     7,     8,     9,   105,    11,    12,    13,
      14,    15,    16,     0,    17,    18,    19,   106,    21,    22,
      23,     0,     0,    24,     0,    26,     0,   -18,    27,    28,
     -98,   -98,     0,     0,    29,     0,     0,    31,    32,     0,
      33,    34,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,    36,    37,    38,    39,    40,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,  -138,    60,    61,    62,   116,  -138,    64,    65,    66,
       0,    67,    68,    69,     0,     0,     0,    70,     0,     0,
      71,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    73,     0,    74,     0,     0,    75,
      76,    77,   117,     0,     0,    79,   -98,     1,     0,     2,
       0,     3,     4,     5,     6,     0,     0,     7,     8,     9,
     105,    11,    12,    13,    14,    15,    16,     0,    17,    18,
      19,   106,    21,    22,    23,     0,     0,    24,     0,    26,
       0,   -18,    27,    28,   -92,   -92,     0,     0,    29,     0,
       0,    31,    32,     0,    33,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    41,     0,     0,     0,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,  -138,    60,    61,    62,   116,
    -138,    64,    65,    66,     0,    67,    68,    69,     0,     0,
       0,    70,     0,     0,    71,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    73,     0,
      74,     0,     0,    75,    76,    77,   117,     0,     0,    79,
     -92,     1,     0,     2,     0,     3,     4,     5,     6,     0,
       0,     7,     8,     9,   105,    11,    12,    13,    14,    15,
      16,     0,    17,    18,    19,   106,    21,    22,    23,     0,
       0,    24,     0,    26,     0,   -18,    27,    28,   -94,   -94,
       0,     0,    29,     0,     0,    31,    32,     0,    33,    34,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      35,    36,    37,    38,    39,    40,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    41,     0,     0,
       0,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,  -138,
      60,    61,    62,   116,  -138,    64,    65,    66,     0,    67,
      68,    69,     0,     0,     0,    70,     0,     0,    71,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    73,     0,    74,     0,     0,    75,    76,    77,
     117,     0,     0,    79,   -94,     1,     0,     2,     0,     3,
       4,     5,     6,     0,     0,     7,     8,     9,   105,    11,
      12,    13,    14,    15,    16,     0,    17,    18,    19,   106,
      21,    22,    23,     0,     0,    24,     0,    26,     0,   -18,
      27,    28,     0,     0,     0,     0,    29,     0,     0,    31,
      32,     0,    33,    34,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,    36,    37,    38,    39,    40,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    41,     0,     0,     0,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,  -138,    60,    61,    62,   116,  -138,    64,
      65,    66,     0,    67,    68,    69,     0,     0,     0,    70,
       0,     0,    71,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    73,     0,    74,     0,
       0,    75,    76,    77,   117,     0,     0,    79,   265,     1,
       0,     2,     0,     3,     4,     5,     6,     0,     0,     7,
       8,     9,   105,    11,    12,    13,    14,    15,    16,     0,
      17,    18,    19,   106,    21,    22,    23,     0,     0,    24,
       0,    26,     0,   -18,    27,    28,     0,     0,     0,     0,
      29,     0,     0,    31,    32,     0,    33,    34,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    41,     0,     0,     0,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,  -138,    60,    61,
      62,   116,  -138,    64,    65,    66,     0,    67,    68,    69,
       0,     0,     0,    70,     0,     0,    71,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      73,     0,    74,     0,     0,    75,    76,    77,   117,     0,
       0,    79,   300,     1,     0,     2,     0,     3,     4,     5,
       6,     0,     0,     7,     8,     9,   105,    11,    12,    13,
      14,    15,    16,     0,    17,    18,    19,   106,    21,    22,
      23,     0,     0,    24,     0,    26,     0,   -18,    27,    28,
       0,     0,     0,     0,    29,     0,     0,    31,    32,     0,
      33,    34,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,    36,    37,    38,    39,    40,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,  -138,    60,    61,    62,   116,  -138,    64,    65,    66,
       0,    67,    68,    69,     0,     0,     0,    70,     0,     0,
      71,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    73,     0,    74,     0,     0,    75,
      76,    77,   117,     0,     0,    79,   377,     1,     0,     2,
       0,     3,     4,     5,     6,     0,     0,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,     0,    17,    18,
      19,    20,    21,    22,    23,     0,     0,    24,    25,    26,
       0,   -18,    27,    28,     0,     0,     0,     0,    29,  -184,
      30,    31,    32,     0,    33,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    41,     0,     0,     0,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,  -138,    60,    61,    62,    63,
    -138,    64,    65,    66,  -184,    67,    68,    69,     0,     0,
    -184,    70,     0,     0,    71,     0,    72,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    73,     0,
      74,     0,     0,    75,    76,    77,    78,     0,     1,    79,
       2,     0,     3,     4,     5,     6,     0,   282,     7,     8,
       9,   105,    11,    12,    13,    14,    15,    16,     0,    17,
      18,    19,   106,    21,    22,    23,   283,   284,    24,     0,
      26,     0,   -18,    27,    28,     0,     0,     0,     0,    29,
       0,     0,    31,    32,     0,    33,    34,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    35,    36,    37,
      38,    39,    40,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    41,     0,     0,     0,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,  -138,    60,    61,    62,
     116,  -138,    64,    65,    66,     0,    67,    68,    69,     0,
       0,     0,    70,     0,     0,    71,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    73,
       0,    74,     0,     0,    75,    76,    77,   117,     0,     1,
      79,     2,     0,     3,     4,     5,     6,     0,     0,     7,
       8,     9,   105,    11,    12,    13,    14,    15,    16,     0,
      17,    18,    19,   106,    21,    22,    23,     0,     0,    24,
       0,    26,     0,   -18,    27,    28,     0,     0,     0,     0,
      29,     0,     0,    31,    32,     0,    33,    34,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    35,    36,
      37,    38,    39,    40,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    41,     0,     0,     0,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,  -138,    60,    61,
      62,   116,  -138,    64,    65,    66,     0,    67,    68,    69,
       0,     0,     0,    70,     0,     0,    71,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      73,     3,    74,     0,     0,    75,    76,    77,   117,     0,
     105,    79,     0,     0,    14,    15,     0,     0,    17,    18,
      19,   106,    21,    22,     0,     0,     0,     0,     0,     0,
       0,   -18,     0,     0,     0,     0,     0,     0,    29,     0,
       0,    31,    32,     0,    33,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    41,     0,     0,     0,    42,    43,    44,
      45,     0,     0,     0,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,   187,     0,    60,    61,    62,   188,
       0,    64,    65,    66,     0,    67,    68,    69,     0,     0,
       0,    70,     0,     0,    71,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     3,    73,     0,
      74,     0,     0,    75,    76,    77,   105,     0,     0,    79,
      14,    15,   189,     0,    17,    18,    19,   106,    21,    22,
       0,     0,     0,     0,     0,     0,     0,   -18,     0,     0,
       0,     0,     0,     0,    29,     0,     0,    31,    32,     0,
      33,    34,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,    36,    37,    38,    39,    40,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,    42,    43,    44,    45,     0,     0,     0,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,     0,    60,    61,    62,   107,     0,    64,    65,    66,
       0,    67,    68,    69,     0,     0,     0,    70,     0,     0,
      71,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    73,     3,    74,     0,     0,    75,
      76,    77,     0,     0,   105,    79,     0,   -81,    14,    15,
       0,     0,    17,    18,    19,   106,    21,    22,     0,     0,
       0,     0,     0,     0,     0,   -18,     0,     0,     0,     0,
       0,     0,    29,     0,     0,    31,    32,     0,    33,    34,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      35,    36,    37,    38,    39,    40,     0,     0,   590,     0,
     591,   592,     0,     0,     0,   593,   594,    41,     0,     0,
       0,    42,    43,    44,    45,     0,     0,     0,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,     0,
      60,    61,    62,   107,     0,    64,    65,    66,     0,    67,
      68,    69,     0,     0,     0,    70,   595,     0,    71,     0,
       0,     0,     0,     0,     0,     0,     0,     3,     0,   596,
     597,     0,    73,     0,    74,     0,   105,    75,    76,    77,
      14,    15,     0,    79,    17,    18,    19,   106,    21,    22,
       0,     0,     0,     0,     0,     0,     0,   -18,     0,     0,
       0,     0,     0,     0,    29,     0,     0,    31,    32,     0,
      33,    34,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    35,    36,    37,    38,    39,    40,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    41,
       0,     0,     0,    42,    43,    44,    45,     0,     0,     0,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,  -138,    60,    61,    62,   107,  -138,    64,    65,    66,
       0,    67,    68,    69,     0,     0,     0,    70,     0,     0,
      71,     0,     0,     0,     0,     0,     0,     0,     0,     3,
       0,     0,     0,     0,    73,     0,    74,     0,   105,    75,
      76,    77,    14,    15,     0,    79,    17,    18,    19,   106,
      21,    22,     0,     0,     0,     0,     0,     0,     0,   -18,
       0,     0,     0,     0,     0,     0,    29,     0,     0,    31,
      32,     0,    33,    34,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,    36,    37,    38,    39,    40,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    41,     0,     0,     0,    42,    43,    44,    45,     0,
       0,     0,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,     0,    60,    61,    62,   107,     0,    64,
      65,    66,   467,    67,    68,    69,     0,     0,     0,    70,
       0,     0,    71,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    73,     0,    74,     0,
       0,    75,    76,    77,     0,     0,     0,    79,     0,     0,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,     0,
     235,   236,   237,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   277,
       0,   238,     0,     0,   239,   240,   241,     0,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,     0,     0,
       0,     0,   252,   253,   254,   255,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,     0,   235,   236,   237,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   278,     0,   238,     0,     0,
     239,   240,   241,     0,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,     0,     0,     0,     0,   252,   253,
     254,   255,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,     0,   235,   236,   237,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,     0,   235,   236,   237,     0,     0,
       0,     0,     0,   238,     0,     0,   239,   240,   241,     0,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
       0,     0,     0,     0,   252,   253,   254,   255,     0,     0,
       0,     0,     0,     0,     0,     0,   238,     0,     0,   239,
     240,   241,     0,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,     0,     0,     0,     0,   252,   253,   254,
     255,     0,     0,     0,   455,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,     0,   235,   236,   237,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
       0,     0,     0,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,     0,   235,   236,
     237,     0,     0,     0,     0,     0,   238,     0,     0,   239,
     240,   241,     0,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,     0,     0,     0,     0,   252,   253,   254,
     255,     0,     0,   307,     0,     0,     0,     0,     0,   238,
       0,     0,   239,   240,   241,     0,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,     0,     0,     0,     0,
     252,   253,   254,   255,     0,     0,   380,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,     0,   235,   236,   237,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,     0,
     235,   236,   237,     0,     0,     0,     0,     0,   238,     0,
       0,   239,   240,   241,     0,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,     0,     0,     0,     0,   252,
     253,   254,   255,     0,     0,   381,     0,     0,     0,     0,
       0,   238,     0,     0,   239,   240,   241,     0,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,     0,     0,
       0,     0,   252,   253,   254,   255,     0,     0,   397,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,     0,   235,
     236,   237,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,     0,   235,   236,   237,     0,     0,     0,     0,     0,
     238,     0,     0,   239,   240,   241,     0,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,     0,     0,     0,
       0,   252,   253,   254,   255,     0,     0,   404,     0,     0,
       0,     0,     0,   238,     0,     0,   239,   240,   241,     0,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
       0,     0,     0,     0,   252,   253,   254,   255,     0,     0,
     471,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
       0,   235,   236,   237,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,     0,   235,   236,   237,     0,     0,     0,
       0,     0,   238,     0,     0,   239,   240,   241,     0,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,     0,
       0,     0,     0,   252,   253,   254,   255,     0,     0,   477,
       0,     0,     0,     0,     0,   238,     0,     0,   239,   240,
     241,     0,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,     0,     0,     0,     0,   252,   253,   254,   255,
       0,     0,   523,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,     0,   235,   236,   237,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,     0,   235,   236,   237,     0,
       0,     0,     0,     0,   238,     0,     0,   239,   240,   241,
       0,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,     0,     0,     0,     0,   252,   253,   254,   255,     0,
       0,   533,     0,     0,     0,     0,     0,   238,     0,     0,
     239,   240,   241,     0,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,     0,     0,     0,     0,   252,   253,
     254,   255,     0,     0,   537,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,     0,   235,   236,   237,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
       0,     0,     0,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,     0,   235,   236,
     237,     0,     0,     0,     0,     0,   238,     0,     0,   239,
     240,   241,     0,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,     0,     0,     0,     0,   252,   253,   254,
     255,     0,     0,   538,     0,     0,     0,     0,     0,   238,
       0,     0,   239,   240,   241,     0,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,     0,     0,     0,     0,
     252,   253,   254,   255,     0,     0,   539,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,     0,   235,   236,   237,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,     0,
     235,   236,   237,     0,     0,     0,     0,     0,   238,     0,
       0,   239,   240,   241,     0,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,     0,     0,     0,     0,   252,
     253,   254,   255,     0,     0,   634,     0,     0,     0,     0,
       0,   238,     0,     0,   239,   240,   241,     0,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,     0,     0,
       0,     0,   252,   253,   254,   255,     0,     0,   668,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,     0,     0,     0,     0,     0,     0,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,     0,   235,
     236,   237,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,     0,   235,   236,   237,     0,     0,     0,     0,     0,
     238,     0,     0,   239,   240,   241,     0,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,     0,     0,     0,
       0,   252,   253,   254,   255,     0,   256,     0,     0,     0,
       0,     0,     0,   238,     0,     0,   239,   240,   241,     0,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
       0,     0,     0,     0,   252,   253,   254,   255,     0,   269,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,     0,     0,     0,     0,     0,     0,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,     0,
     235,   236,   237,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,     0,   235,   236,   237,     0,     0,     0,     0,
       0,   238,     0,     0,   239,   240,   241,     0,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,     0,     0,
       0,     0,   252,   253,   254,   255,     0,   475,     0,     0,
       0,     0,     0,     0,   238,     0,     0,   239,   240,   241,
       0,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,     0,     0,     0,     0,   252,   253,   254,   255,     0,
     476,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
       0,   235,   236,   237,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,     0,   235,   236,   237,     0,     0,     0,
       0,     0,   238,     0,     0,   239,   240,   241,     0,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,     0,
       0,     0,     0,   252,   253,   254,   255,     0,   534,     0,
       0,     0,     0,     0,     0,   238,     0,     0,   239,   240,
     241,     0,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,     0,     0,     0,     0,   252,   253,   254,   255,
       0,   535,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,     0,   235,   236,   237,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,     0,   235,   236,   237,     0,     0,
       0,     0,     0,   238,     0,     0,   239,   240,   241,     0,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
       0,     0,     0,     0,   252,   253,   254,   255,     0,   545,
       0,     0,     0,     0,     0,     0,   238,     0,     0,   239,
     240,   241,     0,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,     0,     0,     0,     0,   252,   253,   254,
     255,     0,   704,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,     0,   235,   236,   237,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,     0,   235,   236,   237,     0,
       0,     0,     0,     0,   238,     0,     0,   239,   240,   241,
       0,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,     0,     0,     0,     0,   252,   253,   254,   255,     0,
     712,     0,     0,     0,     0,     0,     0,   238,     0,     0,
     239,   240,   241,     0,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,     0,     0,     0,     0,   252,   253,
     254,   255,     0,   715,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,     0,   235,   236,   237,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,     0,   235,   236,   237,
       0,     0,     0,     0,     0,   238,     0,     0,   239,   240,
     241,     0,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,     0,     0,     0,     0,   252,   253,   254,   255,
       0,   717,     0,     0,     0,     0,     0,     0,   238,     0,
       0,   239,   240,   241,     0,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,     0,     0,     0,     0,   252,
     253,   254,   255,     0,   723,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,     0,   235,   236,   237,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
       0,     0,     0,     0,     0,     0,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,     0,   235,   236,
     237,     0,     0,     0,     0,     0,   238,     0,     0,   239,
     240,   241,     0,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,     0,     0,     0,     0,   252,   253,   254,
     255,   454,     0,     0,     0,     0,     0,     0,     0,   238,
       0,     0,   239,   240,   241,   453,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,     0,     0,     0,     0,
     252,   253,   254,   255,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,     0,   235,   236,   237,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,     0,
       0,     0,     0,     0,     0,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,     0,   235,   236,   237,
       0,     0,     0,     0,     0,   238,     0,     0,   239,   240,
     241,   644,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,     0,     0,     0,     0,   252,   253,   254,   255,
       0,     0,     0,     0,     0,     0,     0,     0,   238,     0,
       0,   239,   240,   241,   669,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,     0,     0,     0,     0,   252,
     253,   254,   255,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,     0,     0,     0,     0,     0,
       0,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,     0,   235,   236,   237,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,     0,     0,
       0,     0,     0,     0,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,     0,   235,   236,   237,     0,
       0,     0,     0,     0,   238,     0,     0,   239,   240,   241,
     670,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,     0,     0,     0,     0,   252,   253,   254,   255,     0,
       0,     0,     0,     0,     0,     0,     0,   238,     0,     0,
     239,   240,   241,   671,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,     0,     0,     0,     0,   252,   253,
     254,   255,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,     0,   235,   236,   237,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,     0,     0,     0,
       0,     0,     0,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,     0,   235,   236,   237,     0,     0,
       0,     0,     0,   238,     0,     0,   239,   240,   241,   675,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
       0,     0,     0,     0,   252,   253,   254,   255,     0,     0,
       0,     0,     0,     0,     0,     0,   238,     0,     0,   239,
     240,   241,   676,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,     0,     0,     0,     0,   252,   253,   254,
     255,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,     0,     0,     0,     0,     0,     0,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
       0,   235,   236,   237,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,     0,     0,     0,     0,
       0,     0,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,     0,   235,   236,   237,     0,     0,     0,
       0,     0,   238,     0,     0,   239,   240,   241,     0,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,     0,
       0,     0,     0,   252,   253,   254,   255,     0,     0,     0,
       0,     0,     0,     0,     0,   238,     0,     0,     0,   240,
     241,     0,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   212,   213,     0,     0,   252,   253,   254,   255,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,     0,   235,   236,   237,   212,   213,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   226,   227,   228,   229,   230,
     231,   232,   233,   234,     0,   235,   236,   237,     0,     0,
       0,     0,     0,   238,     0,     0,     0,     0,   241,     0,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
       0,     0,     0,     0,   252,   253,   254,   255,     0,     0,
       0,     0,     0,     0,     0,     0,   238,     0,     0,     0,
       0,   212,   213,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,     0,     0,     0,     0,   252,   253,   254,
     255,   226,   227,   228,   229,   230,   231,   232,   233,   234,
       0,   235,   236,   237,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   238,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   245,   246,   247,   248,   249,   250,   251,     0,
       0,     0,     0,   252,   253,   254,   255
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-462)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-185)))

static const yytype_int16 yycheck[] =
{
       2,     0,   117,   113,     6,    79,    14,    96,    14,     0,
     471,    32,     3,    15,    16,    17,    18,     3,     0,     0,
     109,   198,     5,    98,    14,   318,    38,    39,   145,   206,
     143,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    14,    45,   318,   143,    14,    49,    50,    51,
      52,    53,    54,    14,   318,   318,   122,   318,    98,    99,
      62,    25,   122,    46,    47,    48,   318,   385,    32,   144,
     143,    73,   123,    75,    76,    77,   101,    79,    42,   145,
     101,    80,    24,    25,    26,    27,   146,   122,   489,    80,
      32,   145,    98,    14,   145,   103,    78,   103,    80,    80,
      42,    14,    98,    45,    46,    96,   102,   103,    98,    99,
     145,   113,   145,   103,   104,   140,   517,   506,   109,   140,
     123,   123,   124,   125,   513,   145,    98,   129,   130,    43,
      98,    99,   144,   426,    98,   117,   104,    98,    99,   103,
     143,   125,   145,   104,   146,   463,    24,    25,    26,    27,
     327,    98,   426,   143,    32,    98,    78,   125,   141,   102,
     103,   145,   426,   426,    42,   426,   484,    45,    46,   506,
     134,   123,   174,   175,   426,   177,   513,    98,    99,   580,
     144,   506,   143,   104,    32,    98,    99,    35,   513,   123,
     103,   104,    14,   145,   108,   117,   145,   515,   516,   143,
     114,   311,   144,   185,   125,   196,   143,   668,   140,   143,
     196,   145,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   305,    98,   110,   236,   237,   102,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   143,   573,    38,    39,   576,   660,
      98,    25,   264,   185,   102,   103,   144,   617,    32,   112,
     113,   621,   274,   116,   117,   277,    98,    99,    42,   281,
      24,    25,   104,    98,   266,   287,   288,   289,   103,   690,
      35,   145,   294,   295,    98,    98,   441,   143,   443,   103,
     103,   303,   304,    98,    35,   143,   308,   102,   103,   311,
      48,    49,    98,   315,   316,   317,   493,   494,    99,   318,
      98,    25,   324,   325,   326,   103,    11,   318,    32,   123,
     134,   134,     9,   510,    98,    14,    98,   318,    42,   103,
     143,   103,   143,   432,   266,    24,    25,    26,    27,   143,
      98,   145,    99,    32,    98,   103,    35,   104,   143,   103,
     140,   506,   123,    42,    98,   145,    45,    46,   513,   103,
     134,   143,   134,   691,    98,   143,   378,   379,   555,   103,
     382,   119,    48,    49,   123,   387,   388,   389,    98,   391,
     392,   393,   143,   570,    98,    98,   398,   380,   381,   103,
     103,    99,   140,   141,   142,   143,   104,    24,    25,    26,
      27,   143,    98,    99,   125,    32,   418,   103,   104,    98,
     146,   143,   511,   143,   103,    42,    14,   426,    45,    46,
     134,    40,    14,   116,   143,   426,    24,    25,    26,    27,
     144,   432,   441,   445,   443,   426,   143,   140,   450,   451,
     452,   453,   145,   119,    42,   134,   140,    45,    46,    98,
     441,   145,   443,   143,   103,   144,    98,   133,   134,   135,
     102,   103,   146,   464,   140,   141,   142,   143,   464,   143,
      98,    99,    98,   145,   599,   103,   104,   103,    48,    49,
      14,    24,    25,    26,    27,   134,   146,   146,   143,    32,
      24,    25,    26,    27,   143,   143,   143,   506,    32,    42,
      98,    35,    45,    46,   513,   103,   518,   123,    42,   510,
     123,    45,    46,    98,   526,   506,   641,   144,   103,   644,
     532,    98,   513,    98,   123,   140,   103,   102,   103,   541,
     145,   524,   525,   465,   466,   143,   134,    98,   143,   146,
     533,   102,   103,   536,   669,   670,   671,   672,   673,   119,
     675,   676,   146,   140,   143,   487,   488,   558,   145,   571,
     140,   562,   558,   146,    98,   145,   562,   143,   143,   103,
     140,   141,   142,   143,   143,   146,   140,   589,   590,   591,
     592,   145,   143,    98,   596,   597,   146,   102,   103,     4,
     602,   603,   140,    98,   146,   527,   146,   102,   103,   125,
     134,   144,    14,   125,   146,   146,   146,   599,   146,   610,
     144,   623,    24,    25,    26,    27,   617,   145,   550,   551,
     621,   617,   554,    14,   122,   621,   146,   146,   143,   134,
      42,   143,   146,    45,    46,   145,    41,    25,   146,   651,
     633,   145,   574,   575,    32,   140,   578,   579,    34,   641,
     143,   125,   644,   645,    42,   146,    14,    98,   146,   125,
     146,   146,   146,   129,   130,   145,   143,   599,   680,   125,
     143,   143,   684,   685,   122,   687,   688,   669,   670,   671,
     672,   673,   674,   675,   676,   677,    98,    48,    49,   701,
     702,   103,   103,   625,    98,   146,   628,   629,   116,   692,
     632,   693,   694,   695,   696,   697,   698,   699,   174,   641,
      98,   177,   644,   645,   146,   103,   116,    78,    79,    80,
      32,    98,   134,    14,   125,   101,   101,   146,   125,   125,
     146,    98,   146,    24,    25,    26,    27,   669,   670,   671,
     672,   673,   674,   675,   676,   677,   134,   146,   146,    80,
     145,    42,   146,   146,    45,    46,   144,   292,   119,   426,
     145,   693,   694,   695,   696,   697,   698,   699,    26,   205,
     131,   132,   133,   134,   135,   145,   543,   709,   710,   140,
     141,   142,   143,    24,    25,    26,    27,   443,   500,   255,
     618,   502,   562,     1,   604,    68,   305,     5,   264,    -1,
      -1,    42,    -1,    -1,    45,    46,    14,    98,   274,    -1,
      18,    19,   103,    -1,    22,    23,    24,    25,    26,    27,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,   294,   295,
      -1,    -1,    -1,    -1,    42,    -1,    -1,    45,    46,    -1,
      48,    49,    -1,   134,    -1,    -1,    -1,    -1,    -1,   315,
     316,   317,    60,    61,    62,    63,    64,    65,   324,   325,
     326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    48,    49,    -1,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      -1,   109,   110,   111,    -1,    -1,    -1,   115,    -1,    -1,
     118,    -1,    -1,   379,    -1,    -1,   382,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   132,    -1,   134,    -1,    -1,   137,
     138,   139,    -1,     1,    -1,   143,    -1,     5,   146,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    -1,   119,    -1,
      18,    19,   418,    -1,    22,    23,    24,    25,    26,    27,
     131,   132,   133,   134,   135,    -1,    -1,    35,    -1,   140,
     141,   142,   143,    -1,    42,    -1,    -1,    45,    46,   445,
      48,    49,    -1,    -1,   450,   451,   452,    48,    49,    -1,
      -1,    -1,    60,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    -1,    -1,    77,
      -1,   103,    -1,    81,    82,    83,    84,   109,   110,    -1,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      -1,   109,   110,   111,    -1,    -1,    -1,   115,    -1,    -1,
     118,    -1,   518,    -1,    -1,    -1,    -1,    -1,   119,    -1,
     526,    -1,    -1,    -1,   132,    -1,   134,    48,    49,   137,
     138,   139,    -1,   134,   135,   143,    -1,   145,    -1,   140,
     141,   142,   143,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      -1,    -1,    -1,    -1,    -1,   571,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   602,   603,   119,    -1,
      -1,    -1,   123,   124,    -1,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,    -1,    -1,   623,    -1,   140,
     141,   142,   143,     0,     1,    -1,     3,    -1,     5,     6,
       7,     8,    -1,    -1,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    -1,    22,    23,    24,    25,    26,
      27,    28,    -1,    -1,    31,    32,    33,    -1,    35,    36,
      37,    -1,    -1,    -1,    -1,    42,    43,    44,    45,    46,
      -1,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,   685,
      -1,    -1,   688,    60,    61,    62,    63,    64,    65,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   702,    -1,    -1,    -1,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,    -1,    -1,   114,   115,    -1,
      -1,   118,    -1,   120,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   132,    -1,   134,    -1,    -1,
     137,   138,   139,   140,    -1,     1,   143,     3,    -1,     5,
       6,     7,     8,    -1,    -1,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    -1,    22,    23,    24,    25,
      26,    27,    28,    -1,    -1,    31,    -1,    33,    -1,    35,
      36,    37,    38,    39,    -1,    -1,    42,    -1,    -1,    45,
      46,    -1,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    -1,   109,   110,   111,    -1,    -1,    -1,   115,
      -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,   134,    -1,
      -1,   137,   138,   139,   140,    -1,    -1,   143,   144,     1,
      -1,     3,    -1,     5,     6,     7,     8,    -1,    -1,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    -1,
      22,    23,    24,    25,    26,    27,    28,    -1,    -1,    31,
      -1,    33,    -1,    35,    36,    37,    38,    39,    -1,    -1,
      42,    -1,    -1,    45,    46,    -1,    48,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,    -1,   109,   110,   111,
      -1,    -1,    -1,   115,    -1,    -1,   118,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     132,    -1,   134,    -1,    -1,   137,   138,   139,   140,    -1,
      -1,   143,   144,     1,    -1,     3,    -1,     5,     6,     7,
       8,    -1,    -1,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
      28,    -1,    -1,    31,    -1,    33,    -1,    35,    36,    37,
      38,    39,    -1,    -1,    42,    -1,    -1,    45,    46,    -1,
      48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    60,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      -1,   109,   110,   111,    -1,    -1,    -1,   115,    -1,    -1,
     118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   132,    -1,   134,    -1,    -1,   137,
     138,   139,   140,    -1,    -1,   143,   144,     1,    -1,     3,
      -1,     5,     6,     7,     8,    -1,    -1,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    -1,    22,    23,
      24,    25,    26,    27,    28,    -1,    -1,    31,    -1,    33,
      -1,    35,    36,    37,    38,    39,    -1,    -1,    42,    -1,
      -1,    45,    46,    -1,    48,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,    -1,   109,   110,   111,    -1,    -1,
      -1,   115,    -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,
     134,    -1,    -1,   137,   138,   139,   140,    -1,    -1,   143,
     144,     1,    -1,     3,    -1,     5,     6,     7,     8,    -1,
      -1,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    -1,    22,    23,    24,    25,    26,    27,    28,    -1,
      -1,    31,    -1,    33,    -1,    35,    36,    37,    38,    39,
      -1,    -1,    42,    -1,    -1,    45,    46,    -1,    48,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    61,    62,    63,    64,    65,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    -1,   109,
     110,   111,    -1,    -1,    -1,   115,    -1,    -1,   118,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   132,    -1,   134,    -1,    -1,   137,   138,   139,
     140,    -1,    -1,   143,   144,     1,    -1,     3,    -1,     5,
       6,     7,     8,    -1,    -1,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    -1,    22,    23,    24,    25,
      26,    27,    28,    -1,    -1,    31,    -1,    33,    -1,    35,
      36,    37,    38,    39,    -1,    -1,    42,    -1,    -1,    45,
      46,    -1,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    -1,   109,   110,   111,    -1,    -1,    -1,   115,
      -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,   134,    -1,
      -1,   137,   138,   139,   140,    -1,    -1,   143,   144,     1,
      -1,     3,    -1,     5,     6,     7,     8,    -1,    -1,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    -1,
      22,    23,    24,    25,    26,    27,    28,    -1,    -1,    31,
      -1,    33,    -1,    35,    36,    37,    38,    39,    -1,    -1,
      42,    -1,    -1,    45,    46,    -1,    48,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,    -1,   109,   110,   111,
      -1,    -1,    -1,   115,    -1,    -1,   118,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     132,    -1,   134,    -1,    -1,   137,   138,   139,   140,    -1,
      -1,   143,   144,     1,    -1,     3,    -1,     5,     6,     7,
       8,    -1,    -1,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
      28,    -1,    -1,    31,    -1,    33,    -1,    35,    36,    37,
      38,    39,    -1,    -1,    42,    -1,    -1,    45,    46,    -1,
      48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    60,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      -1,   109,   110,   111,    -1,    -1,    -1,   115,    -1,    -1,
     118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   132,    -1,   134,    -1,    -1,   137,
     138,   139,   140,    -1,    -1,   143,   144,     1,    -1,     3,
      -1,     5,     6,     7,     8,    -1,    -1,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    -1,    22,    23,
      24,    25,    26,    27,    28,    -1,    -1,    31,    -1,    33,
      -1,    35,    36,    37,    38,    39,    -1,    -1,    42,    -1,
      -1,    45,    46,    -1,    48,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,    -1,   109,   110,   111,    -1,    -1,
      -1,   115,    -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,
     134,    -1,    -1,   137,   138,   139,   140,    -1,    -1,   143,
     144,     1,    -1,     3,    -1,     5,     6,     7,     8,    -1,
      -1,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    -1,    22,    23,    24,    25,    26,    27,    28,    -1,
      -1,    31,    -1,    33,    -1,    35,    36,    37,    38,    39,
      -1,    -1,    42,    -1,    -1,    45,    46,    -1,    48,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    61,    62,    63,    64,    65,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    -1,   109,
     110,   111,    -1,    -1,    -1,   115,    -1,    -1,   118,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   132,    -1,   134,    -1,    -1,   137,   138,   139,
     140,    -1,    -1,   143,   144,     1,    -1,     3,    -1,     5,
       6,     7,     8,    -1,    -1,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    -1,    22,    23,    24,    25,
      26,    27,    28,    -1,    -1,    31,    -1,    33,    -1,    35,
      36,    37,    38,    39,    -1,    -1,    42,    -1,    -1,    45,
      46,    -1,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    -1,   109,   110,   111,    -1,    -1,    -1,   115,
      -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,   134,    -1,
      -1,   137,   138,   139,   140,    -1,    -1,   143,   144,     1,
      -1,     3,    -1,     5,     6,     7,     8,    -1,    -1,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    -1,
      22,    23,    24,    25,    26,    27,    28,    -1,    -1,    31,
      -1,    33,    -1,    35,    36,    37,    38,    39,    -1,    -1,
      42,    -1,    -1,    45,    46,    -1,    48,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,    -1,   109,   110,   111,
      -1,    -1,    -1,   115,    -1,    -1,   118,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     132,    -1,   134,    -1,    -1,   137,   138,   139,   140,    -1,
      -1,   143,   144,     1,    -1,     3,    -1,     5,     6,     7,
       8,    -1,    -1,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
      28,    -1,    -1,    31,    -1,    33,    -1,    35,    36,    37,
      38,    39,    -1,    -1,    42,    -1,    -1,    45,    46,    -1,
      48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    60,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      -1,   109,   110,   111,    -1,    -1,    -1,   115,    -1,    -1,
     118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   132,    -1,   134,    -1,    -1,   137,
     138,   139,   140,    -1,    -1,   143,   144,     1,    -1,     3,
      -1,     5,     6,     7,     8,    -1,    -1,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    -1,    22,    23,
      24,    25,    26,    27,    28,    -1,    -1,    31,    -1,    33,
      -1,    35,    36,    37,    38,    39,    -1,    -1,    42,    -1,
      -1,    45,    46,    -1,    48,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,    -1,   109,   110,   111,    -1,    -1,
      -1,   115,    -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,
     134,    -1,    -1,   137,   138,   139,   140,    -1,    -1,   143,
     144,     1,    -1,     3,    -1,     5,     6,     7,     8,    -1,
      -1,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    -1,    22,    23,    24,    25,    26,    27,    28,    -1,
      -1,    31,    -1,    33,    -1,    35,    36,    37,    38,    39,
      -1,    -1,    42,    -1,    -1,    45,    46,    -1,    48,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    61,    62,    63,    64,    65,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    -1,   109,
     110,   111,    -1,    -1,    -1,   115,    -1,    -1,   118,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   132,    -1,   134,    -1,    -1,   137,   138,   139,
     140,    -1,    -1,   143,   144,     1,    -1,     3,    -1,     5,
       6,     7,     8,    -1,    -1,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    -1,    22,    23,    24,    25,
      26,    27,    28,    -1,    -1,    31,    -1,    33,    -1,    35,
      36,    37,    38,    39,    -1,    -1,    42,    -1,    -1,    45,
      46,    -1,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    -1,   109,   110,   111,    -1,    -1,    -1,   115,
      -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,   134,    -1,
      -1,   137,   138,   139,   140,    -1,    -1,   143,   144,     1,
      -1,     3,    -1,     5,     6,     7,     8,    -1,    -1,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    -1,
      22,    23,    24,    25,    26,    27,    28,    -1,    -1,    31,
      -1,    33,    -1,    35,    36,    37,    38,    39,    -1,    -1,
      42,    -1,    -1,    45,    46,    -1,    48,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,    -1,   109,   110,   111,
      -1,    -1,    -1,   115,    -1,    -1,   118,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     132,    -1,   134,    -1,    -1,   137,   138,   139,   140,    -1,
      -1,   143,   144,     1,    -1,     3,    -1,     5,     6,     7,
       8,    -1,    -1,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
      28,    -1,    -1,    31,    -1,    33,    -1,    35,    36,    37,
      38,    39,    -1,    -1,    42,    -1,    -1,    45,    46,    -1,
      48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    60,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      -1,   109,   110,   111,    -1,    -1,    -1,   115,    -1,    -1,
     118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   132,    -1,   134,    -1,    -1,   137,
     138,   139,   140,    -1,    -1,   143,   144,     1,    -1,     3,
      -1,     5,     6,     7,     8,    -1,    -1,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    -1,    22,    23,
      24,    25,    26,    27,    28,    -1,    -1,    31,    -1,    33,
      -1,    35,    36,    37,    38,    39,    -1,    -1,    42,    -1,
      -1,    45,    46,    -1,    48,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,    -1,   109,   110,   111,    -1,    -1,
      -1,   115,    -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,
     134,    -1,    -1,   137,   138,   139,   140,    -1,    -1,   143,
     144,     1,    -1,     3,    -1,     5,     6,     7,     8,    -1,
      -1,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    -1,    22,    23,    24,    25,    26,    27,    28,    -1,
      -1,    31,    -1,    33,    -1,    35,    36,    37,    38,    39,
      -1,    -1,    42,    -1,    -1,    45,    46,    -1,    48,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    61,    62,    63,    64,    65,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    -1,   109,
     110,   111,    -1,    -1,    -1,   115,    -1,    -1,   118,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   132,    -1,   134,    -1,    -1,   137,   138,   139,
     140,    -1,    -1,   143,   144,     1,    -1,     3,    -1,     5,
       6,     7,     8,    -1,    -1,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    -1,    22,    23,    24,    25,
      26,    27,    28,    -1,    -1,    31,    -1,    33,    -1,    35,
      36,    37,    -1,    -1,    -1,    -1,    42,    -1,    -1,    45,
      46,    -1,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    -1,   109,   110,   111,    -1,    -1,    -1,   115,
      -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,   134,    -1,
      -1,   137,   138,   139,   140,    -1,    -1,   143,   144,     1,
      -1,     3,    -1,     5,     6,     7,     8,    -1,    -1,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    -1,
      22,    23,    24,    25,    26,    27,    28,    -1,    -1,    31,
      -1,    33,    -1,    35,    36,    37,    -1,    -1,    -1,    -1,
      42,    -1,    -1,    45,    46,    -1,    48,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,    -1,   109,   110,   111,
      -1,    -1,    -1,   115,    -1,    -1,   118,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     132,    -1,   134,    -1,    -1,   137,   138,   139,   140,    -1,
      -1,   143,   144,     1,    -1,     3,    -1,     5,     6,     7,
       8,    -1,    -1,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
      28,    -1,    -1,    31,    -1,    33,    -1,    35,    36,    37,
      -1,    -1,    -1,    -1,    42,    -1,    -1,    45,    46,    -1,
      48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    60,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      -1,   109,   110,   111,    -1,    -1,    -1,   115,    -1,    -1,
     118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   132,    -1,   134,    -1,    -1,   137,
     138,   139,   140,    -1,    -1,   143,   144,     1,    -1,     3,
      -1,     5,     6,     7,     8,    -1,    -1,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    -1,    22,    23,
      24,    25,    26,    27,    28,    -1,    -1,    31,    32,    33,
      -1,    35,    36,    37,    -1,    -1,    -1,    -1,    42,    43,
      44,    45,    46,    -1,    48,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,    -1,    -1,
     114,   115,    -1,    -1,   118,    -1,   120,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,
     134,    -1,    -1,   137,   138,   139,   140,    -1,     1,   143,
       3,    -1,     5,     6,     7,     8,    -1,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    -1,
      33,    -1,    35,    36,    37,    -1,    -1,    -1,    -1,    42,
      -1,    -1,    45,    46,    -1,    48,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,
      63,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,    -1,   109,   110,   111,    -1,
      -1,    -1,   115,    -1,    -1,   118,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   132,
      -1,   134,    -1,    -1,   137,   138,   139,   140,    -1,     1,
     143,     3,    -1,     5,     6,     7,     8,    -1,    -1,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    -1,
      22,    23,    24,    25,    26,    27,    28,    -1,    -1,    31,
      -1,    33,    -1,    35,    36,    37,    -1,    -1,    -1,    -1,
      42,    -1,    -1,    45,    46,    -1,    48,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,    -1,   109,   110,   111,
      -1,    -1,    -1,   115,    -1,    -1,   118,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     132,     5,   134,    -1,    -1,   137,   138,   139,   140,    -1,
      14,   143,    -1,    -1,    18,    19,    -1,    -1,    22,    23,
      24,    25,    26,    27,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,
      -1,    45,    46,    -1,    48,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,    63,
      64,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    -1,    -1,    -1,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
      -1,   105,   106,   107,    -1,   109,   110,   111,    -1,    -1,
      -1,   115,    -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,   132,    -1,
     134,    -1,    -1,   137,   138,   139,    14,    -1,    -1,   143,
      18,    19,   146,    -1,    22,    23,    24,    25,    26,    27,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    -1,    -1,    45,    46,    -1,
      48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    60,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    -1,    -1,    -1,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,   105,   106,   107,
      -1,   109,   110,   111,    -1,    -1,    -1,   115,    -1,    -1,
     118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   132,     5,   134,    -1,    -1,   137,
     138,   139,    -1,    -1,    14,   143,    -1,   145,    18,    19,
      -1,    -1,    22,    23,    24,    25,    26,    27,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    42,    -1,    -1,    45,    46,    -1,    48,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    61,    62,    63,    64,    65,    -1,    -1,    68,    -1,
      70,    71,    -1,    -1,    -1,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    -1,    -1,    -1,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,    -1,   105,   106,   107,    -1,   109,
     110,   111,    -1,    -1,    -1,   115,   116,    -1,   118,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,    -1,   129,
     130,    -1,   132,    -1,   134,    -1,    14,   137,   138,   139,
      18,    19,    -1,   143,    22,    23,    24,    25,    26,    27,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    -1,    -1,    45,    46,    -1,
      48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    60,    61,    62,    63,    64,    65,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    -1,    -1,    -1,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      -1,   109,   110,   111,    -1,    -1,    -1,   115,    -1,    -1,
     118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,
      -1,    -1,    -1,    -1,   132,    -1,   134,    -1,    14,   137,
     138,   139,    18,    19,    -1,   143,    22,    23,    24,    25,
      26,    27,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,    45,
      46,    -1,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    61,    62,    63,    64,    65,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    -1,    -1,    -1,    81,    82,    83,    84,    -1,
      -1,    -1,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,   105,
     106,   107,    10,   109,   110,   111,    -1,    -1,    -1,   115,
      -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,   134,    -1,
      -1,   137,   138,   139,    -1,    -1,    -1,   143,    -1,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,
      -1,   119,    -1,    -1,   122,   123,   124,    -1,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,    -1,    -1,
      -1,    -1,   140,   141,   142,   143,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    -1,    -1,
      -1,    -1,    -1,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    21,    -1,   119,    -1,    -1,
     122,   123,   124,    -1,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,    -1,    -1,    -1,    -1,   140,   141,
     142,   143,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    -1,    -1,    -1,    -1,    -1,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    -1,
      -1,    -1,    -1,   119,    -1,    -1,   122,   123,   124,    -1,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
      -1,    -1,    -1,    -1,   140,   141,   142,   143,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
     123,   124,    -1,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,    -1,    -1,    -1,    -1,   140,   141,   142,
     143,    -1,    -1,    -1,   147,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    -1,    -1,    -1,    -1,    -1,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
     123,   124,    -1,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,    -1,    -1,    -1,    -1,   140,   141,   142,
     143,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,   119,
      -1,    -1,   122,   123,   124,    -1,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,    -1,    -1,    -1,    -1,
     140,   141,   142,   143,    -1,    -1,   146,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,   122,   123,   124,    -1,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,    -1,    -1,    -1,    -1,   140,
     141,   142,   143,    -1,    -1,   146,    -1,    -1,    -1,    -1,
      -1,   119,    -1,    -1,   122,   123,   124,    -1,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,    -1,    -1,
      -1,    -1,   140,   141,   142,   143,    -1,    -1,   146,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    -1,    -1,    -1,    -1,    -1,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,   122,   123,   124,    -1,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,    -1,    -1,    -1,
      -1,   140,   141,   142,   143,    -1,    -1,   146,    -1,    -1,
      -1,    -1,    -1,   119,    -1,    -1,   122,   123,   124,    -1,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
      -1,    -1,    -1,    -1,   140,   141,   142,   143,    -1,    -1,
     146,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,   122,   123,   124,    -1,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,    -1,
      -1,    -1,    -1,   140,   141,   142,   143,    -1,    -1,   146,
      -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,   123,
     124,    -1,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,    -1,    -1,    -1,    -1,   140,   141,   142,   143,
      -1,    -1,   146,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    -1,    -1,
      -1,    -1,    -1,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,   122,   123,   124,
      -1,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,    -1,    -1,    -1,    -1,   140,   141,   142,   143,    -1,
      -1,   146,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,
     122,   123,   124,    -1,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,    -1,    -1,    -1,    -1,   140,   141,
     142,   143,    -1,    -1,   146,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    -1,    -1,    -1,    -1,    -1,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
     123,   124,    -1,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,    -1,    -1,    -1,    -1,   140,   141,   142,
     143,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,   119,
      -1,    -1,   122,   123,   124,    -1,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,    -1,    -1,    -1,    -1,
     140,   141,   142,   143,    -1,    -1,   146,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,   122,   123,   124,    -1,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,    -1,    -1,    -1,    -1,   140,
     141,   142,   143,    -1,    -1,   146,    -1,    -1,    -1,    -1,
      -1,   119,    -1,    -1,   122,   123,   124,    -1,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,    -1,    -1,
      -1,    -1,   140,   141,   142,   143,    -1,    -1,   146,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    -1,    78,
      79,    80,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    -1,    -1,    -1,    -1,    -1,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,   122,   123,   124,    -1,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,    -1,    -1,    -1,
      -1,   140,   141,   142,   143,    -1,   145,    -1,    -1,    -1,
      -1,    -1,    -1,   119,    -1,    -1,   122,   123,   124,    -1,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
      -1,    -1,    -1,    -1,   140,   141,   142,   143,    -1,   145,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    -1,
      78,    79,    80,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    -1,    -1,    -1,    -1,
      -1,   119,    -1,    -1,   122,   123,   124,    -1,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,    -1,    -1,
      -1,    -1,   140,   141,   142,   143,    -1,   145,    -1,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,   122,   123,   124,
      -1,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,    -1,    -1,    -1,    -1,   140,   141,   142,   143,    -1,
     145,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,   122,   123,   124,    -1,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,    -1,
      -1,    -1,    -1,   140,   141,   142,   143,    -1,   145,    -1,
      -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,   123,
     124,    -1,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,    -1,    -1,    -1,    -1,   140,   141,   142,   143,
      -1,   145,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    -1,    -1,    -1,    -1,    -1,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    -1,
      -1,    -1,    -1,   119,    -1,    -1,   122,   123,   124,    -1,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
      -1,    -1,    -1,    -1,   140,   141,   142,   143,    -1,   145,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
     123,   124,    -1,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,    -1,    -1,    -1,    -1,   140,   141,   142,
     143,    -1,   145,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    -1,    -1,
      -1,    -1,    -1,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,   122,   123,   124,
      -1,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,    -1,    -1,    -1,    -1,   140,   141,   142,   143,    -1,
     145,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,
     122,   123,   124,    -1,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,    -1,    -1,    -1,    -1,   140,   141,
     142,   143,    -1,   145,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,   123,
     124,    -1,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,    -1,    -1,    -1,    -1,   140,   141,   142,   143,
      -1,   145,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,   122,   123,   124,    -1,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,    -1,    -1,    -1,    -1,   140,
     141,   142,   143,    -1,   145,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    -1,    -1,    -1,    -1,    -1,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    78,    79,
      80,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
     123,   124,    -1,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,    -1,    -1,    -1,    -1,   140,   141,   142,
     143,   144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,
      -1,    -1,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,    -1,    -1,    -1,    -1,
     140,   141,   142,   143,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,    -1,    -1,    -1,    -1,   140,   141,   142,   143,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,    -1,    -1,    -1,    -1,   140,
     141,   142,   143,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    -1,    78,    79,    80,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    -1,    -1,
      -1,    -1,    -1,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    79,    80,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,    -1,    -1,    -1,    -1,   140,   141,   142,   143,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,    -1,    -1,    -1,    -1,   140,   141,
     142,   143,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    -1,    -1,    -1,    -1,    -1,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    -1,
      -1,    -1,    -1,   119,    -1,    -1,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
      -1,    -1,    -1,    -1,   140,   141,   142,   143,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,    -1,    -1,    -1,    -1,   140,   141,   142,
     143,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    -1,    78,    79,    80,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,   122,   123,   124,    -1,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,    -1,
      -1,    -1,    -1,   140,   141,   142,   143,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,   123,
     124,    -1,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,    48,    49,    -1,    -1,   140,   141,   142,   143,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    -1,    78,    79,    80,    48,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    -1,    -1,
      -1,    -1,    -1,   119,    -1,    -1,    -1,    -1,   124,    -1,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
      -1,    -1,    -1,    -1,   140,   141,   142,   143,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,
      -1,    48,    49,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,    -1,    -1,    -1,    -1,   140,   141,   142,
     143,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      -1,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   129,   130,   131,   132,   133,   134,   135,    -1,
      -1,    -1,    -1,   140,   141,   142,   143
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     3,     5,     6,     7,     8,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    22,    23,    24,
      25,    26,    27,    28,    31,    32,    33,    36,    37,    42,
      44,    45,    46,    48,    49,    60,    61,    62,    63,    64,
      65,    77,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
     100,   101,   102,   103,   105,   106,   107,   109,   110,   111,
     115,   118,   120,   132,   134,   137,   138,   139,   140,   143,
     149,   150,   153,   154,   155,   158,   159,   164,   167,   168,
     171,   173,   178,   179,   189,   193,   194,   195,   197,   198,
     199,   202,   203,   204,   145,    14,    25,   103,   178,   194,
     202,    98,   103,   143,   178,   179,   103,   140,   160,   161,
     164,   161,   202,   143,   143,   143,    98,   102,   103,   143,
     187,   145,   145,   145,   202,   202,   202,   202,    32,    98,
     163,   165,    98,   103,   163,   145,   143,   140,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,    98,
     103,   202,   161,   161,   161,   202,   202,   202,   202,   202,
     202,     1,   172,   202,   143,   143,   203,   143,   202,    98,
     103,   202,   202,   202,   160,   162,   164,    98,   103,   146,
     200,   201,   202,   204,     0,   150,    35,   145,    14,    98,
     103,    99,   104,    43,   108,   114,    14,    25,    98,   103,
     178,   195,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    78,    79,    80,   119,   122,
     123,   124,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   140,   141,   142,   143,   145,    14,    14,   178,
     199,   202,    98,    99,   143,   144,   162,    11,     9,   145,
     202,   202,   172,   143,   143,   172,   172,    21,    21,    98,
     103,   143,    10,    29,    30,   161,   166,   123,   123,   143,
     202,    98,   151,   152,   143,   143,   146,   172,   202,   172,
     144,   160,   164,   125,   125,   122,   146,   146,   125,    98,
     103,   143,   178,   179,   103,   143,   187,   143,   140,   145,
      40,   174,   174,   103,   143,   187,   143,    14,   103,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   112,   113,
     116,   117,   116,    98,   103,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   172,    14,   146,   172,   144,   143,   143,
     146,   146,   145,   172,   146,   146,   202,   143,   123,   123,
     202,   143,   143,   143,   202,   202,   202,   146,   123,   144,
     152,   172,   172,   146,   146,   146,   202,   202,    98,   103,
     201,   204,   202,   199,    98,   103,    99,   104,   143,   172,
     172,   172,    14,   144,   154,   155,   156,   157,   158,   159,
     173,   178,   194,   197,   198,    24,    25,    98,   103,   175,
     176,   140,   145,   140,   145,   143,   172,   172,   172,   103,
     143,   187,   143,   125,   144,   147,   146,   146,   202,   172,
     161,   161,   172,   146,     4,   196,   196,    10,   202,   202,
     202,   146,   202,   202,   202,   145,   145,   146,   140,   202,
     146,   146,   125,   145,   190,   146,   172,   146,   146,   146,
     145,   144,   157,    14,    14,   178,    98,   103,    98,   103,
     122,    24,    25,    32,   144,   158,   177,   180,   181,   188,
     193,   194,   144,   177,   172,   146,   146,   146,   143,   172,
     172,   172,   202,   146,   146,    41,   145,   196,   178,   179,
     160,   160,   143,   146,   145,   145,   165,   146,   146,   146,
      34,    38,    39,   169,   170,   145,    98,   103,   191,   192,
     196,   146,   160,   160,   190,    14,   176,   101,   140,   184,
     185,    32,   140,   185,   144,   158,   180,   181,   188,    98,
     178,   187,   144,   146,   196,   196,   190,   172,   146,   146,
     146,   145,   161,   161,   172,   160,   202,   161,   161,   143,
      68,    70,    71,    75,    76,   116,   129,   130,   202,   125,
     144,   170,   143,   143,   122,   160,   160,   160,   103,    25,
      42,    98,   158,   178,   179,   182,   183,   186,   122,   145,
     144,   186,   145,   187,   172,   196,   160,   160,   196,   146,
     160,   160,   190,   146,   146,   202,   202,   202,   202,   116,
     116,   125,   202,   202,   125,   162,   172,   172,   192,    98,
     178,   123,   145,    98,   101,   144,   183,   184,   144,   172,
     146,   160,   145,   160,   160,   145,   160,   161,   146,   125,
     125,   125,   125,   125,   162,   125,   125,   162,   146,   146,
     123,   145,    98,   202,   123,   143,   145,   123,   143,   145,
     146,   190,   165,   162,   162,   162,   162,   162,   162,   162,
     202,   123,   143,   145,   145,   202,   172,   202,   172,   190,
     196,   161,   145,   202,   172,   145,   146,   145,   146,   145,
     160,   145,   160,   145,   146,   145,   145,   145
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

__attribute__((__unused__))
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
#else
static unsigned
yy_location_print_ (yyo, yylocp)
    FILE *yyo;
    YYLTYPE const * const yylocp;
#endif
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += fprintf (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += fprintf (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += fprintf (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += fprintf (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += fprintf (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, yyscanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, yyscan_t yyscanner)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    yyscan_t yyscanner;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (yyscanner);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, yyscan_t yyscanner)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    yyscan_t yyscanner;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, yyscan_t yyscanner)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, yyscanner)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    yyscan_t yyscanner;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, yyscanner); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, yyscan_t yyscanner)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, yyscanner)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    yyscan_t yyscanner;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {
      case 98: /* "identifier" */
/* Line 1398 of yacc.c  */
#line 1414 "parser.ypp"
        { free(((*yyvaluep).string)); };
/* Line 1398 of yacc.c  */
#line 4846 "parser.cpp"
        break;
      case 99: /* "variable reference" */
/* Line 1398 of yacc.c  */
#line 1414 "parser.ypp"
        { free(((*yyvaluep).string)); };
/* Line 1398 of yacc.c  */
#line 4853 "parser.cpp"
        break;
      case 100: /* "backquote expression" */
/* Line 1398 of yacc.c  */
#line 1414 "parser.ypp"
        { free(((*yyvaluep).string)); };
/* Line 1398 of yacc.c  */
#line 4860 "parser.cpp"
        break;
      case 101: /* "in-object member reference" */
/* Line 1398 of yacc.c  */
#line 1414 "parser.ypp"
        { free(((*yyvaluep).string)); };
/* Line 1398 of yacc.c  */
#line 4867 "parser.cpp"
        break;
      case 102: /* "identifier or keyword used as function or method identifier" */
/* Line 1398 of yacc.c  */
#line 1414 "parser.ypp"
        { free(((*yyvaluep).string)); };
/* Line 1398 of yacc.c  */
#line 4874 "parser.cpp"
        break;
      case 103: /* "namespace or class-scoped reference" */
/* Line 1398 of yacc.c  */
#line 1414 "parser.ypp"
        { free(((*yyvaluep).string)); };
/* Line 1398 of yacc.c  */
#line 4881 "parser.cpp"
        break;
      case 104: /* "namespace-scoped global variable reference" */
/* Line 1398 of yacc.c  */
#line 1414 "parser.ypp"
        { free(((*yyvaluep).string)); };
/* Line 1398 of yacc.c  */
#line 4888 "parser.cpp"
        break;
      case 105: /* "context reference" */
/* Line 1398 of yacc.c  */
#line 1414 "parser.ypp"
        { free(((*yyvaluep).string)); };
/* Line 1398 of yacc.c  */
#line 4895 "parser.cpp"
        break;
      case 106: /* "named context reference" */
/* Line 1398 of yacc.c  */
#line 1414 "parser.ypp"
        { free(((*yyvaluep).string)); };
/* Line 1398 of yacc.c  */
#line 4902 "parser.cpp"
        break;
      case 107: /* "cast operator" */
/* Line 1398 of yacc.c  */
#line 1414 "parser.ypp"
        { free(((*yyvaluep).string)); };
/* Line 1398 of yacc.c  */
#line 4909 "parser.cpp"
        break;
      case 108: /* "simple class declaration" */
/* Line 1398 of yacc.c  */
#line 1414 "parser.ypp"
        { free(((*yyvaluep).string)); };
/* Line 1398 of yacc.c  */
#line 4916 "parser.cpp"
        break;
      case 109: /* "date/time value" */
/* Line 1398 of yacc.c  */
#line 1415 "parser.ypp"
        { if (((*yyvaluep).datetime)) ((*yyvaluep).datetime)->deref(); };
/* Line 1398 of yacc.c  */
#line 4923 "parser.cpp"
        break;
      case 110: /* "quoted string" */
/* Line 1398 of yacc.c  */
#line 1415 "parser.ypp"
        { if (((*yyvaluep).String)) ((*yyvaluep).String)->deref(); };
/* Line 1398 of yacc.c  */
#line 4930 "parser.cpp"
        break;
      case 111: /* "binary constant value" */
/* Line 1398 of yacc.c  */
#line 1415 "parser.ypp"
        { if (((*yyvaluep).binary)) ((*yyvaluep).binary)->deref(); };
/* Line 1398 of yacc.c  */
#line 4937 "parser.cpp"
        break;
      case 112: /* "regular expression substitution expression" */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).RegexSubst); };
/* Line 1398 of yacc.c  */
#line 4944 "parser.cpp"
        break;
      case 113: /* "transliteration expression" */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).RegexTrans); };
/* Line 1398 of yacc.c  */
#line 4951 "parser.cpp"
        break;
      case 114: /* "scoped class declaration" */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).nscope); };
/* Line 1398 of yacc.c  */
#line 4958 "parser.cpp"
        break;
      case 115: /* "call to base class method" */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).nscope); };
/* Line 1398 of yacc.c  */
#line 4965 "parser.cpp"
        break;
      case 116: /* "regular expression" */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).Regex); };
/* Line 1398 of yacc.c  */
#line 4972 "parser.cpp"
        break;
      case 117: /* "regular expression extraction expression" */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).Regex); };
/* Line 1398 of yacc.c  */
#line 4979 "parser.cpp"
        break;
      case 118: /* "implicit argument reference" */
/* Line 1398 of yacc.c  */
#line 1415 "parser.ypp"
        { if (((*yyvaluep).implicit_arg)) ((*yyvaluep).implicit_arg)->deref(); };
/* Line 1398 of yacc.c  */
#line 4986 "parser.cpp"
        break;
      case 119: /* "keyword used as hash key or object member reference" */
/* Line 1398 of yacc.c  */
#line 1415 "parser.ypp"
        { if (((*yyvaluep).String)) ((*yyvaluep).String)->deref(); };
/* Line 1398 of yacc.c  */
#line 4993 "parser.cpp"
        break;
      case 120: /* "%try-module error token" */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).trymod); };
/* Line 1398 of yacc.c  */
#line 5000 "parser.cpp"
        break;
      case 154: /* gvardecl */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).gv); };
/* Line 1398 of yacc.c  */
#line 5007 "parser.cpp"
        break;
      case 155: /* top_namespace_decl */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).ns); };
/* Line 1398 of yacc.c  */
#line 5014 "parser.cpp"
        break;
      case 156: /* namespace_decls */
/* Line 1398 of yacc.c  */
#line 1415 "parser.ypp"
        { if (((*yyvaluep).nsnlist)) ((*yyvaluep).nsnlist)->deref(); };
/* Line 1398 of yacc.c  */
#line 5021 "parser.cpp"
        break;
      case 157: /* namespace_decl */
/* Line 1398 of yacc.c  */
#line 1415 "parser.ypp"
        { if (((*yyvaluep).nsn)) ((*yyvaluep).nsn)->deref(); };
/* Line 1398 of yacc.c  */
#line 5028 "parser.cpp"
        break;
      case 158: /* unscoped_const_decl */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).constnode); };
/* Line 1398 of yacc.c  */
#line 5035 "parser.cpp"
        break;
      case 159: /* scoped_const_decl */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).constnode); };
/* Line 1398 of yacc.c  */
#line 5042 "parser.cpp"
        break;
      case 160: /* block */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).sblock); };
/* Line 1398 of yacc.c  */
#line 5049 "parser.cpp"
        break;
      case 161: /* statement_or_block */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).sblock); };
/* Line 1398 of yacc.c  */
#line 5056 "parser.cpp"
        break;
      case 162: /* statements */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).sblock); };
/* Line 1398 of yacc.c  */
#line 5063 "parser.cpp"
        break;
      case 163: /* optname */
/* Line 1398 of yacc.c  */
#line 1414 "parser.ypp"
        { free(((*yyvaluep).string)); };
/* Line 1398 of yacc.c  */
#line 5070 "parser.cpp"
        break;
      case 164: /* statement */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).statement); };
/* Line 1398 of yacc.c  */
#line 5077 "parser.cpp"
        break;
      case 165: /* context_mods */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).cmods); };
/* Line 1398 of yacc.c  */
#line 5084 "parser.cpp"
        break;
      case 166: /* context_mod */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).cmod); };
/* Line 1398 of yacc.c  */
#line 5091 "parser.cpp"
        break;
      case 167: /* return_statement */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).statement); };
/* Line 1398 of yacc.c  */
#line 5098 "parser.cpp"
        break;
      case 168: /* switch_statement */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).statement); };
/* Line 1398 of yacc.c  */
#line 5105 "parser.cpp"
        break;
      case 169: /* case_block */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).switchstmt); };
/* Line 1398 of yacc.c  */
#line 5112 "parser.cpp"
        break;
      case 170: /* case_code */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).casenode); };
/* Line 1398 of yacc.c  */
#line 5119 "parser.cpp"
        break;
      case 171: /* try_statement */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).statement); };
/* Line 1398 of yacc.c  */
#line 5126 "parser.cpp"
        break;
      case 172: /* myexp */
/* Line 1398 of yacc.c  */
#line 1416 "parser.ypp"
        { if (((*yyvaluep).node)) ((*yyvaluep).node)->deref(0); };
/* Line 1398 of yacc.c  */
#line 5133 "parser.cpp"
        break;
      case 173: /* class_def */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).classdef); };
/* Line 1398 of yacc.c  */
#line 5140 "parser.cpp"
        break;
      case 174: /* inheritance_list */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).sclist); };
/* Line 1398 of yacc.c  */
#line 5147 "parser.cpp"
        break;
      case 175: /* superclass_list */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).sclist); };
/* Line 1398 of yacc.c  */
#line 5154 "parser.cpp"
        break;
      case 176: /* superclass */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).sclnode); };
/* Line 1398 of yacc.c  */
#line 5161 "parser.cpp"
        break;
      case 177: /* class_attributes */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).qoreclass); };
/* Line 1398 of yacc.c  */
#line 5168 "parser.cpp"
        break;
      case 178: /* uncqtypedef */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).parsertype); };
/* Line 1398 of yacc.c  */
#line 5175 "parser.cpp"
        break;
      case 179: /* qtypedef */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).parsertype); };
/* Line 1398 of yacc.c  */
#line 5182 "parser.cpp"
        break;
      case 180: /* private_member_list */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).memberlist); };
/* Line 1398 of yacc.c  */
#line 5189 "parser.cpp"
        break;
      case 181: /* public_member_list */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).memberlist); };
/* Line 1398 of yacc.c  */
#line 5196 "parser.cpp"
        break;
      case 182: /* classvardecl */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).classvarinfo); };
/* Line 1398 of yacc.c  */
#line 5203 "parser.cpp"
        break;
      case 183: /* member2 */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).memberinfo); };
/* Line 1398 of yacc.c  */
#line 5210 "parser.cpp"
        break;
      case 184: /* member */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).memberinfo); };
/* Line 1398 of yacc.c  */
#line 5217 "parser.cpp"
        break;
      case 185: /* member_list */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).memberlist); };
/* Line 1398 of yacc.c  */
#line 5224 "parser.cpp"
        break;
      case 186: /* member_list2 */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).memberlist); };
/* Line 1398 of yacc.c  */
#line 5231 "parser.cpp"
        break;
      case 187: /* ident_openparen */
/* Line 1398 of yacc.c  */
#line 1414 "parser.ypp"
        { free(((*yyvaluep).string)); };
/* Line 1398 of yacc.c  */
#line 5238 "parser.cpp"
        break;
      case 188: /* method_definition */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).methodnode); };
/* Line 1398 of yacc.c  */
#line 5245 "parser.cpp"
        break;
      case 190: /* base_constructor_list */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).bcalist); };
/* Line 1398 of yacc.c  */
#line 5252 "parser.cpp"
        break;
      case 191: /* base_constructors */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).bcalist); };
/* Line 1398 of yacc.c  */
#line 5259 "parser.cpp"
        break;
      case 192: /* base_constructor */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).bcanode); };
/* Line 1398 of yacc.c  */
#line 5266 "parser.cpp"
        break;
      case 196: /* return_value */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).returnTypeInfo); };
/* Line 1398 of yacc.c  */
#line 5273 "parser.cpp"
        break;
      case 197: /* sub_def */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).parsefunc); };
/* Line 1398 of yacc.c  */
#line 5280 "parser.cpp"
        break;
      case 198: /* scoped_sub_def */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).sparsefunc); };
/* Line 1398 of yacc.c  */
#line 5287 "parser.cpp"
        break;
      case 199: /* list */
/* Line 1398 of yacc.c  */
#line 1416 "parser.ypp"
        { if (((*yyvaluep).list)) ((*yyvaluep).list)->deref(0); };
/* Line 1398 of yacc.c  */
#line 5294 "parser.cpp"
        break;
      case 200: /* hash */
/* Line 1398 of yacc.c  */
#line 1416 "parser.ypp"
        { if (((*yyvaluep).hash)) ((*yyvaluep).hash)->deref(0); };
/* Line 1398 of yacc.c  */
#line 5301 "parser.cpp"
        break;
      case 201: /* hash_element */
/* Line 1398 of yacc.c  */
#line 1413 "parser.ypp"
        { delete ((*yyvaluep).hashelement); };
/* Line 1398 of yacc.c  */
#line 5308 "parser.cpp"
        break;
      case 202: /* exp */
/* Line 1398 of yacc.c  */
#line 1416 "parser.ypp"
        { if (((*yyvaluep).node)) ((*yyvaluep).node)->deref(0); };
/* Line 1398 of yacc.c  */
#line 5315 "parser.cpp"
        break;
      case 203: /* string */
/* Line 1398 of yacc.c  */
#line 1415 "parser.ypp"
        { if (((*yyvaluep).String)) ((*yyvaluep).String)->deref(); };
/* Line 1398 of yacc.c  */
#line 5322 "parser.cpp"
        break;
      case 204: /* scalar */
/* Line 1398 of yacc.c  */
#line 1416 "parser.ypp"
        { if (((*yyvaluep).node)) ((*yyvaluep).node)->deref(0); };
/* Line 1398 of yacc.c  */
#line 5329 "parser.cpp"
        break;

      default:
        break;
    }
}




/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (yyscan_t yyscanner)
#else
int
yyparse (yyscanner)
    yyscan_t yyscanner;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;


#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
static YYSTYPE yyval_default;
# define YY_INITIAL_VALUE(Value) = Value
#endif
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc = yyloc_default;


    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
/* Line 1792 of yacc.c  */
#line 1425 "parser.ypp"
    {
           (yyvsp[(1) - (1)].parsefunc)->add(*(qore_ns_private::get(*(getRootNS()))));
        }
    break;

  case 5:
/* Line 1792 of yacc.c  */
#line 1428 "parser.ypp"
    {
           (yyvsp[(1) - (1)].sparsefunc)->add(*(qore_ns_private::get(*(getRootNS()))));
        }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 1431 "parser.ypp"
    {
           qore_root_ns_private::parseAddClass(*((yyvsp[(1) - (1)].classdef)->name), (yyvsp[(1) - (1)].classdef)->oc);

	   // see if class definitions are allowed
	   if (checkParseOption(PO_NO_CLASS_DEFS))
	      parse_error("illegal class definition \"%s\" (conflicts with parse option NO_CLASS_DEFS)", (yyvsp[(1) - (1)].classdef)->oc->getName());
	   delete (yyvsp[(1) - (1)].classdef);
	}
    break;

  case 7:
/* Line 1792 of yacc.c  */
#line 1439 "parser.ypp"
    {
           qore_root_ns_private::parseAddConstant(*getRootNS(), (yyvsp[(1) - (1)].constnode)->name, (yyvsp[(1) - (1)].constnode)->value, (yyvsp[(1) - (1)].constnode)->pub);
	   delete (yyvsp[(1) - (1)].constnode);
	}
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 1443 "parser.ypp"
    {
           qore_root_ns_private::parseAddConstant(*getRootNS(), (yyvsp[(1) - (1)].constnode)->name, (yyvsp[(1) - (1)].constnode)->value, (yyvsp[(1) - (1)].constnode)->pub);
	   delete (yyvsp[(1) - (1)].constnode);
	}
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 1448 "parser.ypp"
    {
	   if ((yyvsp[(1) - (1)].statement)) {
	      if ((yyvsp[(1) - (1)].statement)->isParseDeclaration())
		 delete (yyvsp[(1) - (1)].statement);
	      else
	         qore_program_private::addStatement(*(getProgram()), (yyvsp[(1) - (1)].statement));
	   }
	}
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 1456 "parser.ypp"
    {
	   // set line range
	   (yyvsp[(2) - (3)].sblock)->loc.start_line = (yylsp[(1) - (3)]).first_line;
	   (yyvsp[(2) - (3)].sblock)->loc.end_line = (yylsp[(2) - (3)]).last_line;
	   qore_program_private::addStatement(*(getProgram()), (yyvsp[(2) - (3)].sblock));
        }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 1462 "parser.ypp"
    {
           qore_root_ns_private::parseAddNamespace((yyvsp[(1) - (1)].ns)); 
	   // see if ns declaration is legal
	   if (checkParseOption(PO_NO_NAMESPACE_DEFS))
	      parse_error("illegal namespace definition \"%s\" (conflicts with parse option NO_NAMESPACE_DEFINITION)", (yyvsp[(1) - (1)].ns)->getName());
	}
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 1468 "parser.ypp"
    {
           QoreModuleDefContext* qmd = get_module_def_context();
           if (!qmd)
              qore_program_private::makeParseWarning(getProgram(), QP_WARN_MODULE_ONLY, "MODULE-ONLY", "module definitions are ignored when not defining a module");

           // registered internally
        }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 1475 "parser.ypp"
    {
           bool has_dollar = (yyvsp[(1) - (1)].trymod)->var[0] == '$';
           if (!has_dollar) {
              if (!checkParseOption(PO_ALLOW_BARE_REFS))
                 parse_error("%%try-module variable '%s' declared without '$' prefix, but parse option 'allow-bare-refs' is not set", (yyvsp[(1) - (1)].trymod)->var);
           }
           else {
              (yyvsp[(1) - (1)].trymod)->fixName();
              if (checkParseOption(PO_ALLOW_BARE_REFS))
                 parse_error("%%try-module variable '%s' declared with '$' prefix, but parse option 'allow-bare-refs' is set", (yyvsp[(1) - (1)].trymod)->var);
           }

           if (checkParseOption(PO_NO_TOP_LEVEL_STATEMENTS)) {
              parse_error("'%%try-module' with exception variable cannot be used with parse option NO_TOP_LEVEL_STATEMENTS; use %%try-module without an exception variable instead");
              delete (yyvsp[(1) - (1)].trymod);
           }
           else {
              VarRefTryModuleErrorNode* left = new VarRefTryModuleErrorNode((yylsp[(1) - (1)]).first_line, (yylsp[(1) - (1)]).last_line, (yyvsp[(1) - (1)].trymod)->takeName());
              QoreAssignmentOperatorNode* exp = new QoreAssignmentOperatorNode(left, (yyvsp[(1) - (1)].trymod)->takeExceptionHash());
              qore_program_private::addStatement(*(getProgram()), new ExpressionStatement((yylsp[(1) - (1)]).first_line, (yylsp[(1) - (1)]).last_line, exp));
           }
        }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 1500 "parser.ypp"
    {
        }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 1502 "parser.ypp"
    {
        }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 1507 "parser.ypp"
    {
           QoreModuleDefContext* qmd = get_module_def_context();
           if (!qmd)
              qore_program_private::makeParseWarning(getProgram(), QP_WARN_MODULE_ONLY, "MODULE-ONLY", "cannot add module tag '%s' = <%s> when not defining a module", (yyvsp[(1) - (4)].string), get_type_name((yyvsp[(3) - (4)].node)));
           else
              qmd->set((yyvsp[(1) - (4)].string), (yyvsp[(3) - (4)].node));

           free((yyvsp[(1) - (4)].string));
           (yyvsp[(3) - (4)].node)->deref(0);
        }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 1520 "parser.ypp"
    { (yyval.b) = false; }
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 1521 "parser.ypp"
    {
           (yyval.b) = true;
        }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 1527 "parser.ypp"
    {
	   const QoreTypeInfo* t = (yyvsp[(3) - (4)].parsertype)->getTypeInfo();
           (yyval.gv) = new GVarSingleDecl((yyvsp[(4) - (4)].string), t, t ? 0 : (yyvsp[(3) - (4)].parsertype)->getParseTypeInfo(), (yyvsp[(1) - (4)].b), true);
           delete (yyvsp[(3) - (4)].parsertype);
	}
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 1532 "parser.ypp"
    {
           (yyval.gv) = new GVarSingleDecl((yyvsp[(3) - (3)].string), 0, 0, (yyvsp[(1) - (3)].b), true);
        }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 1535 "parser.ypp"
    {
	   const QoreTypeInfo* t = (yyvsp[(3) - (4)].parsertype)->getTypeInfo();
           (yyval.gv) = new GVarSingleDecl((yyvsp[(4) - (4)].string), t, t ? 0 : (yyvsp[(3) - (4)].parsertype)->getParseTypeInfo(), (yyvsp[(1) - (4)].b), true);
           delete (yyvsp[(3) - (4)].parsertype);
	}
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 1540 "parser.ypp"
    {
           (yyval.gv) = new GVarSingleDecl((yyvsp[(3) - (3)].string), 0, 0, (yyvsp[(1) - (3)].b), true);
	}
    break;

  case 24:
/* Line 1792 of yacc.c  */
#line 1543 "parser.ypp"
    {
	   const QoreTypeInfo* t = (yyvsp[(3) - (4)].parsertype)->getTypeInfo();
           (yyval.gv) = new GVarSingleDecl((yyvsp[(4) - (4)].string), t, t ? 0 : (yyvsp[(3) - (4)].parsertype)->getParseTypeInfo(), (yyvsp[(1) - (4)].b), false);
           delete (yyvsp[(3) - (4)].parsertype);
	}
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 1548 "parser.ypp"
    {
	   const QoreTypeInfo* t = (yyvsp[(3) - (4)].parsertype)->getTypeInfo();
           (yyval.gv) = new GVarSingleDecl((yyvsp[(4) - (4)].string), t, t ? 0 : (yyvsp[(3) - (4)].parsertype)->getParseTypeInfo(), (yyvsp[(1) - (4)].b), false);
           delete (yyvsp[(3) - (4)].parsertype);
	}
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 1553 "parser.ypp"
    {
           (yyval.gv) = new GVarListDecl((yyvsp[(4) - (5)].list), (yyvsp[(1) - (5)].b));
        }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 1559 "parser.ypp"
    {
           qore_ns_private* p = new qore_ns_private;
           check_nsmod((yyvsp[(1) - (5)].i4), *p);
           (yyvsp[(4) - (5)].nsnlist)->add(*p);
           delete (yyvsp[(4) - (5)].nsnlist);
           (yyval.ns) = p->ns;
        }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 1566 "parser.ypp"
    {
           qore_ns_private* p = new qore_ns_private;
           check_nsmod((yyvsp[(1) - (3)].i4), *p);
           (yyval.ns) = p->ns;
        }
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 1571 "parser.ypp"
    {
           qore_ns_private* p = new qore_ns_private;
           check_nsmod((yyvsp[(1) - (4)].i4), *p);
           (yyval.ns) = p->ns;
        }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 1579 "parser.ypp"
    {
	   (yyval.nsnlist) = new NSNodeList;
	   (yyval.nsnlist)->push_back((yyvsp[(1) - (1)].nsn));
        }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 1583 "parser.ypp"
    {
           (yyval.nsnlist) = (yyvsp[(1) - (2)].nsnlist);
           (yyval.nsnlist)->push_back((yyvsp[(2) - (2)].nsn));
	}
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 1590 "parser.ypp"
    {
	   (yyval.nsn) = new NSNode((yyvsp[(1) - (1)].constnode));
        }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 1593 "parser.ypp"
    {
	   (yyval.nsn) = new NSNode((yyvsp[(1) - (1)].constnode));
	}
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 1596 "parser.ypp"
    {
	   (yyval.nsn) = new NSNode((yyvsp[(1) - (1)].classdef));
	   // see if class definitions are allowed
	   if (checkParseOption(PO_NO_CLASS_DEFS))
	      parse_error("illegal class definition \"%s\" (conflicts with parse option NO_CLASS_DEFS)", (yyvsp[(1) - (1)].classdef)->oc->getName());
	}
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 1602 "parser.ypp"
    {
           (yyval.nsn) = new NSNode((yyvsp[(1) - (1)].parsefunc));
        }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 1605 "parser.ypp"
    {
           (yyval.nsn) = new NSNode((yyvsp[(1) - (1)].sparsefunc));
        }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 1608 "parser.ypp"
    {
           (yyval.nsn) = new NSNode((yyvsp[(1) - (2)].gv));
        }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 1611 "parser.ypp"
    { 
	   (yyval.nsn) = new NSNode((yyvsp[(1) - (1)].ns)); 
	   // see if ns declaration is legal
	   if (checkParseOption(PO_NO_NAMESPACE_DEFS))
	      parse_error("illegal namespace definition \"%s\" (conflicts with parse option NO_NAMESPACE_DEFINITION)", (yyvsp[(1) - (1)].ns)->getName());
	}
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 1619 "parser.ypp"
    { 
	   (yyval.constnode) = new ConstNode((yyvsp[(2) - (5)].string), (yyvsp[(4) - (5)].node)); 
	}
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 1622 "parser.ypp"
    { 
	   (yyval.constnode) = new ConstNode((yyvsp[(3) - (6)].string), (yyvsp[(5) - (6)].node), true); 
	}
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 1628 "parser.ypp"
    {
	   (yyval.constnode) = new ConstNode((yyvsp[(2) - (5)].string), (yyvsp[(4) - (5)].node)); 
	}
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 1631 "parser.ypp"
    {
	   (yyval.constnode) = new ConstNode((yyvsp[(3) - (6)].string), (yyvsp[(5) - (6)].node), true); 
	}
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 1638 "parser.ypp"
    { (yyval.sblock) = (yyvsp[(2) - (3)].sblock); }
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 1641 "parser.ypp"
    { (yyval.sblock) = 0; }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 1646 "parser.ypp"
    { (yyval.sblock) = new StatementBlock((yylsp[(1) - (1)]).first_line, (yylsp[(1) - (1)]).last_line, (yyvsp[(1) - (1)].statement)); }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 1649 "parser.ypp"
    { (yyval.sblock) = (yyvsp[(1) - (1)].sblock); }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 1654 "parser.ypp"
    { (yyval.sblock) = new StatementBlock((yylsp[(1) - (1)]).first_line, (yylsp[(1) - (1)]).last_line, (yyvsp[(1) - (1)].statement)); }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 1656 "parser.ypp"
    { (yyval.sblock) = new StatementBlock((yylsp[(1) - (1)]).first_line, (yylsp[(1) - (1)]).last_line, (yyvsp[(1) - (1)].sblock)); }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 1658 "parser.ypp"
    { (yyvsp[(1) - (2)].sblock)->addStatement((yyvsp[(2) - (2)].sblock)); (yyval.sblock) = (yyvsp[(1) - (2)].sblock); }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 1660 "parser.ypp"
    { (yyvsp[(1) - (2)].sblock)->addStatement((yyvsp[(2) - (2)].statement)); (yyval.sblock) = (yyvsp[(1) - (2)].sblock); }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 1665 "parser.ypp"
    { (yyval.string) = 0; }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 1666 "parser.ypp"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 1670 "parser.ypp"
    {
	   // if the expression has no effect and it's not a variable declaration
	   qore_type_t t = (yyvsp[(1) - (2)].node) ? (yyvsp[(1) - (2)].node)->getType() : 0;
	   bool ok = false;
	   if (t == NT_LIST) {
	      QoreListNode* l = reinterpret_cast<QoreListNode*>((yyvsp[(1) - (2)].node));
	      // rewrite expression if it's a list without parentheses under certain conditions
	      (yyvsp[(1) - (2)].node) = checkRewriteList(l);

	      if (l->isVariableList())
		 ok = true;
	   }

	   if (!ok && !hasEffect((yyvsp[(1) - (2)].node)) && (t != NT_VARREF || !reinterpret_cast<VarRefNode*>((yyvsp[(1) - (2)].node))->parseIsDecl()))
	      parse_error("statement has no effect (%s)", (yyvsp[(1) - (2)].node) ? (yyvsp[(1) - (2)].node)->getTypeName() : "NOTHING");
           ignore_return_value((yyvsp[(1) - (2)].node));
	   (yyval.statement) = new ExpressionStatement((yylsp[(1) - (2)]).first_line, (yylsp[(1) - (2)]).last_line, (yyvsp[(1) - (2)].node));
	}
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 1689 "parser.ypp"
    {
	   NamedScope *ns = new NamedScope((yyvsp[(1) - (5)].string));
	   assert(ns->size() > 1);
	   printd(5, "statement: parsing static method call: %s() size=%d\n", ns->ostr, ns->size());
	   (yyval.statement) = new ExpressionStatement((yylsp[(1) - (5)]).first_line, (yylsp[(1) - (5)]).last_line, new StaticMethodCallNode(ns, makeArgs((yyvsp[(3) - (5)].node))));
	}
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 1696 "parser.ypp"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 1697 "parser.ypp"
    {
	   (yyval.statement) = new RethrowStatement((yylsp[(1) - (2)]).first_line, (yylsp[(1) - (2)]).last_line);
	}
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 1700 "parser.ypp"
    {
	   (yyval.statement) = new ThrowStatement((yylsp[(1) - (3)]).first_line, (yylsp[(2) - (3)]).last_line, (yyvsp[(2) - (3)].node));
	}
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 1703 "parser.ypp"
    {
	   (yyval.statement) = new OnBlockExitStatement((yylsp[(1) - (2)]).first_line, (yylsp[(2) - (2)]).last_line, (yyvsp[(2) - (2)].sblock), OBE_Unconditional);
	}
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 1706 "parser.ypp"
    {
	   (yyval.statement) = new OnBlockExitStatement((yylsp[(1) - (2)]).first_line, (yylsp[(2) - (2)]).last_line, (yyvsp[(2) - (2)].sblock), OBE_Success);
	}
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 1709 "parser.ypp"
    {
	   (yyval.statement) = new OnBlockExitStatement((yylsp[(1) - (2)]).first_line, (yylsp[(2) - (2)]).last_line, (yyvsp[(2) - (2)].sblock), OBE_Error);
	}
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 1712 "parser.ypp"
    {
	   (yyval.statement) = new ContextStatement((yylsp[(1) - (3)]).first_line, (yylsp[(3) - (3)]).last_line, 0, 0, (yyvsp[(2) - (3)].cmods), (yyvsp[(3) - (3)].sblock));
	}
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 1715 "parser.ypp"
    {
	   (yyval.statement) = new SummarizeStatement((yylsp[(1) - (11)]).first_line, (yylsp[(11) - (11)]).last_line, (yyvsp[(2) - (11)].string), (yyvsp[(4) - (11)].node), (yyvsp[(10) - (11)].cmods), (yyvsp[(11) - (11)].sblock), (yyvsp[(8) - (11)].node));
	}
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 1718 "parser.ypp"
    {
	   (yyval.statement) = new ContextStatement((yylsp[(1) - (7)]).first_line, (yylsp[(7) - (7)]).last_line, (yyvsp[(2) - (7)].string), (yyvsp[(4) - (7)].node), (yyvsp[(6) - (7)].cmods), (yyvsp[(7) - (7)].sblock));
        }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 1721 "parser.ypp"
    {	
	   (yyval.statement) = new IfStatement((yylsp[(1) - (5)]).first_line, (yylsp[(5) - (5)]).last_line, (yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].sblock));
	}
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 1724 "parser.ypp"
    {
	   (yyval.statement) = new IfStatement((yylsp[(1) - (7)]).first_line, (yylsp[(7) - (7)]).last_line, (yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].sblock), (yyvsp[(7) - (7)].sblock));
	}
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 1727 "parser.ypp"
    {
	   (yyval.statement) = new WhileStatement((yylsp[(1) - (5)]).first_line, (yylsp[(5) - (5)]).last_line, (yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].sblock));
	}
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 1730 "parser.ypp"
    {
	   (yyval.statement) = new DoWhileStatement((yylsp[(1) - (7)]).first_line, (yylsp[(5) - (7)]).last_line, (yyvsp[(5) - (7)].node), (yyvsp[(2) - (7)].sblock));
	}
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 1733 "parser.ypp"
    {
	   (yyval.statement) = new ForStatement((yylsp[(1) - (9)]).first_line, (yylsp[(9) - (9)]).last_line, (yyvsp[(3) - (9)].node), (yyvsp[(5) - (9)].node), (yyvsp[(7) - (9)].node), (yyvsp[(9) - (9)].sblock));
	}
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 1736 "parser.ypp"
    {
	   (yyval.statement) = new ForEachStatement((yylsp[(1) - (7)]).first_line, (yylsp[(7) - (7)]).last_line, (yyvsp[(2) - (7)].node), (yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].sblock));
	}
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 1739 "parser.ypp"
    { (yyval.statement) = (yyvsp[(1) - (2)].statement); }
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 1740 "parser.ypp"
    {
	   // see if thread exit is allowed
	   if (checkParseOption(PO_NO_THREAD_CONTROL))
	      parse_error("illegal use of \"thread_exit\" (conflicts with parse option NO_THREAD_CONTROL)");

	   (yyval.statement) = new ThreadExitStatement((yylsp[(1) - (2)]).first_line, (yylsp[(1) - (2)]).last_line); 
	}
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 1747 "parser.ypp"
    {
	  (yyval.statement) = new BreakStatement((yylsp[(1) - (2)]).first_line, (yylsp[(1) - (2)]).last_line);
	}
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 1750 "parser.ypp"
    {
	  (yyval.statement) = new ContinueStatement((yylsp[(1) - (2)]).first_line, (yylsp[(1) - (2)]).last_line);
	}
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 1753 "parser.ypp"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 1754 "parser.ypp"
    { (yyval.statement) = 0; }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 1759 "parser.ypp"
    { (yyval.cmods) = 0; }
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 1760 "parser.ypp"
    { 
	   if (!(yyvsp[(1) - (2)].cmods)) 
	      (yyval.cmods) = new ContextModList((yyvsp[(2) - (2)].cmod)); 
	   else { 
	      (yyvsp[(1) - (2)].cmods)->addContextMod((yyvsp[(2) - (2)].cmod)); 
	      (yyval.cmods) = (yyvsp[(1) - (2)].cmods); 
	   }
	}
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 1772 "parser.ypp"
    { (yyval.cmod) = new ContextMod(CM_WHERE_NODE, (yyvsp[(3) - (4)].node)); }
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 1774 "parser.ypp"
    { (yyval.cmod) = new ContextMod(CM_SORT_ASCENDING, (yyvsp[(3) - (4)].node)); }
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 1776 "parser.ypp"
    { (yyval.cmod) = new ContextMod(CM_SORT_DESCENDING, (yyvsp[(3) - (4)].node)); }
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 1780 "parser.ypp"
    { (yyval.statement) = new ReturnStatement((yylsp[(1) - (1)]).first_line, (yylsp[(1) - (1)]).last_line); }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 1782 "parser.ypp"
    { (yyval.statement) = new ReturnStatement((yylsp[(1) - (2)]).first_line, (yylsp[(2) - (2)]).last_line, (yyvsp[(2) - (2)].node)); }
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 1787 "parser.ypp"
    {
	   (yyvsp[(6) - (7)].switchstmt)->setSwitch((yyvsp[(3) - (7)].node));
	   (yyval.statement) = (yyvsp[(6) - (7)].switchstmt);
	   (yyval.statement)->loc.start_line = (yylsp[(1) - (7)]).first_line;
	   (yyval.statement)->loc.end_line = (yylsp[(7) - (7)]).last_line;
        }
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 1797 "parser.ypp"
    {
	   (yyval.switchstmt) = new SwitchStatement((yyvsp[(1) - (1)].casenode));
	}
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 1801 "parser.ypp"
    {
	   (yyvsp[(1) - (2)].switchstmt)->addCase((yyvsp[(2) - (2)].casenode));
	   (yyval.switchstmt) = (yyvsp[(1) - (2)].switchstmt);
        }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 1809 "parser.ypp"
    {
	   check_case(">=", (yyvsp[(3) - (5)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].sblock), OP_LOG_GE);
        }
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 1814 "parser.ypp"
    {
	   check_case(">=", (yyvsp[(3) - (4)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (4)].node), 0, OP_LOG_GE);
        }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 1820 "parser.ypp"
    {
	   check_case("<=", (yyvsp[(3) - (5)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].sblock), OP_LOG_LE);
        }
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 1825 "parser.ypp"
    {
	   check_case("<=", (yyvsp[(3) - (4)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (4)].node), 0, OP_LOG_LE);
        }
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 1831 "parser.ypp"
    {
	   check_case("==", (yyvsp[(3) - (5)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].sblock), OP_LOG_EQ);
        }
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 1836 "parser.ypp"
    {
	   check_case("==", (yyvsp[(3) - (4)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (4)].node), 0, OP_LOG_EQ);
        }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 1842 "parser.ypp"
    {
	   check_case("<", (yyvsp[(3) - (5)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].sblock), OP_LOG_LT);
        }
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 1847 "parser.ypp"
    {
	   check_case("<", (yyvsp[(3) - (4)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (4)].node), 0, OP_LOG_LT);
        }
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 1853 "parser.ypp"
    {
	   check_case(">", (yyvsp[(3) - (5)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].sblock), OP_LOG_GT);
        }
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 1858 "parser.ypp"
    {
	   check_case(">", (yyvsp[(3) - (4)].node));
	   (yyval.casenode) = new CaseNodeWithOperator((yyvsp[(3) - (4)].node), 0, OP_LOG_GT);
        }
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 1864 "parser.ypp"
    {
	   (yyval.casenode) = new CaseNodeRegex((yyvsp[(3) - (5)].Regex), (yyvsp[(5) - (5)].sblock));
	}
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 1868 "parser.ypp"
    {
	   (yyval.casenode) = new CaseNodeRegex((yyvsp[(3) - (4)].Regex), 0);
	}
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 1873 "parser.ypp"
    {
	   (yyval.casenode) = new CaseNodeNegRegex((yyvsp[(3) - (5)].Regex), (yyvsp[(5) - (5)].sblock));
	}
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 1877 "parser.ypp"
    {
	   (yyval.casenode) = new CaseNodeNegRegex((yyvsp[(3) - (4)].Regex), 0);
	}
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 1882 "parser.ypp"
    {
	   (yyval.casenode) = new CaseNodeRegex((yyvsp[(2) - (4)].Regex), (yyvsp[(4) - (4)].sblock));
	}
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 1886 "parser.ypp"
    {
	   (yyval.casenode) = new CaseNodeRegex((yyvsp[(2) - (3)].Regex), 0);
	}
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 1891 "parser.ypp"
    {
	   check_case(0, (yyvsp[(2) - (4)].node));
	   (yyval.casenode) = new CaseNode((yyvsp[(2) - (4)].node), (yyvsp[(4) - (4)].sblock));
	}
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 1896 "parser.ypp"
    {
	   check_case(0, (yyvsp[(2) - (3)].node));
	   (yyval.casenode) = new CaseNode((yyvsp[(2) - (3)].node), 0);
	}
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 1902 "parser.ypp"
    {
	   (yyval.casenode) = new CaseNode(0, (yyvsp[(3) - (3)].sblock));
	}
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 1906 "parser.ypp"
    {
	   (yyval.casenode) = new CaseNode(0, 0);
	}
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 1912 "parser.ypp"
    {
	   char* param = 0;
	   if ((yyvsp[(5) - (7)].node)) {
	      if ((yyvsp[(5) - (7)].node)->getType() == NT_VARREF) 
		 param = reinterpret_cast<VarRefNode*>((yyvsp[(5) - (7)].node))->takeName();
	      else if ((yyvsp[(5) - (7)].node)->getType() == NT_BAREWORD) {
		 param = reinterpret_cast<BarewordNode*>((yyvsp[(5) - (7)].node))->takeString();
		 if (!checkParseOption(PO_ALLOW_BARE_REFS))
		    parse_error("local variable '%s' in catch parameter list declared without '$' prefix, but parse option 'allow-bare-refs' is not set", param);
	      }
	      else
		 parse_error("only one parameter accepted in catch block for exception hash");
	      (yyvsp[(5) - (7)].node)->deref(0);
	   }
	   (yyval.statement) = new TryStatement((yylsp[(1) - (7)]).first_line, (yylsp[(7) - (7)]).last_line, (yyvsp[(2) - (7)].sblock), (yyvsp[(7) - (7)].sblock), param);
	}
    break;

  case 107:
/* Line 1792 of yacc.c  */
#line 1930 "parser.ypp"
    { (yyval.node) = 0; }
    break;

  case 108:
/* Line 1792 of yacc.c  */
#line 1931 "parser.ypp"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 109:
/* Line 1792 of yacc.c  */
#line 1932 "parser.ypp"
    { (yyval.node) = 0; }
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 1936 "parser.ypp"
    {
           check_classmod((yyvsp[(1) - (6)].i4), *((yyvsp[(5) - (6)].qoreclass)));
           qore_class_private::parseSetBaseClassList(*((yyvsp[(5) - (6)].qoreclass)), (yyvsp[(3) - (6)].sclist));
	   (yyval.classdef) = new ObjClassDef((yyvsp[(2) - (6)].string), (yyvsp[(5) - (6)].qoreclass));
	}
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 1941 "parser.ypp"
    {
           check_classmod((yyvsp[(1) - (6)].i4), *((yyvsp[(5) - (6)].qoreclass)));
	   (yyval.classdef) = new ObjClassDef((yyvsp[(2) - (6)].nscope), (yyvsp[(5) - (6)].qoreclass));
           qore_class_private::parseSetBaseClassList(*((yyvsp[(5) - (6)].qoreclass)), (yyvsp[(3) - (6)].sclist));
	}
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 1946 "parser.ypp"
    {
           // class name is set automatically from name saved in scanner
	   QoreClass *qc = new QoreClass;
           check_classmod((yyvsp[(1) - (4)].i4), *qc);
           qore_class_private::parseSetBaseClassList(*qc, (yyvsp[(3) - (4)].sclist));
	   (yyval.classdef) = new ObjClassDef((yyvsp[(2) - (4)].string), qc);
	}
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 1953 "parser.ypp"
    {
           // class name is set automatically from name saved in scanner
	   QoreClass *qc = new QoreClass;
           check_classmod((yyvsp[(1) - (4)].i4), *qc);
	   (yyval.classdef) = new ObjClassDef((yyvsp[(2) - (4)].nscope), qc);
           qore_class_private::parseSetBaseClassList(*qc, (yyvsp[(3) - (4)].sclist));
	}
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 1960 "parser.ypp"
    {
           // class name is set automatically from name saved in scanner
	   QoreClass *qc = new QoreClass;
           check_classmod((yyvsp[(1) - (5)].i4), *qc);
           qore_class_private::parseSetBaseClassList(*qc, (yyvsp[(3) - (5)].sclist));
	   (yyval.classdef) = new ObjClassDef((yyvsp[(2) - (5)].string), qc);
	}
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 1967 "parser.ypp"
    {
           // class name is set automatically from name saved in scanner
	   QoreClass *qc = new QoreClass;
           check_classmod((yyvsp[(1) - (5)].i4), *qc);
	   (yyval.classdef) = new ObjClassDef((yyvsp[(2) - (5)].nscope), qc);
           qore_class_private::parseSetBaseClassList(*qc, (yyvsp[(3) - (5)].sclist));
	}
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 1977 "parser.ypp"
    {
	   (yyval.sclist) = (yyvsp[(2) - (2)].sclist);
        }
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 1980 "parser.ypp"
    { // NOTHING
           (yyval.sclist) = 0;
	}
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 1986 "parser.ypp"
    {
	   (yyval.sclist) = new BCList((yyvsp[(1) - (1)].sclnode));
	}
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 1989 "parser.ypp"
    {
	   (yyvsp[(1) - (3)].sclist)->push_back((yyvsp[(3) - (3)].sclnode));
	   (yyval.sclist) = (yyvsp[(1) - (3)].sclist);
        }
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 1996 "parser.ypp"
    {
	   (yyval.sclnode) = new BCNode((yyvsp[(1) - (1)].string), false);
	}
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 1999 "parser.ypp"
    {
	   (yyval.sclnode) = new BCNode(new NamedScope((yyvsp[(1) - (1)].string)), false);
	}
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 2002 "parser.ypp"
    {
	   (yyval.sclnode) = new BCNode((yyvsp[(2) - (2)].string), false);
	}
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 2005 "parser.ypp"
    {
	   (yyval.sclnode) = new BCNode(new NamedScope((yyvsp[(2) - (2)].string)), false);
	}
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 2008 "parser.ypp"
    {
	   (yyval.sclnode) = new BCNode((yyvsp[(2) - (2)].string), true);
	}
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 2011 "parser.ypp"
    {
	   (yyval.sclnode) = new BCNode(new NamedScope((yyvsp[(2) - (2)].string)), true);
	}
    break;

  case 126:
/* Line 1792 of yacc.c  */
#line 2017 "parser.ypp"
    { 
           (yyval.qoreclass) = new QoreClass;
	   (yyvsp[(1) - (1)].methodnode)->addAndDelete((yyval.qoreclass));
	}
    break;

  case 127:
/* Line 1792 of yacc.c  */
#line 2021 "parser.ypp"
    {
	   (yyval.qoreclass) = new QoreClass;
	   (yyvsp[(1) - (1)].memberlist)->mergePrivate((yyval.qoreclass));
	   delete (yyvsp[(1) - (1)].memberlist);
	}
    break;

  case 128:
/* Line 1792 of yacc.c  */
#line 2026 "parser.ypp"
    {
	   (yyval.qoreclass) = new QoreClass;
	   (yyvsp[(1) - (1)].memberlist)->mergePublic((yyval.qoreclass));
	   delete (yyvsp[(1) - (1)].memberlist);
	}
    break;

  case 129:
/* Line 1792 of yacc.c  */
#line 2031 "parser.ypp"
    {
	   (yyval.qoreclass) = new QoreClass;
	   (yyval.qoreclass)->parseAddPublicConstant((yyvsp[(1) - (1)].constnode)->getName(), (yyvsp[(1) - (1)].constnode)->takeValue());
	   delete (yyvsp[(1) - (1)].constnode);
	}
    break;

  case 130:
/* Line 1792 of yacc.c  */
#line 2036 "parser.ypp"
    { 
	   (yyvsp[(2) - (2)].methodnode)->addAndDelete((yyvsp[(1) - (2)].qoreclass));
	   (yyval.qoreclass) = (yyvsp[(1) - (2)].qoreclass); 
	}
    break;

  case 131:
/* Line 1792 of yacc.c  */
#line 2040 "parser.ypp"
    { 
	   (yyvsp[(2) - (2)].memberlist)->mergePrivate((yyvsp[(1) - (2)].qoreclass));
	   (yyval.qoreclass) = (yyvsp[(1) - (2)].qoreclass);
	   delete (yyvsp[(2) - (2)].memberlist);
	}
    break;

  case 132:
/* Line 1792 of yacc.c  */
#line 2045 "parser.ypp"
    {
	   (yyvsp[(2) - (2)].memberlist)->mergePublic((yyvsp[(1) - (2)].qoreclass));
	   (yyval.qoreclass) = (yyvsp[(1) - (2)].qoreclass); 
	   delete (yyvsp[(2) - (2)].memberlist);
	}
    break;

  case 133:
/* Line 1792 of yacc.c  */
#line 2050 "parser.ypp"
    {
	   (yyval.qoreclass)->parseAddPublicConstant((yyvsp[(2) - (2)].constnode)->getName(), (yyvsp[(2) - (2)].constnode)->takeValue());
	   (yyval.qoreclass) = (yyvsp[(1) - (2)].qoreclass);
	   delete (yyvsp[(2) - (2)].constnode);
	}
    break;

  case 134:
/* Line 1792 of yacc.c  */
#line 2071 "parser.ypp"
    {
	   (yyval.parsertype) = new ParserTypeStruct((yyvsp[(1) - (1)].string));
	}
    break;

  case 135:
/* Line 1792 of yacc.c  */
#line 2074 "parser.ypp"
    {
	   (yyval.parsertype) = new ParserScopedTypeStruct((yyvsp[(1) - (1)].string));
        }
    break;

  case 136:
/* Line 1792 of yacc.c  */
#line 2077 "parser.ypp"
    {
	   (yyval.parsertype) = new ParserOrNothingTypeStruct((yyvsp[(2) - (2)].string));
        }
    break;

  case 137:
/* Line 1792 of yacc.c  */
#line 2080 "parser.ypp"
    {
	   (yyval.parsertype) = new ParserScopedOrNothingTypeStruct((yyvsp[(2) - (2)].string));
        }
    break;

  case 138:
/* Line 1792 of yacc.c  */
#line 2087 "parser.ypp"
    { (yyval.parsertype) = 0; }
    break;

  case 139:
/* Line 1792 of yacc.c  */
#line 2088 "parser.ypp"
    {
           (yyval.parsertype) = (yyvsp[(1) - (1)].parsertype);
        }
    break;

  case 140:
/* Line 1792 of yacc.c  */
#line 2094 "parser.ypp"
    {
	   (yyval.memberlist) = (yyvsp[(2) - (3)].memberlist);
	}
    break;

  case 141:
/* Line 1792 of yacc.c  */
#line 2097 "parser.ypp"
    {
	   (yyval.memberlist) = (yyvsp[(3) - (4)].memberlist);
	}
    break;

  case 142:
/* Line 1792 of yacc.c  */
#line 2103 "parser.ypp"
    {
	   (yyval.memberlist) = (yyvsp[(2) - (3)].memberlist);
	}
    break;

  case 143:
/* Line 1792 of yacc.c  */
#line 2106 "parser.ypp"
    {
	   (yyval.memberlist) = (yyvsp[(3) - (4)].memberlist);
	}
    break;

  case 144:
/* Line 1792 of yacc.c  */
#line 2109 "parser.ypp"
    {
	   (yyval.memberlist) = new EmptyPublicMemberList;
	}
    break;

  case 145:
/* Line 1792 of yacc.c  */
#line 2115 "parser.ypp"
    {
	   (yyval.classvarinfo) = new ClassVarInfo((yyvsp[(3) - (4)].string), new QoreVarInfo((yylsp[(2) - (4)]).first_line, (yylsp[(3) - (4)]).last_line, (yyvsp[(2) - (4)].parsertype)->getTypeInfo(), (yyvsp[(2) - (4)].parsertype)->getParseTypeInfo()));
	   delete (yyvsp[(2) - (4)].parsertype);
	}
    break;

  case 146:
/* Line 1792 of yacc.c  */
#line 2119 "parser.ypp"
    {
	   (yyval.classvarinfo) = new ClassVarInfo((yyvsp[(2) - (3)].string), new QoreVarInfo((yylsp[(2) - (3)]).first_line, (yylsp[(2) - (3)]).last_line));
	}
    break;

  case 147:
/* Line 1792 of yacc.c  */
#line 2122 "parser.ypp"
    {
	   (yyval.classvarinfo) = new ClassVarInfo((yyvsp[(3) - (6)].string), new QoreVarInfo((yylsp[(2) - (6)]).first_line, (yylsp[(5) - (6)]).last_line, (yyvsp[(2) - (6)].parsertype)->getTypeInfo(), (yyvsp[(2) - (6)].parsertype)->getParseTypeInfo(), (yyvsp[(5) - (6)].node)));
	   //printd(5, "new QoreVarInfo = %p (empty: %d)\n", $$->u.varInfo, $$->u.varInfo->empty());
	   delete (yyvsp[(2) - (6)].parsertype);
        }
    break;

  case 148:
/* Line 1792 of yacc.c  */
#line 2127 "parser.ypp"
    {
	   (yyval.classvarinfo) = new ClassVarInfo((yyvsp[(2) - (5)].string), new QoreVarInfo((yylsp[(2) - (5)]).first_line, (yylsp[(4) - (5)]).last_line, (yyvsp[(4) - (5)].node)));
	}
    break;

  case 149:
/* Line 1792 of yacc.c  */
#line 2130 "parser.ypp"
    {
	   const QoreTypeInfo* t = (yyvsp[(2) - (7)].parsertype)->getTypeInfo();
	   ScopedObjectCallNode* new_call = 0;

	   if (t)
	      parse_error("cannot call constructor for non-class base type '%s'", t->getName());
	   else
	      new_call = new ScopedObjectCallNode(new NamedScope(strdup((yyvsp[(2) - (7)].parsertype)->getClassName())), makeArgs((yyvsp[(5) - (7)].node)));

	   (yyval.classvarinfo) = new ClassVarInfo((yyvsp[(3) - (7)].string), new QoreVarInfo((yylsp[(2) - (7)]).first_line, (yylsp[(5) - (7)]).last_line, (yyvsp[(2) - (7)].parsertype)->getTypeInfo(), (yyvsp[(2) - (7)].parsertype)->getParseTypeInfo(), new_call));

	   delete (yyvsp[(2) - (7)].parsertype);
	}
    break;

  case 150:
/* Line 1792 of yacc.c  */
#line 2145 "parser.ypp"
    {
	   int fl = (yyvsp[(1) - (3)].parsertype) ? (yylsp[(1) - (3)]).first_line : (yylsp[(2) - (3)]).first_line;
	   (yyval.memberinfo) = new MemberInfo((yyvsp[(2) - (3)].string), new QoreMemberInfo(fl, (yylsp[(2) - (3)]).last_line, (yyvsp[(1) - (3)].parsertype)->getTypeInfo(), (yyvsp[(1) - (3)].parsertype)->getParseTypeInfo()));
	   delete (yyvsp[(1) - (3)].parsertype);
	   if (checkParseOption(PO_ALLOW_BARE_REFS))
	      parse_error("reference to '$.%s' with the '$.' prefix is not allowed when parse option 'allow-bare-refs' is set", (yyvsp[(2) - (3)].string));
	}
    break;

  case 151:
/* Line 1792 of yacc.c  */
#line 2152 "parser.ypp"
    {
	   int fl = (yyvsp[(1) - (5)].parsertype) ? (yylsp[(1) - (5)]).first_line : (yylsp[(2) - (5)]).first_line;
	   (yyval.memberinfo) = new MemberInfo((yyvsp[(2) - (5)].string), new QoreMemberInfo(fl, (yylsp[(4) - (5)]).last_line, (yyvsp[(1) - (5)].parsertype)->getTypeInfo(), (yyvsp[(1) - (5)].parsertype)->getParseTypeInfo(), (yyvsp[(4) - (5)].node)));
	   delete (yyvsp[(1) - (5)].parsertype);
	   if (checkParseOption(PO_ALLOW_BARE_REFS))
	      parse_error("reference to '$.%s' with the '$.' prefix is not allowed when parse option 'allow-bare-refs' is set", (yyvsp[(2) - (5)].string));
	}
    break;

  case 152:
/* Line 1792 of yacc.c  */
#line 2159 "parser.ypp"
    {
	   int fl = (yyvsp[(1) - (6)].parsertype) ? (yylsp[(1) - (6)]).first_line : (yylsp[(2) - (6)]).first_line;
	   const QoreTypeInfo* t = (yyvsp[(1) - (6)].parsertype)->getTypeInfo();
	   ScopedObjectCallNode* new_call = 0;

	   if (!(yyvsp[(1) - (6)].parsertype))
	      parse_error("cannot call constructor without declaring the class");
	   else if (t)
	      parse_error("cannot call constructor for non-class base type '%s'", t->getName());
	   else
	      new_call = new ScopedObjectCallNode(new NamedScope(strdup((yyvsp[(1) - (6)].parsertype)->getClassName())), makeArgs((yyvsp[(4) - (6)].node)));

	   (yyval.memberinfo) = new MemberInfo((yyvsp[(2) - (6)].string), new QoreMemberInfo(fl, (yylsp[(4) - (6)]).last_line, (yyvsp[(1) - (6)].parsertype)->getTypeInfo(), (yyvsp[(1) - (6)].parsertype)->getParseTypeInfo(), new_call));

	   delete (yyvsp[(1) - (6)].parsertype);
	   if (checkParseOption(PO_ALLOW_BARE_REFS))
	      parse_error("reference to '$.%s' with the '$.' prefix is not allowed when parse option 'allow-bare-refs' is set", (yyvsp[(2) - (6)].string));
	}
    break;

  case 153:
/* Line 1792 of yacc.c  */
#line 2177 "parser.ypp"
    {
	   int fl = (yylsp[(1) - (3)]).first_line;
	   (yyval.memberinfo) = new MemberInfo((yyvsp[(2) - (3)].string), new QoreMemberInfo(fl, (yylsp[(2) - (3)]).last_line, (yyvsp[(1) - (3)].parsertype)->getTypeInfo(), (yyvsp[(1) - (3)].parsertype)->getParseTypeInfo()));
	   delete (yyvsp[(1) - (3)].parsertype);
	   if (!checkParseOption(PO_ALLOW_BARE_REFS))
	      parse_error("member '%s' declared without '$.' prefix, but parse option 'allow-bare-refs' is not set", (yyvsp[(2) - (3)].string));
	}
    break;

  case 154:
/* Line 1792 of yacc.c  */
#line 2184 "parser.ypp"
    {
	   int fl = (yylsp[(1) - (5)]).first_line;
	   (yyval.memberinfo) = new MemberInfo((yyvsp[(2) - (5)].string), new QoreMemberInfo(fl, (yylsp[(4) - (5)]).last_line, (yyvsp[(1) - (5)].parsertype)->getTypeInfo(), (yyvsp[(1) - (5)].parsertype)->getParseTypeInfo(), (yyvsp[(4) - (5)].node)));
	   delete (yyvsp[(1) - (5)].parsertype);
	   if (!checkParseOption(PO_ALLOW_BARE_REFS))
	      parse_error("member '%s' declared without '$.' prefix, but parse option 'allow-bare-refs' is not set", (yyvsp[(2) - (5)].string));
	}
    break;

  case 155:
/* Line 1792 of yacc.c  */
#line 2191 "parser.ypp"
    {
	   int fl = (yylsp[(1) - (6)]).first_line;
	   const QoreTypeInfo* t = (yyvsp[(1) - (6)].parsertype)->getTypeInfo();
	   ScopedObjectCallNode* new_call = 0;

	   if (!(yyvsp[(1) - (6)].parsertype))
	      parse_error("cannot call constructor without declaring the class");
	   else if (t)
	      parse_error("cannot call constructor for non-class base type '%s'", t->getName());
	   else
	      new_call = new ScopedObjectCallNode(new NamedScope(strdup((yyvsp[(1) - (6)].parsertype)->getClassName())), makeArgs((yyvsp[(4) - (6)].node)));

	   (yyval.memberinfo) = new MemberInfo((yyvsp[(2) - (6)].string), new QoreMemberInfo(fl, (yylsp[(4) - (6)]).last_line, (yyvsp[(1) - (6)].parsertype)->getTypeInfo(), (yyvsp[(1) - (6)].parsertype)->getParseTypeInfo(), new_call));

	   delete (yyvsp[(1) - (6)].parsertype);
	   if (!checkParseOption(PO_ALLOW_BARE_REFS))
	      parse_error("member '%s' declared without '$.' prefix, but parse option 'allow-bare-refs' is not set", (yyvsp[(2) - (6)].string));
	}
    break;

  case 156:
/* Line 1792 of yacc.c  */
#line 2209 "parser.ypp"
    {
	   int fl = (yylsp[(1) - (2)]).first_line;
	   (yyval.memberinfo) = new MemberInfo((yyvsp[(1) - (2)].string), new QoreMemberInfo(fl, (yylsp[(1) - (2)]).last_line));
	   if (!checkParseOption(PO_ALLOW_BARE_REFS))
	      parse_error("member '%s' declared without '$.' prefix, but parse option 'allow-bare-refs' is not set", (yyvsp[(1) - (2)].string));
	}
    break;

  case 157:
/* Line 1792 of yacc.c  */
#line 2215 "parser.ypp"
    {
	   int fl = (yylsp[(1) - (4)]).first_line;
	   (yyval.memberinfo) = new MemberInfo((yyvsp[(1) - (4)].string), new QoreMemberInfo(fl, (yylsp[(3) - (4)]).last_line, (yyvsp[(3) - (4)].node)));
	   if (!checkParseOption(PO_ALLOW_BARE_REFS))
	      parse_error("member '%s' declared without '$.' prefix, but parse option 'allow-bare-refs' is not set", (yyvsp[(1) - (4)].string));
	}
    break;

  case 158:
/* Line 1792 of yacc.c  */
#line 2221 "parser.ypp"
    {
	   (yyval.memberinfo) = (yyvsp[(1) - (1)].classvarinfo);
	}
    break;

  case 159:
/* Line 1792 of yacc.c  */
#line 2224 "parser.ypp"
    {
           if ((yyvsp[(1) - (1)].constnode)->pub)
              parse_error("cannot change class constant scope for constant '%s' within a public or private declaration block", (yyvsp[(1) - (1)].constnode)->name.ostr);
	   (yyval.memberinfo) = new MemberInfo((yyvsp[(1) - (1)].constnode)->name.takeName(), (yyvsp[(1) - (1)].constnode)->value);
	   delete (yyvsp[(1) - (1)].constnode);
        }
    break;

  case 160:
/* Line 1792 of yacc.c  */
#line 2233 "parser.ypp"
    {
	   (yyval.memberinfo) = new MemberInfo((yyvsp[(1) - (1)].string));
	   if (checkParseOption(PO_ALLOW_BARE_REFS))
	      parse_error("reference to '$.%s' with the '$.' prefix is not allowed when parse option 'allow-bare-refs' is set", (yyvsp[(1) - (1)].string));
        }
    break;

  case 161:
/* Line 1792 of yacc.c  */
#line 2238 "parser.ypp"
    {
	   (yyval.memberinfo) = new MemberInfo((yyvsp[(1) - (2)].string), new QoreMemberInfo((yylsp[(1) - (2)]).first_line, (yylsp[(2) - (2)]).last_line, (yyvsp[(2) - (2)].string)));
	   if (checkParseOption(PO_ALLOW_BARE_REFS))
	      parse_error("reference to '$.%s' with the '$.' prefix is not allowed when parse option 'allow-bare-refs' is set", (yyvsp[(1) - (2)].string));
	}
    break;

  case 162:
/* Line 1792 of yacc.c  */
#line 2246 "parser.ypp"
    {
	   (yyval.memberlist) = new MemberList((yyvsp[(1) - (1)].memberinfo));
        }
    break;

  case 163:
/* Line 1792 of yacc.c  */
#line 2249 "parser.ypp"
    {
	   (yyvsp[(1) - (3)].memberlist)->add((yyvsp[(3) - (3)].memberinfo));
	   (yyval.memberlist) = (yyvsp[(1) - (3)].memberlist);
	}
    break;

  case 164:
/* Line 1792 of yacc.c  */
#line 2256 "parser.ypp"
    {
	   (yyval.memberlist) = new MemberList((yyvsp[(1) - (1)].memberinfo));
        }
    break;

  case 165:
/* Line 1792 of yacc.c  */
#line 2259 "parser.ypp"
    {
	   (yyvsp[(1) - (2)].memberlist)->add((yyvsp[(2) - (2)].memberinfo));
	   (yyval.memberlist) = (yyvsp[(1) - (2)].memberlist);
	}
    break;

  case 166:
/* Line 1792 of yacc.c  */
#line 2266 "parser.ypp"
    {
	   (yyval.string) = (yyvsp[(1) - (2)].string);
        }
    break;

  case 167:
/* Line 1792 of yacc.c  */
#line 2269 "parser.ypp"
    {
	   (yyval.string) = (yyvsp[(1) - (1)].string);
        }
    break;

  case 168:
/* Line 1792 of yacc.c  */
#line 2275 "parser.ypp"
    {
           if ((yyvsp[(1) - (7)].i4) & OFM_ABSTRACT) {
              if ((yyvsp[(7) - (7)].sblock))
                 parse_error("'abstract' can only be used with no implementation (remove the body and terminate the declaration with ';' or remove the 'abstract')");
              else
                 parse_error("'abstract' can only be used with no implementation (terminate the declaration with ';' instead of '{}')");
           }
	   checkMethod((yyvsp[(2) - (7)].string), (yyvsp[(5) - (7)].bcalist), (yyvsp[(6) - (7)].returnTypeInfo));
	   (yyval.methodnode) = new MethodNode((yyvsp[(2) - (7)].string), newMethodVariant((yyvsp[(2) - (7)].string), (yyvsp[(1) - (7)].i4), (yylsp[(3) - (7)]).first_line, (yylsp[(3) - (7)]).last_line, (yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].bcalist), (yyvsp[(6) - (7)].returnTypeInfo), (yyvsp[(7) - (7)].sblock), (yyvsp[(1) - (7)].i4) & OFM_DEPRECATED), (yyvsp[(1) - (7)].i4) & OFM_STATIC);
	}
    break;

  case 169:
/* Line 1792 of yacc.c  */
#line 2285 "parser.ypp"
    {
           if ((yyvsp[(1) - (7)].i4) & OFM_ABSTRACT) {
              if ((yyvsp[(7) - (7)].sblock))
                 parse_error("'abstract' can only be used with no implementation (remove the body and terminate the declaration with ';' or remove the 'abstract')");
              else
                 parse_error("'abstract' can only be used with no implementation (terminate the declaration with ';' instead of '{}')");
           }
	   RetTypeInfo* rt = new RetTypeInfo((yyvsp[(2) - (7)].parsertype)->getParseTypeInfo(), (yyvsp[(2) - (7)].parsertype)->getTypeInfo());
	   delete (yyvsp[(2) - (7)].parsertype);
	   
	   checkMethod((yyvsp[(3) - (7)].string), (yyvsp[(6) - (7)].bcalist), rt);

	   (yyval.methodnode) = new MethodNode((yyvsp[(3) - (7)].string), newMethodVariant((yyvsp[(3) - (7)].string), (yyvsp[(1) - (7)].i4), (yylsp[(4) - (7)]).first_line, (yylsp[(4) - (7)]).last_line, (yyvsp[(4) - (7)].node), (yyvsp[(6) - (7)].bcalist), rt, (yyvsp[(7) - (7)].sblock), (yyvsp[(1) - (7)].i4) & OFM_DEPRECATED), (yyvsp[(1) - (7)].i4) & OFM_STATIC);
	}
    break;

  case 170:
/* Line 1792 of yacc.c  */
#line 2299 "parser.ypp"
    {
           if (!((yyvsp[(1) - (7)].i4) & OFM_ABSTRACT))
              parse_error("non-abstract method declared without any body; either declare the method 'abstract' or declare an empty method body with '{}'");
           checkMethod((yyvsp[(2) - (7)].string), (yyvsp[(5) - (7)].bcalist), (yyvsp[(6) - (7)].returnTypeInfo));
           (yyval.methodnode) = new MethodNode((yyvsp[(2) - (7)].string), newMethodVariant((yyvsp[(2) - (7)].string), (yyvsp[(1) - (7)].i4), (yylsp[(3) - (7)]).first_line, (yylsp[(3) - (7)]).last_line, (yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].bcalist), (yyvsp[(6) - (7)].returnTypeInfo), 0, (yyvsp[(1) - (7)].i4) & OFM_DEPRECATED), (yyvsp[(1) - (7)].i4) & OFM_STATIC);
        }
    break;

  case 171:
/* Line 1792 of yacc.c  */
#line 2305 "parser.ypp"
    {
           if (!((yyvsp[(1) - (7)].i4) & OFM_ABSTRACT))
              parse_error("non-abstract method declared without any body; either declare the method 'abstract' or declare an empty method body with '{}'");
           RetTypeInfo* rt = new RetTypeInfo((yyvsp[(2) - (7)].parsertype)->getParseTypeInfo(), (yyvsp[(2) - (7)].parsertype)->getTypeInfo());
           delete (yyvsp[(2) - (7)].parsertype);

           checkMethod((yyvsp[(3) - (7)].string), (yyvsp[(6) - (7)].bcalist), rt);

           (yyval.methodnode) = new MethodNode((yyvsp[(3) - (7)].string), newMethodVariant((yyvsp[(3) - (7)].string), (yyvsp[(1) - (7)].i4), (yylsp[(4) - (7)]).first_line, (yylsp[(4) - (7)]).last_line, (yyvsp[(4) - (7)].node), (yyvsp[(6) - (7)].bcalist), rt, 0, (yyvsp[(1) - (7)].i4) & OFM_DEPRECATED), (yyvsp[(1) - (7)].i4) & OFM_STATIC);
        }
    break;

  case 172:
/* Line 1792 of yacc.c  */
#line 2318 "parser.ypp"
    {
           if ((yyvsp[(1) - (8)].i4) & OFM_ABSTRACT) {
              if ((yyvsp[(8) - (8)].sblock))
                 parse_error("'abstract' can only be used with no implementation (remove the body and terminate the declaration with ';' or remove the 'abstract')");
              else
                 parse_error("'abstract' can only be used with no implementation (terminate the declaration with ';' instead of '{}')");
           }
	   tryAddMethod((yyvsp[(1) - (8)].i4), (yyvsp[(2) - (8)].string), (yylsp[(4) - (8)]).first_line, (yylsp[(4) - (8)]).last_line, (yyvsp[(4) - (8)].node), (yyvsp[(6) - (8)].bcalist), (yyvsp[(7) - (8)].returnTypeInfo), (yyvsp[(8) - (8)].sblock));
	}
    break;

  case 173:
/* Line 1792 of yacc.c  */
#line 2327 "parser.ypp"
    {
           if ((yyvsp[(1) - (8)].i4) & OFM_ABSTRACT) {
              if ((yyvsp[(8) - (8)].sblock))
                 parse_error("'abstract' can only be used with no implementation (remove the body and terminate the declaration with ';' or remove the 'abstract')");
              else
                 parse_error("'abstract' can only be used with no implementation (terminate the declaration with ';' instead of '{}')");
           }
	   RetTypeInfo* rt = new RetTypeInfo((yyvsp[(2) - (8)].parsertype)->getParseTypeInfo(), (yyvsp[(2) - (8)].parsertype)->getTypeInfo());
	   delete (yyvsp[(2) - (8)].parsertype);

	   tryAddMethod((yyvsp[(1) - (8)].i4), (yyvsp[(3) - (8)].string), (yylsp[(5) - (8)]).first_line, (yylsp[(5) - (8)]).last_line, (yyvsp[(5) - (8)].node), (yyvsp[(7) - (8)].bcalist), rt, (yyvsp[(8) - (8)].sblock));
	}
    break;

  case 174:
/* Line 1792 of yacc.c  */
#line 2339 "parser.ypp"
    {
           if (!(yyvsp[(1) - (8)].i4) & OFM_ABSTRACT)
              parse_error("non-abstract method declared without any body; either declare the method 'abstract' or declare an empty method body with '{}'");
           tryAddMethod((yyvsp[(1) - (8)].i4), (yyvsp[(2) - (8)].string), (yylsp[(4) - (8)]).first_line, (yylsp[(4) - (8)]).last_line, (yyvsp[(4) - (8)].node), (yyvsp[(6) - (8)].bcalist), (yyvsp[(7) - (8)].returnTypeInfo), 0);
        }
    break;

  case 175:
/* Line 1792 of yacc.c  */
#line 2344 "parser.ypp"
    {
           if (!(yyvsp[(1) - (8)].i4) & OFM_ABSTRACT)
              parse_error("non-abstract method declared without any body; either declare the method 'abstract' or declare an empty method body with '{}'");
           RetTypeInfo* rt = new RetTypeInfo((yyvsp[(2) - (8)].parsertype)->getParseTypeInfo(), (yyvsp[(2) - (8)].parsertype)->getTypeInfo());
           delete (yyvsp[(2) - (8)].parsertype);

           tryAddMethod((yyvsp[(1) - (8)].i4), (yyvsp[(3) - (8)].string), (yylsp[(5) - (8)]).first_line, (yylsp[(5) - (8)]).last_line, (yyvsp[(5) - (8)].node), (yyvsp[(7) - (8)].bcalist), rt, 0);
        }
    break;

  case 176:
/* Line 1792 of yacc.c  */
#line 2352 "parser.ypp"
    {
	   tryAddMethod(0, (yyvsp[(1) - (7)].string), (yylsp[(3) - (7)]).first_line, (yylsp[(3) - (7)]).last_line, (yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].bcalist), (yyvsp[(6) - (7)].returnTypeInfo), (yyvsp[(7) - (7)].sblock));
	}
    break;

  case 177:
/* Line 1792 of yacc.c  */
#line 2355 "parser.ypp"
    {
	   RetTypeInfo* rt = new RetTypeInfo((yyvsp[(1) - (7)].parsertype)->getParseTypeInfo(), (yyvsp[(1) - (7)].parsertype)->getTypeInfo());
	   delete (yyvsp[(1) - (7)].parsertype);

	   tryAddMethod(0, (yyvsp[(2) - (7)].string), (yylsp[(4) - (7)]).first_line, (yylsp[(4) - (7)]).last_line, (yyvsp[(4) - (7)].node), (yyvsp[(6) - (7)].bcalist), rt, (yyvsp[(7) - (7)].sblock));
	}
    break;

  case 178:
/* Line 1792 of yacc.c  */
#line 2364 "parser.ypp"
    {
	   (yyval.bcalist) = (yyvsp[(2) - (2)].bcalist);
	}
    break;

  case 179:
/* Line 1792 of yacc.c  */
#line 2367 "parser.ypp"
    { // nothing
	   (yyval.bcalist) = 0;
	}
    break;

  case 180:
/* Line 1792 of yacc.c  */
#line 2373 "parser.ypp"
    {
	   (yyval.bcalist) = new BCAList((yyvsp[(1) - (1)].bcanode));
	}
    break;

  case 181:
/* Line 1792 of yacc.c  */
#line 2376 "parser.ypp"
    {
	   (yyvsp[(1) - (3)].bcalist)->push_back((yyvsp[(3) - (3)].bcanode));
	   (yyval.bcalist) = (yyvsp[(1) - (3)].bcalist);
	}
    break;

  case 182:
/* Line 1792 of yacc.c  */
#line 2383 "parser.ypp"
    {
	   (yyval.bcanode) = new BCANode((yyvsp[(1) - (4)].string), makeArgs((yyvsp[(3) - (4)].node)));
	}
    break;

  case 183:
/* Line 1792 of yacc.c  */
#line 2386 "parser.ypp"
    {
	   (yyval.bcanode) = new BCANode(new NamedScope((yyvsp[(1) - (4)].string)), makeArgs((yyvsp[(3) - (4)].node)));
	}
    break;

  case 184:
/* Line 1792 of yacc.c  */
#line 2393 "parser.ypp"
    { (yyval.i4) = 0; }
    break;

  case 185:
/* Line 1792 of yacc.c  */
#line 2394 "parser.ypp"
    {
           (yyval.i4) = (yyvsp[(1) - (1)].i4);
        }
    break;

  case 186:
/* Line 1792 of yacc.c  */
#line 2399 "parser.ypp"
    { (yyval.i4) = (yyvsp[(1) - (1)].i4); }
    break;

  case 187:
/* Line 1792 of yacc.c  */
#line 2400 "parser.ypp"
    {
	   if (((yyvsp[(1) - (2)].i4) | (yyvsp[(2) - (2)].i4)) == (yyvsp[(1) - (2)].i4))
	      parse_error("modifier given twice");
	   (yyval.i4) = (yyvsp[(1) - (2)].i4) | (yyvsp[(2) - (2)].i4); 
	}
    break;

  case 188:
/* Line 1792 of yacc.c  */
#line 2408 "parser.ypp"
    { (yyval.i4) = OFM_PRIVATE; }
    break;

  case 189:
/* Line 1792 of yacc.c  */
#line 2409 "parser.ypp"
    { (yyval.i4) = OFM_STATIC; }
    break;

  case 190:
/* Line 1792 of yacc.c  */
#line 2410 "parser.ypp"
    { (yyval.i4) = OFM_SYNCED; }
    break;

  case 191:
/* Line 1792 of yacc.c  */
#line 2411 "parser.ypp"
    { (yyval.i4) = OFM_DEPRECATED; }
    break;

  case 192:
/* Line 1792 of yacc.c  */
#line 2412 "parser.ypp"
    { (yyval.i4) = OFM_PUBLIC; }
    break;

  case 193:
/* Line 1792 of yacc.c  */
#line 2413 "parser.ypp"
    { (yyval.i4) = OFM_FINAL; }
    break;

  case 194:
/* Line 1792 of yacc.c  */
#line 2414 "parser.ypp"
    { (yyval.i4) = OFM_ABSTRACT; }
    break;

  case 195:
/* Line 1792 of yacc.c  */
#line 2418 "parser.ypp"
    {
	   if (!(yyvsp[(2) - (2)].parsertype)) {
	      parse_error("missing type declaration after 'returns'");
	      (yyval.returnTypeInfo) = 0;
	   }
	   else {
	      (yyval.returnTypeInfo) = new RetTypeInfo((yyvsp[(2) - (2)].parsertype)->getParseTypeInfo(), (yyvsp[(2) - (2)].parsertype)->getTypeInfo());
	      delete (yyvsp[(2) - (2)].parsertype);
	   }
	}
    break;

  case 196:
/* Line 1792 of yacc.c  */
#line 2429 "parser.ypp"
    {
	   (yyval.returnTypeInfo) = 0;
	}
    break;

  case 197:
/* Line 1792 of yacc.c  */
#line 2434 "parser.ypp"
    {
	   int ar = get_pop_argv_ref();
	   int64 flags = ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS;
           (yyval.parsefunc) = new ParseUserFunction((yyvsp[(2) - (6)].string), new UserFunctionVariant((yyvsp[(6) - (6)].sblock), (yylsp[(3) - (6)]).first_line, (yylsp[(3) - (6)]).last_line, (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].returnTypeInfo), false, flags));
	}
    break;

  case 198:
/* Line 1792 of yacc.c  */
#line 2439 "parser.ypp"
    {
	   int ar = get_pop_argv_ref();
	   int64 flags = ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS;

	   RetTypeInfo* rt = new RetTypeInfo((yyvsp[(1) - (6)].parsertype)->getParseTypeInfo(), (yyvsp[(1) - (6)].parsertype)->getTypeInfo());
	   delete (yyvsp[(1) - (6)].parsertype);

	   (yyval.parsefunc) = new ParseUserFunction((yyvsp[(3) - (6)].string), new UserFunctionVariant((yyvsp[(6) - (6)].sblock), (yylsp[(4) - (6)]).first_line, (yylsp[(4) - (6)]).last_line, (yyvsp[(4) - (6)].node), rt, false, flags));
	}
    break;

  case 199:
/* Line 1792 of yacc.c  */
#line 2448 "parser.ypp"
    {
	   check_funcmod((yyvsp[(1) - (7)].i4));
	   int ar = get_pop_argv_ref();
	   int64 flags = ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS;
	   if ((yyvsp[(1) - (7)].i4) & OFM_DEPRECATED)
	      flags |= QC_DEPRECATED;
           
	   (yyval.parsefunc) = new ParseUserFunction((yyvsp[(3) - (7)].string), new UserFunctionVariant((yyvsp[(7) - (7)].sblock), (yylsp[(4) - (7)]).first_line, (yylsp[(4) - (7)]).last_line, (yyvsp[(4) - (7)].node), (yyvsp[(6) - (7)].returnTypeInfo), (yyvsp[(1) - (7)].i4) & OFM_SYNCED, flags)); 
           if ((yyvsp[(1) - (7)].i4) & OFM_PUBLIC)
              (yyval.parsefunc)->setPublic();
	}
    break;

  case 200:
/* Line 1792 of yacc.c  */
#line 2459 "parser.ypp"
    {
	   check_funcmod((yyvsp[(1) - (7)].i4));
	   int ar = get_pop_argv_ref();
	   int64 flags = ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS;
	   if ((yyvsp[(1) - (7)].i4) & OFM_DEPRECATED)
	      flags |= QC_DEPRECATED;

	   RetTypeInfo* rt = new RetTypeInfo((yyvsp[(2) - (7)].parsertype)->getParseTypeInfo(), (yyvsp[(2) - (7)].parsertype)->getTypeInfo());
	   delete (yyvsp[(2) - (7)].parsertype);

	   (yyval.parsefunc) = new ParseUserFunction((yyvsp[(4) - (7)].string), new UserFunctionVariant((yyvsp[(7) - (7)].sblock), (yylsp[(5) - (7)]).first_line, (yylsp[(5) - (7)]).last_line, (yyvsp[(5) - (7)].node), rt, (yyvsp[(1) - (7)].i4) & OFM_SYNCED, flags)); 
           if ((yyvsp[(1) - (7)].i4) & OFM_PUBLIC)
              (yyval.parsefunc)->setPublic();
	}
    break;

  case 201:
/* Line 1792 of yacc.c  */
#line 2475 "parser.ypp"
    {
	   int ar = get_pop_argv_ref();
	   int64 flags = ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS;
           (yyval.sparsefunc) = new ParseScopedUserFunction((yyvsp[(2) - (7)].string), new UserFunctionVariant((yyvsp[(7) - (7)].sblock), (yylsp[(4) - (7)]).first_line, (yylsp[(4) - (7)]).last_line, (yyvsp[(4) - (7)].node), (yyvsp[(6) - (7)].returnTypeInfo), false, flags));
	}
    break;

  case 202:
/* Line 1792 of yacc.c  */
#line 2480 "parser.ypp"
    {
	   int ar = get_pop_argv_ref();
	   int64 flags = ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS;

	   RetTypeInfo* rt = new RetTypeInfo((yyvsp[(1) - (7)].parsertype)->getParseTypeInfo(), (yyvsp[(1) - (7)].parsertype)->getTypeInfo());
	   delete (yyvsp[(1) - (7)].parsertype);

	   (yyval.sparsefunc) = new ParseScopedUserFunction((yyvsp[(3) - (7)].string), new UserFunctionVariant((yyvsp[(7) - (7)].sblock), (yylsp[(5) - (7)]).first_line, (yylsp[(5) - (7)]).last_line, (yyvsp[(5) - (7)].node), rt, false, flags));
	}
    break;

  case 203:
/* Line 1792 of yacc.c  */
#line 2489 "parser.ypp"
    {
	   check_funcmod((yyvsp[(1) - (8)].i4));
	   int ar = get_pop_argv_ref();
	   int64 flags = ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS;
	   if ((yyvsp[(1) - (8)].i4) & OFM_DEPRECATED)
	      flags |= QC_DEPRECATED;
           
	   (yyval.sparsefunc) = new ParseScopedUserFunction((yyvsp[(3) - (8)].string), new UserFunctionVariant((yyvsp[(8) - (8)].sblock), (yylsp[(5) - (8)]).first_line, (yylsp[(5) - (8)]).last_line, (yyvsp[(5) - (8)].node), (yyvsp[(7) - (8)].returnTypeInfo), (yyvsp[(1) - (8)].i4) & OFM_SYNCED, flags)); 
           if ((yyvsp[(1) - (8)].i4) & OFM_PUBLIC)
              (yyval.sparsefunc)->setPublic();
	}
    break;

  case 204:
/* Line 1792 of yacc.c  */
#line 2500 "parser.ypp"
    {
	   check_funcmod((yyvsp[(1) - (8)].i4));
	   int ar = get_pop_argv_ref();
	   int64 flags = ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS;
	   if ((yyvsp[(1) - (8)].i4) & OFM_DEPRECATED)
	      flags |= QC_DEPRECATED;

	   RetTypeInfo* rt = new RetTypeInfo((yyvsp[(2) - (8)].parsertype)->getParseTypeInfo(), (yyvsp[(2) - (8)].parsertype)->getTypeInfo());
	   delete (yyvsp[(2) - (8)].parsertype);

	   (yyval.sparsefunc) = new ParseScopedUserFunction((yyvsp[(4) - (8)].string), new UserFunctionVariant((yyvsp[(8) - (8)].sblock), (yylsp[(6) - (8)]).first_line, (yylsp[(6) - (8)]).last_line, (yyvsp[(6) - (8)].node), rt, (yyvsp[(1) - (8)].i4) & OFM_SYNCED, flags)); 
           if ((yyvsp[(1) - (8)].i4) & OFM_PUBLIC)
              (yyval.sparsefunc)->setPublic();
	}
    break;

  case 205:
/* Line 1792 of yacc.c  */
#line 2518 "parser.ypp"
    { (yyval.list) = splice_expressions((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node)); }
    break;

  case 206:
/* Line 1792 of yacc.c  */
#line 2519 "parser.ypp"
    {
	   QoreListNode* l;
	   if ((yyvsp[(1) - (2)].node) && (yyvsp[(1) - (2)].node)->getType() == NT_LIST) 
	      l = reinterpret_cast<QoreListNode*>((yyvsp[(1) - (2)].node));
	   else {
	      l = new QoreListNode;
	      l->push((yyvsp[(1) - (2)].node));
	      // parse_error("problem in parsing ',' in list: left side of comma is not a list (type: '%s')", $1 ? $1->getTypeName() : "NOTHING");
	      // so we don't insert null values in the parse tree
	   }
	   (yyval.list) = l;
        }
    break;

  case 207:
/* Line 1792 of yacc.c  */
#line 2534 "parser.ypp"
    {
	   (yyval.hash) = new QoreHashNode;
	   (yyval.hash)->setKeyValue((yyvsp[(1) - (1)].hashelement)->key, (yyvsp[(1) - (1)].hashelement)->value, 0);
	   delete (yyvsp[(1) - (1)].hashelement);
	}
    break;

  case 208:
/* Line 1792 of yacc.c  */
#line 2539 "parser.ypp"
    {
	   if ((yyvsp[(1) - (3)].hash)->existsKey((yyvsp[(3) - (3)].hashelement)->key))
	      QoreHashNode::doDuplicateKeyWarning((yyvsp[(3) - (3)].hashelement)->key);
	   (yyvsp[(1) - (3)].hash)->setKeyValue((yyvsp[(3) - (3)].hashelement)->key, (yyvsp[(3) - (3)].hashelement)->value, 0);
	   delete (yyvsp[(3) - (3)].hashelement);
	   (yyval.hash) = (yyvsp[(1) - (3)].hash);
	}
    break;

  case 209:
/* Line 1792 of yacc.c  */
#line 2547 "parser.ypp"
    { /* empty ',' on end of hash */ (yyval.hash)=(yyvsp[(1) - (2)].hash); }
    break;

  case 210:
/* Line 1792 of yacc.c  */
#line 2552 "parser.ypp"
    { (yyval.hashelement) = new HashElement((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node)); }
    break;

  case 211:
/* Line 1792 of yacc.c  */
#line 2554 "parser.ypp"
    { (yyval.hashelement) = new HashElement(HE_TAG_CONST, (yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].node)); }
    break;

  case 212:
/* Line 1792 of yacc.c  */
#line 2556 "parser.ypp"
    { (yyval.hashelement) = new HashElement(HE_TAG_SCOPED_CONST, (yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].node)); }
    break;

  case 213:
/* Line 1792 of yacc.c  */
#line 2560 "parser.ypp"
    { (yyval.node) = (yyvsp[(1) - (1)].node); }
    break;

  case 214:
/* Line 1792 of yacc.c  */
#line 2562 "parser.ypp"
    { (yyval.node) = (yyvsp[(1) - (1)].binary); }
    break;

  case 215:
/* Line 1792 of yacc.c  */
#line 2564 "parser.ypp"
    { (yyval.node) = (yyvsp[(1) - (1)].list); }
    break;

  case 216:
/* Line 1792 of yacc.c  */
#line 2566 "parser.ypp"
    { (yyval.node) = (yyvsp[(2) - (3)].hash); }
    break;

  case 217:
/* Line 1792 of yacc.c  */
#line 2568 "parser.ypp"
    { (yyval.node) = new ScopedRefNode((yyvsp[(1) - (1)].string)); }
    break;

  case 218:
/* Line 1792 of yacc.c  */
#line 2569 "parser.ypp"
    {
	   if (!(yyvsp[(1) - (2)].parsertype) && !strcmp((yyvsp[(2) - (2)].string), "argv"))
	      inc_argv_ref();

	   if ((yyvsp[(1) - (2)].parsertype))
	      (yyval.node) = new VarRefDeclNode((yylsp[(1) - (2)]).first_line, (yylsp[(2) - (2)]).last_line, (yyvsp[(2) - (2)].string), get_var_type(), (yyvsp[(1) - (2)].parsertype)->getTypeInfo(), (yyvsp[(1) - (2)].parsertype)->getParseTypeInfo());
	   else
	      (yyval.node) = new VarRefNode((yyvsp[(2) - (2)].string), get_var_type());

	   delete (yyvsp[(1) - (2)].parsertype);
	   if (checkParseOption(PO_ALLOW_BARE_REFS))
	      parse_error("reference to variable '%s' with the '$' sign is not allowed when parse option 'allow-bare-refs' is set", (yyvsp[(2) - (2)].string));
	}
    break;

  case 219:
/* Line 1792 of yacc.c  */
#line 2582 "parser.ypp"
    {
	   if (!(yyvsp[(1) - (2)].parsertype) && !strcmp((yyvsp[(2) - (2)].string), "argv"))
	      inc_argv_ref();

	   if ((yyvsp[(1) - (2)].parsertype))
	      (yyval.node) = new VarRefDeclNode((yylsp[(1) - (2)]).first_line, (yylsp[(2) - (2)]).last_line, (yyvsp[(2) - (2)].string), get_var_type(), (yyvsp[(1) - (2)].parsertype)->getTypeInfo(), (yyvsp[(1) - (2)].parsertype)->getParseTypeInfo());
	   else
	      (yyval.node) = new VarRefNode((yyvsp[(2) - (2)].string), get_var_type());

	   delete (yyvsp[(1) - (2)].parsertype);
	   if (checkParseOption(PO_ALLOW_BARE_REFS))
	      parse_error("reference to variable '%s' with the '$' sign is not allowed when parse option 'allow-bare-refs' is set", (yyvsp[(2) - (2)].string));
	}
    break;

  case 220:
/* Line 1792 of yacc.c  */
#line 2595 "parser.ypp"
    {
	   (yyval.node) = new VarRefDeclNode((yylsp[(1) - (2)]).first_line, (yylsp[(2) - (2)]).last_line, (yyvsp[(2) - (2)].string), get_var_type(), (yyvsp[(1) - (2)].parsertype)->getTypeInfo(), (yyvsp[(1) - (2)].parsertype)->getParseTypeInfo());
	   delete (yyvsp[(1) - (2)].parsertype);
	}
    break;

  case 221:
/* Line 1792 of yacc.c  */
#line 2599 "parser.ypp"
    {
	   VarRefDeclNode* v = new VarRefDeclNode((yylsp[(2) - (3)]).first_line, (yylsp[(3) - (3)]).last_line, (yyvsp[(3) - (3)].string), VT_LOCAL, (yyvsp[(2) - (3)].parsertype)->getTypeInfo(), (yyvsp[(2) - (3)].parsertype)->getParseTypeInfo());
	   v->setExplicitScope();
	   (yyval.node) = v;
	   delete (yyvsp[(2) - (3)].parsertype);
	   if (!checkParseOption(PO_ALLOW_BARE_REFS))
	      parse_error("local variable '%s' declared without '$' prefix, but parse option 'allow-bare-refs' is not set", (yyvsp[(3) - (3)].string));
	}
    break;

  case 222:
/* Line 1792 of yacc.c  */
#line 2607 "parser.ypp"
    {
	   // see if types are required
	   if (checkParseOption(PO_REQUIRE_TYPES))
	      parse_error("local variable '%s' declared without type information, but parse options require all declarations to have type information", (yyvsp[(2) - (2)].string));
	   VarRefNode* v = new VarRefNode((yyvsp[(2) - (2)].string), VT_LOCAL);
	   v->setExplicitScope();
	   (yyval.node) = v;
	   if (!checkParseOption(PO_ALLOW_BARE_REFS))
	      parse_error("local variable '%s' declared without '$' prefix, but parse option 'allow-bare-refs' is not set", (yyvsp[(2) - (2)].string));
	}
    break;

  case 223:
/* Line 1792 of yacc.c  */
#line 2617 "parser.ypp"
    {
	   VarRefNode* v;
	   if ((yyvsp[(2) - (3)].parsertype)) {
	      v = new VarRefDeclNode((yylsp[(3) - (3)]).first_line, (yylsp[(3) - (3)]).last_line, (yyvsp[(3) - (3)].string), VT_LOCAL, (yyvsp[(2) - (3)].parsertype)->getTypeInfo(), (yyvsp[(2) - (3)].parsertype)->getParseTypeInfo());
	      delete (yyvsp[(2) - (3)].parsertype);
	   }
	   else {
	      // see if types are required
	      if (checkParseOption(PO_REQUIRE_TYPES))
		 parse_error("local variable '%s' declared without type information, but parse options require all declarations to have type information", (yyvsp[(3) - (3)].string));
	      v = new VarRefNode((yyvsp[(3) - (3)].string), VT_LOCAL);
	   }
	   v->setExplicitScope();
	   (yyval.node) = v;
	   if (checkParseOption(PO_ALLOW_BARE_REFS))
	      parse_error("reference to variable '$%s' with the '$' sign is not allowed when parse option 'allow-bare-refs' is set", (yyvsp[(3) - (3)].string));
	}
    break;

  case 224:
/* Line 1792 of yacc.c  */
#line 2634 "parser.ypp"
    {
	   (yyvsp[(3) - (4)].list)->setVariableList();
	   ListIterator li((yyvsp[(3) - (4)].list));
	   while (li.next()) {
	      AbstractQoreNode* n = li.getValue();
	      qore_type_t t = get_node_type(n);
	      if (t == NT_BAREWORD) {
		 BarewordNode* b = reinterpret_cast<BarewordNode*>(n);
		 if (checkParseOption(PO_REQUIRE_TYPES))
		    parse_error("local variable '%s' declared without type information, but parse options require all declarations to have type information", b->str);
		 if (!checkParseOption(PO_ALLOW_BARE_REFS))
		    parse_error("local variable '%s' in local variable declaration list declared without '$' prefix, but parse option 'allow-bare-refs' is not set", b->str);
		 VarRefNode* v = new VarRefNode(b->takeString(), VT_LOCAL);
		 v->setExplicitScope();
		 b->deref();
		 AbstractQoreNode** p = li.getValuePtr();
		 *p = v;
	      }
	      else if (t == NT_VARREF) {
		 VarRefNode* v = reinterpret_cast<VarRefNode*>(n);
		 // see if types are required
		 if (checkParseOption(PO_REQUIRE_TYPES) && !v->isDecl())
		    parse_error("local variable '%s' declared without type information, but parse options require all declarations to have type information", v->getName());
		 if (v->explicitScope()) {
		    if (v->getType() == VT_LOCAL)
		       parse_error("illegal use of 'my %s' in local variable declaration list", v->getName());
		    else if (v->getType() == VT_GLOBAL)
		       parse_error("illegal use of 'our %s' in local variable declaration list", v->getName());
		 }
		 else
		    v->makeLocal();
		 v->setExplicitScope();
	      }
	      else
		 parse_error("element %d in list following 'my' is not a variable reference (%s)", li.index(), get_type_name(n));
	   }
	   (yyval.node) = (yyvsp[(3) - (4)].list);
        }
    break;

  case 225:
/* Line 1792 of yacc.c  */
#line 2672 "parser.ypp"
    {
           (yyval.node) = (yyvsp[(1) - (1)].gv)->makeVar();
        }
    break;

  case 226:
/* Line 1792 of yacc.c  */
#line 2676 "parser.ypp"
    {
	   if (checkParseOption(PO_ASSUME_LOCAL & PO_ALLOW_BARE_REFS) && !strcmp((yyvsp[(1) - (1)].string), "argv"))
	      inc_argv_ref();

	   (yyval.node) = new BarewordNode((yyvsp[(1) - (1)].string));
	}
    break;

  case 227:
/* Line 1792 of yacc.c  */
#line 2683 "parser.ypp"
    { (yyval.node) = new ContextrefNode((yyvsp[(1) - (1)].string)); }
    break;

  case 228:
/* Line 1792 of yacc.c  */
#line 2685 "parser.ypp"
    { (yyval.node) = new ContextRowNode; }
    break;

  case 229:
/* Line 1792 of yacc.c  */
#line 2687 "parser.ypp"
    { (yyval.node) = new ComplexContextrefNode((yyvsp[(1) - (1)].string)); }
    break;

  case 230:
/* Line 1792 of yacc.c  */
#line 2689 "parser.ypp"
    { (yyval.node) = new FindNode((yyvsp[(2) - (8)].node), (yyvsp[(4) - (8)].node), (yyvsp[(7) - (8)].node)); }
    break;

  case 231:
/* Line 1792 of yacc.c  */
#line 2690 "parser.ypp"
    {
           (yyval.node) = new QorePlusEqualsOperatorNode((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	}
    break;

  case 232:
/* Line 1792 of yacc.c  */
#line 2693 "parser.ypp"
    {
           (yyval.node) = new QoreMinusEqualsOperatorNode((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	}
    break;

  case 233:
/* Line 1792 of yacc.c  */
#line 2696 "parser.ypp"
    {
           (yyval.node) = new QoreAndEqualsOperatorNode((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	}
    break;

  case 234:
/* Line 1792 of yacc.c  */
#line 2699 "parser.ypp"
    {
           (yyval.node) = new QoreOrEqualsOperatorNode((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	}
    break;

  case 235:
/* Line 1792 of yacc.c  */
#line 2702 "parser.ypp"
    {
           (yyval.node) = new QoreModulaEqualsOperatorNode((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	}
    break;

  case 236:
/* Line 1792 of yacc.c  */
#line 2705 "parser.ypp"
    {
           (yyval.node) = new QoreMultiplyEqualsOperatorNode((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	}
    break;

  case 237:
/* Line 1792 of yacc.c  */
#line 2708 "parser.ypp"
    {
           (yyval.node) = new QoreDivideEqualsOperatorNode((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	}
    break;

  case 238:
/* Line 1792 of yacc.c  */
#line 2711 "parser.ypp"
    {
           (yyval.node) = new QoreXorEqualsOperatorNode((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	}
    break;

  case 239:
/* Line 1792 of yacc.c  */
#line 2714 "parser.ypp"
    {
           (yyval.node) = new QoreShiftLeftEqualsOperatorNode((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	}
    break;

  case 240:
/* Line 1792 of yacc.c  */
#line 2717 "parser.ypp"
    {
           (yyval.node) = new QoreShiftRightEqualsOperatorNode((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	}
    break;

  case 241:
/* Line 1792 of yacc.c  */
#line 2720 "parser.ypp"
    {
	   if ((yyvsp[(1) - (3)].node) && (yyvsp[(1) - (3)].node)->getType() == NT_LIST) {
	      (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_LIST_ASSIGNMENT, (yyvsp[(3) - (3)].node));
	   }
	   else {
	      (yyval.node) = new QoreAssignmentOperatorNode((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	   }
	   //print_tree($1, 0);
	}
    break;

  case 242:
/* Line 1792 of yacc.c  */
#line 2730 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_EXISTS, 0); }
    break;

  case 243:
/* Line 1792 of yacc.c  */
#line 2732 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_ELEMENTS, 0); }
    break;

  case 244:
/* Line 1792 of yacc.c  */
#line 2733 "parser.ypp"
    {
	   (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_INSTANCEOF, new ClassRefNode((yyvsp[(3) - (3)].string)));
	}
    break;

  case 245:
/* Line 1792 of yacc.c  */
#line 2736 "parser.ypp"
    {
	   (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_INSTANCEOF, new ClassRefNode((yyvsp[(3) - (3)].string)));
	}
    break;

  case 246:
/* Line 1792 of yacc.c  */
#line 2740 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_KEYS, 0); }
    break;

  case 247:
/* Line 1792 of yacc.c  */
#line 2741 "parser.ypp"
    {  // unshift list, element
	   QoreListNode* l = (yyvsp[(2) - (2)].node) && (yyvsp[(2) - (2)].node)->getType() == NT_LIST ? reinterpret_cast<QoreListNode*>((yyvsp[(2) - (2)].node)) : 0;
	   if (!l || l->size() != 2) {
	      parse_error("invalid arguments to unshift, expected: lvalue, expression (%s)", (yyvsp[(2) - (2)].node)->getTypeName());
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else {
	      AbstractQoreNode* lv = l->shift();
	      (yyval.node) = new QoreTreeNode(lv, OP_UNSHIFT, l->shift());
	      (yyvsp[(2) - (2)].node)->deref(0);
	   }
	}
    break;

  case 248:
/* Line 1792 of yacc.c  */
#line 2753 "parser.ypp"
    {
	   (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_SHIFT, 0); 
	}
    break;

  case 249:
/* Line 1792 of yacc.c  */
#line 2756 "parser.ypp"
    {  // push lvalue-list, element
	   QoreListNode* l = (yyvsp[(2) - (2)].node) && (yyvsp[(2) - (2)].node)->getType() == NT_LIST ? reinterpret_cast<QoreListNode*>((yyvsp[(2) - (2)].node)) : 0;
	   if (!l || l->size() != 2) {
	      parse_error("invalid arguments to push, expected: lvalue, expression (%s)", (yyvsp[(2) - (2)].node)->getTypeName());
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else {
	      AbstractQoreNode* lv = l->shift();
	      (yyval.node) = new QoreTreeNode(lv, OP_PUSH, l->shift());
	      (yyvsp[(2) - (2)].node)->deref(0);
	   }
	}
    break;

  case 250:
/* Line 1792 of yacc.c  */
#line 2768 "parser.ypp"
    {
	   (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_POP, 0); 
	}
    break;

  case 251:
/* Line 1792 of yacc.c  */
#line 2771 "parser.ypp"
    {
	   (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_CHOMP, 0); 
	}
    break;

  case 252:
/* Line 1792 of yacc.c  */
#line 2774 "parser.ypp"
    {
	   (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_TRIM, 0); 
	}
    break;

  case 253:
/* Line 1792 of yacc.c  */
#line 2777 "parser.ypp"
    {  // splice lvalue-list, offset, [length, list]
	   QoreListNode* l = (yyvsp[(2) - (2)].node) && (yyvsp[(2) - (2)].node)->getType() == NT_LIST ? reinterpret_cast<QoreListNode*>((yyvsp[(2) - (2)].node)) : 0;
	   if (!l) {
	      parse_error("invalid arguments to splice, expected: lvalue, offset exp[, length exp[, list exp]] (got %s)", get_type_name((yyvsp[(2) - (2)].node)));
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else if (l->size() < 2) {
	      parse_error("too few arguments to splice, expected at least 2 arguments as follows: lvalue, offset exp[, length exp[, list exp]] (got %d arguments)", l->size());
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else if (l->size() > 4) {
	      parse_error("too many arguments to splice, expected maximum 4 arguments as follows: lvalue, offset exp[, length exp[, list exp]] (got %d arguments)", l->size());
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else {
	      AbstractQoreNode* lv = l->shift();
	      (yyval.node) = new QoreSpliceOperatorNode(lv, l->shift(), l->shift(), l->shift());
	      discard(l, 0);
	   }
	}
    break;

  case 254:
/* Line 1792 of yacc.c  */
#line 2797 "parser.ypp"
    {  // extract lvalue-list, offset, [length, list]
	   QoreListNode* l = (yyvsp[(2) - (2)].node) && (yyvsp[(2) - (2)].node)->getType() == NT_LIST ? reinterpret_cast<QoreListNode*>((yyvsp[(2) - (2)].node)) : 0;
	   if (!l) {
	      parse_error("invalid arguments to extract, expected: lvalue, offset exp[, length exp[, list exp]] (got %s)", get_type_name((yyvsp[(2) - (2)].node)));
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else if (l->size() < 2) {
	      parse_error("too few arguments to extract, expected at least 2 arguments as follows: lvalue, offset exp[, length exp[, list exp]] (got %d arguments)", l->size());
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else if (l->size() > 4) {
	      parse_error("too many arguments to extract, expected maximum 4 arguments as follows: lvalue, offset exp[, length exp[, list exp]] (got %d arguments)", l->size());
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else {
	      AbstractQoreNode* lv = l->shift();
	      (yyval.node) = new QoreExtractOperatorNode(lv, l->shift(), l->shift(), l->shift());
	      discard(l, 0);
	   }
	}
    break;

  case 255:
/* Line 1792 of yacc.c  */
#line 2817 "parser.ypp"
    {
	   pop_ignore_numeric_argv_ref();
	   QoreListNode* l = (yyvsp[(2) - (2)].node) && (yyvsp[(2) - (2)].node)->getType() == NT_LIST ? reinterpret_cast<QoreListNode*>((yyvsp[(2) - (2)].node)) : 0;
	   int len = l ? (int)l->size() : 0;
	   if (!l || len < 2 || len > 3) {
	      parse_error("invalid arguments to map operator, expected: 2 or 3 element list (code expression, list argument, [select expression]), got: '%s'", get_type_name((yyvsp[(2) - (2)].node)));
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else if (len == 2) {
	      AbstractQoreNode* map_exp = l->shift();
	      AbstractQoreNode* arg = l->shift();
	      (yyval.node) = new QoreTreeNode(map_exp, OP_MAP, arg);
	      (yyvsp[(2) - (2)].node)->deref(0);
	   }
	   else {
	      AbstractQoreNode* map_exp = l->shift();
	      (yyval.node) = new QoreTreeNode(map_exp, OP_MAP_SELECT, l);
	   }
	}
    break;

  case 256:
/* Line 1792 of yacc.c  */
#line 2836 "parser.ypp"
    {
	   pop_ignore_numeric_argv_ref();
	   QoreListNode* l = (yyvsp[(2) - (2)].node) && (yyvsp[(2) - (2)].node)->getType() == NT_LIST ? reinterpret_cast<QoreListNode*>((yyvsp[(2) - (2)].node)) : 0;
	   if (!l || l->size() != 2) {
	      parse_error("invalid arguments to foldr operator, expected: 2-element list expected: 2-element list (fold expression and list expression), got: '%s'", get_type_name((yyvsp[(2) - (2)].node)));
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else {
	      AbstractQoreNode* code_exp = l->shift();
	      AbstractQoreNode* arg = l->shift();
	      (yyval.node) = new QoreTreeNode(code_exp, OP_FOLDR, arg);
	      (yyvsp[(2) - (2)].node)->deref(0);
	   }
	}
    break;

  case 257:
/* Line 1792 of yacc.c  */
#line 2850 "parser.ypp"
    {
	   pop_ignore_numeric_argv_ref();
	   QoreListNode* l = (yyvsp[(2) - (2)].node) && (yyvsp[(2) - (2)].node)->getType() == NT_LIST ? reinterpret_cast<QoreListNode*>((yyvsp[(2) - (2)].node)) : 0;
	   if (!l || l->size() != 2) {
	      parse_error("invalid arguments to foldl operator, expected: 2-element list (fold expression and list expression), got: '%s'", get_type_name((yyvsp[(2) - (2)].node)));
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else {
	      AbstractQoreNode* code_exp = l->shift();
	      AbstractQoreNode* arg = l->shift();
	      (yyval.node) = new QoreTreeNode(code_exp, OP_FOLDL, arg);
	      (yyvsp[(2) - (2)].node)->deref(0);
	   }
	}
    break;

  case 258:
/* Line 1792 of yacc.c  */
#line 2864 "parser.ypp"
    {
	   pop_ignore_numeric_argv_ref();
	   QoreListNode* l = (yyvsp[(2) - (2)].node) && (yyvsp[(2) - (2)].node)->getType() == NT_LIST ? reinterpret_cast<QoreListNode*>((yyvsp[(2) - (2)].node)) : 0;
	   if (!l || l->size() != 2) {
	      parse_error("invalid arguments to select operator, expected: 2-element list (list expression and select expression) got: '%s'", get_type_name((yyvsp[(2) - (2)].node)));
	      (yyval.node) = makeErrorTree((yyvsp[(2) - (2)].node), 0);
	   }
	   else {
	      AbstractQoreNode* arg = l->shift();
	      AbstractQoreNode* select_exp = l->shift();
	      (yyval.node) = new QoreTreeNode(arg, OP_SELECT, select_exp);
	      (yyvsp[(2) - (2)].node)->deref(0);
	   }
	}
    break;

  case 259:
/* Line 1792 of yacc.c  */
#line 2879 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (5)].node), OP_QUESTION_MARK, make_list((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node))); }
    break;

  case 260:
/* Line 1792 of yacc.c  */
#line 2880 "parser.ypp"
    {  // pre-increment
           (yyval.node) = new QorePreIncrementOperatorNode((yyvsp[(2) - (2)].node));
        }
    break;

  case 261:
/* Line 1792 of yacc.c  */
#line 2883 "parser.ypp"
    {  // post-increment
           (yyval.node) = new QorePostIncrementOperatorNode((yyvsp[(1) - (2)].node));
        }
    break;

  case 262:
/* Line 1792 of yacc.c  */
#line 2886 "parser.ypp"
    {  // pre-decrement
           (yyval.node) = new QorePreDecrementOperatorNode((yyvsp[(2) - (2)].node));
        }
    break;

  case 263:
/* Line 1792 of yacc.c  */
#line 2889 "parser.ypp"
    {   // post-decrement
           (yyval.node) = new QorePostDecrementOperatorNode((yyvsp[(1) - (2)].node));
        }
    break;

  case 264:
/* Line 1792 of yacc.c  */
#line 2892 "parser.ypp"
    {
	   //printd(5, "1=%s (%p), 3=%s (%p)\n", $1->getTypeName(), $1, $3 ? $3->getTypeName() : "n/a", $3); 
	   qore_type_t t = get_node_type((yyvsp[(1) - (4)].node));
	   if (t == NT_BAREWORD) {
	      BarewordNode* b = reinterpret_cast<BarewordNode*>((yyvsp[(1) - (4)].node));
	      // take string from node and delete node
	      char* str = b->takeString();
	      b->deref();
	      printd(5, "parsing call %s() args=%p %s\n", str, (yyvsp[(3) - (4)].node), (yyvsp[(3) - (4)].node) ? (yyvsp[(3) - (4)].node)->getTypeName() : "n/a");
	      (yyval.node) = new FunctionCallNode(str, makeArgs((yyvsp[(3) - (4)].node)));
	   }
	   else if (t == NT_CONSTANT) {
	      ScopedRefNode* c = reinterpret_cast<ScopedRefNode*>((yyvsp[(1) - (4)].node));
	      // take NamedScope from node and delete node
	      NamedScope *ns = c->takeName();
	      c->deref();
	      assert(ns->size() > 1);
	      printd(5, "parsing scoped call (static method, new object call, or program function call) %s()\n", ns->ostr);
	      (yyval.node) = new StaticMethodCallNode(ns, makeArgs((yyvsp[(3) - (4)].node)));
	   }
	   else if (t == NT_SELF_VARREF) {
	      SelfVarrefNode* v = reinterpret_cast<SelfVarrefNode*>((yyvsp[(1) - (4)].node));
	      // take string from node and delete node
	      char* str = v->takeString();
	      v->deref();
	      printd(5, "parsing in-object method call %s()\n", str);
	      (yyval.node) = new SelfFunctionCallNode(str, makeArgs((yyvsp[(3) - (4)].node)));
	   }
	   else {
	      QoreTreeNode* tree;
	      
	      if (t == NT_TREE) {
		 tree = reinterpret_cast<QoreTreeNode*>((yyvsp[(1) - (4)].node));
		 if (!(tree->getOp() == OP_OBJECT_REF && tree->right && tree->right->getType() == NT_STRING))
		    tree = 0;
	      }
	      else
		 tree = 0;

	      if (tree) {
		 // create an object method call node
		 // take the string
		 QoreStringNode* str = reinterpret_cast<QoreStringNode*>(tree->right);
		 char* cstr = str->giveBuffer();
		 str->deref();
		 
		 //printd(5, "method call to %s: tree=%s, args=%p %s\n", cstr, tree->left->getTypeName(), $3, $3 ? $3->getTypeName() : "n/a");

		 MethodCallNode* mc = new MethodCallNode(cstr, makeArgs((yyvsp[(3) - (4)].node)));
                 
                 // destroy the tree and create a new operator object
                 assert(tree->is_unique());
                 AbstractQoreNode* l = tree->left;
                 tree->right = 0;
                 tree->left = 0;
                 tree->deref(0);

		 (yyval.node) = new QoreDotEvalOperatorNode(l, mc);
	      }
	      else {
		 (yyval.node) = 0;
		 if ((yyvsp[(1) - (4)].node) && (yyvsp[(1) - (4)].node)->getType() == NT_VARREF) {
		    VarRefNode* r = reinterpret_cast<VarRefNode*>((yyvsp[(1) - (4)].node));
		    qore_var_t vartype = r->getType();

		    if (vartype != VT_UNRESOLVED) {
		       (yyval.node) = r->makeNewCall((yyvsp[(3) - (4)].node));
		       //printd(5, "makeNewCall(%p) returned %p (%s)\n", $3, $$, get_type_name($$));
		       if (!(yyval.node))
			  parseException("INVALID-CODE-REFERENCE-CALL", "%s variable '%s' declared as a function reference call", r->getType() == VT_GLOBAL ? "global" : "local", r->getName());
		    }
		 }
		 if (!(yyval.node)) {
		    (yyval.node) = new CallReferenceCallNode((yyvsp[(1) - (4)].node), makeArgs((yyvsp[(3) - (4)].node)));
		    printd(5, "made new CallReferenceCallNode: %p exp=%p %s\n", (yyval.node), (yyvsp[(1) - (4)].node), get_type_name((yyvsp[(1) - (4)].node)));
		 }
	      }
	   }
	}
    break;

  case 265:
/* Line 1792 of yacc.c  */
#line 2971 "parser.ypp"
    {
	   printd(5, "parsing in-object base class method call %s()\n", (yyvsp[(1) - (4)].nscope)->ostr);
	   if (!strcmp((yyvsp[(1) - (4)].nscope)->getIdentifier(), "copy"))
	      parse_error("illegal call to base class copy method '%s'", (yyvsp[(1) - (4)].nscope)->ostr);

	   (yyval.node) = new SelfFunctionCallNode((yyvsp[(1) - (4)].nscope), makeArgs((yyvsp[(3) - (4)].node)));
	}
    break;

  case 266:
/* Line 1792 of yacc.c  */
#line 2978 "parser.ypp"
    {
	   printd(5, "parsing call %s()\n", (yyvsp[(1) - (3)].string));
	   (yyval.node) = new FunctionCallNode((yyvsp[(1) - (3)].string), makeArgs((yyvsp[(2) - (3)].node)));
        }
    break;

  case 267:
/* Line 1792 of yacc.c  */
#line 2983 "parser.ypp"
    {
	   (yyval.node) = new SelfVarrefNode((yyvsp[(1) - (1)].string)); 
	   if (checkParseOption(PO_ALLOW_BARE_REFS))
	      parse_error("reference to '$.%s' with the '$.' prefix is not allowed when parse option 'allow-bare-refs' is set", (yyvsp[(1) - (1)].string));
	}
    break;

  case 268:
/* Line 1792 of yacc.c  */
#line 2988 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_LOG_AND, (yyvsp[(3) - (3)].node)); }
    break;

  case 269:
/* Line 1792 of yacc.c  */
#line 2989 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_LOG_OR, (yyvsp[(3) - (3)].node)); }
    break;

  case 270:
/* Line 1792 of yacc.c  */
#line 2990 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_BIN_OR, (yyvsp[(3) - (3)].node)); }
    break;

  case 271:
/* Line 1792 of yacc.c  */
#line 2991 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_BIN_AND, (yyvsp[(3) - (3)].node)); }
    break;

  case 272:
/* Line 1792 of yacc.c  */
#line 2992 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_BIN_XOR, (yyvsp[(3) - (3)].node)); }
    break;

  case 273:
/* Line 1792 of yacc.c  */
#line 2993 "parser.ypp"
    {
	   (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_REGEX_MATCH, (yyvsp[(3) - (3)].Regex));
	}
    break;

  case 274:
/* Line 1792 of yacc.c  */
#line 2996 "parser.ypp"
    {
	   (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_REGEX_NMATCH, (yyvsp[(3) - (3)].Regex));
	}
    break;

  case 275:
/* Line 1792 of yacc.c  */
#line 2999 "parser.ypp"
    {
	   //printf("REGEX_SUBST: '%s'\n", $3->getPattern()->getBuffer());
	   (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_REGEX_SUBST, (yyvsp[(3) - (3)].RegexSubst));
	}
    break;

  case 276:
/* Line 1792 of yacc.c  */
#line 3003 "parser.ypp"
    {
	   (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_REGEX_TRANS, (yyvsp[(3) - (3)].RegexTrans));
	}
    break;

  case 277:
/* Line 1792 of yacc.c  */
#line 3007 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_REGEX_EXTRACT, (yyvsp[(3) - (3)].Regex)); }
    break;

  case 278:
/* Line 1792 of yacc.c  */
#line 3008 "parser.ypp"
    { (yyval.node) = new QoreLogicalGreaterThanOperatorNode((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node)); }
    break;

  case 279:
/* Line 1792 of yacc.c  */
#line 3009 "parser.ypp"
    { (yyval.node) = new QoreLogicalLessThanOperatorNode((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node)); }
    break;

  case 280:
/* Line 1792 of yacc.c  */
#line 3010 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_LOG_CMP, (yyvsp[(3) - (3)].node)); }
    break;

  case 281:
/* Line 1792 of yacc.c  */
#line 3011 "parser.ypp"
    { (yyval.node) = new QoreLogicalEqualsOperatorNode((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node)); }
    break;

  case 282:
/* Line 1792 of yacc.c  */
#line 3012 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_ABSOLUTE_EQ, (yyvsp[(3) - (3)].node)); }
    break;

  case 283:
/* Line 1792 of yacc.c  */
#line 3013 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_ABSOLUTE_NE, (yyvsp[(3) - (3)].node)); }
    break;

  case 284:
/* Line 1792 of yacc.c  */
#line 3014 "parser.ypp"
    { (yyval.node) = new QoreLogicalNotEqualsOperatorNode((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node)); }
    break;

  case 285:
/* Line 1792 of yacc.c  */
#line 3015 "parser.ypp"
    { (yyval.node) = new QoreLogicalLessThanOrEqualsOperatorNode((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node)); }
    break;

  case 286:
/* Line 1792 of yacc.c  */
#line 3016 "parser.ypp"
    { (yyval.node) = new QoreLogicalGreaterThanOrEqualsOperatorNode((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node)); }
    break;

  case 287:
/* Line 1792 of yacc.c  */
#line 3017 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_SHIFT_LEFT, (yyvsp[(3) - (3)].node)); }
    break;

  case 288:
/* Line 1792 of yacc.c  */
#line 3018 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_SHIFT_RIGHT, (yyvsp[(3) - (3)].node)); }
    break;

  case 289:
/* Line 1792 of yacc.c  */
#line 3019 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_PLUS, (yyvsp[(3) - (3)].node)); }
    break;

  case 290:
/* Line 1792 of yacc.c  */
#line 3020 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_MINUS, (yyvsp[(3) - (3)].node)); }
    break;

  case 291:
/* Line 1792 of yacc.c  */
#line 3021 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_MODULA, (yyvsp[(3) - (3)].node)); }
    break;

  case 292:
/* Line 1792 of yacc.c  */
#line 3022 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_DIV, (yyvsp[(3) - (3)].node)); }
    break;

  case 293:
/* Line 1792 of yacc.c  */
#line 3023 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (3)].node), OP_MULT, (yyvsp[(3) - (3)].node)); }
    break;

  case 294:
/* Line 1792 of yacc.c  */
#line 3024 "parser.ypp"
    { 
	   // FIXME: need to expand constant expression checking to determine
	   //        if the expression can throw an exception at run-time
	   // first check for constant expressions
	   (yyval.node) = QoreUnaryMinusOperatorNode::makeNode((yyvsp[(2) - (2)].node));
	}
    break;

  case 295:
/* Line 1792 of yacc.c  */
#line 3030 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_BIN_NOT, 0); }
    break;

  case 296:
/* Line 1792 of yacc.c  */
#line 3031 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_NOT, 0); }
    break;

  case 297:
/* Line 1792 of yacc.c  */
#line 3032 "parser.ypp"
    {
	   qore_type_t t = (yyvsp[(2) - (2)].node) ? (yyvsp[(2) - (2)].node)->getType() : 0;
	   //printd(5, "backslash exp line %d, type %s\n", @2.first_line, $2->getTypeName());

	   if (t == NT_FUNCTION_CALL || t == NT_PROGRAM_FUNC_CALL) {
	      (yyval.node) = reinterpret_cast<FunctionCallNode*>((yyvsp[(2) - (2)].node))->makeReferenceNodeAndDeref();
	   }
	   else if (t == NT_SELF_CALL) {
	      (yyval.node) = reinterpret_cast<SelfFunctionCallNode*>((yyvsp[(2) - (2)].node))->makeReferenceNodeAndDeref();
	   }
	   else if (t == NT_STATIC_METHOD_CALL) {
	      (yyval.node) = reinterpret_cast<StaticMethodCallNode*>((yyvsp[(2) - (2)].node))->makeReferenceNodeAndDeref();
	   }
	   else {
	      bool make_ref = true;

	      if (t == NT_OPERATOR) {
                 QoreDotEvalOperatorNode* deon = dynamic_cast<QoreDotEvalOperatorNode*>((yyvsp[(2) - (2)].node));
                 if (deon) {
                    (yyval.node) = deon->makeCallReference();
                    make_ref = false;
                 }
	      }

	      if (make_ref) {
		 //printd(5, "type=%s\n", $2->getTypeName());
		 (yyval.node) = new ParseReferenceNode((yyvsp[(2) - (2)].node));
	      }
	   }
	}
    break;

  case 298:
/* Line 1792 of yacc.c  */
#line 3062 "parser.ypp"
    {
	   (yyval.node) = new ScopedObjectCallNode(new NamedScope((yyvsp[(2) - (5)].string)), makeArgs((yyvsp[(4) - (5)].node)));
	   if (checkParseOption(PO_NO_NEW))
	      parse_error("illegal use of the 'new' operator (conflicts with parse option NO_NEW)");
        }
    break;

  case 299:
/* Line 1792 of yacc.c  */
#line 3067 "parser.ypp"
    {
	   (yyval.node) = new ScopedObjectCallNode(new NamedScope((yyvsp[(2) - (5)].string)), makeArgs((yyvsp[(4) - (5)].node)));
	   if (checkParseOption(PO_NO_NEW))
	      parse_error("illegal use of the 'new' operator (conflicts with parse option NO_NEW)");
        }
    break;

  case 300:
/* Line 1792 of yacc.c  */
#line 3072 "parser.ypp"
    {
	   (yyval.node) = new QoreTreeNode((yyvsp[(2) - (2)].node), OP_BACKGROUND, 0);
	   // check to see if the expression is legal
	   if (checkParseOption(PO_NO_THREAD_CONTROL))
	      parse_error("illegal use of \"background\" operator (conflicts with parse option NO_THREAD_CONTROL)");
	   else if (!hasEffect((yyvsp[(2) - (2)].node)))
	      parse_error("argument to background operator (%s) has no effect", get_type_name((yyvsp[(2) - (2)].node)));
	}
    break;

  case 301:
/* Line 1792 of yacc.c  */
#line 3080 "parser.ypp"
    {
	   (yyval.node) = new BackquoteNode((yyvsp[(1) - (1)].string));
	   if (checkParseOption(PO_NO_EXTERNAL_PROCESS))
	      parse_error("illegal use of backquote operator (conflicts with parse option NO_EXTERNAL_PROCESS)");
	}
    break;

  case 302:
/* Line 1792 of yacc.c  */
#line 3085 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (4)].node), OP_LIST_REF, (yyvsp[(3) - (4)].node)); }
    break;

  case 303:
/* Line 1792 of yacc.c  */
#line 3086 "parser.ypp"
    { (yyval.node) = new QoreTreeNode((yyvsp[(1) - (4)].node), OP_OBJECT_REF, (yyvsp[(3) - (4)].node)); }
    break;

  case 304:
/* Line 1792 of yacc.c  */
#line 3087 "parser.ypp"
    {
	   (yyval.node) = process_dot((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
	}
    break;

  case 305:
/* Line 1792 of yacc.c  */
#line 3090 "parser.ypp"
    {
	   (yyval.node) = new QoreTreeNode((yyvsp[(1) - (2)].node), OP_OBJECT_REF, (yyvsp[(2) - (2)].String));
	}
    break;

  case 306:
/* Line 1792 of yacc.c  */
#line 3093 "parser.ypp"
    { 
	   (yyval.node) = (yyvsp[(2) - (3)].node);
	   if ((yyvsp[(2) - (3)].node)) {
              switch ((yyvsp[(2) - (3)].node)->getType()) {
                 case NT_LIST:
                    reinterpret_cast<QoreListNode*>((yyvsp[(2) - (3)].node))->setFinalized();
                    break;
                 case NT_FUNCTION_CALL:
                    reinterpret_cast<FunctionCallNode*>((yyvsp[(2) - (3)].node))->setFinalized();
                    break;
              }
           }
	}
    break;

  case 307:
/* Line 1792 of yacc.c  */
#line 3106 "parser.ypp"
    { QoreListNode* l = new QoreListNode; l->setFinalized(); (yyval.node) = l; }
    break;

  case 308:
/* Line 1792 of yacc.c  */
#line 3107 "parser.ypp"
    {
	   int ar = get_pop_argv_ref();
	   (yyval.node) = new QoreClosureParseNode(new UserClosureFunction((yyvsp[(6) - (6)].sblock), (yylsp[(3) - (6)]).first_line, (yylsp[(3) - (6)]).last_line, (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].returnTypeInfo), false, ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS));
	}
    break;

  case 309:
/* Line 1792 of yacc.c  */
#line 3111 "parser.ypp"
    {
	   RetTypeInfo* rt = new RetTypeInfo((yyvsp[(1) - (6)].parsertype)->getParseTypeInfo(), (yyvsp[(1) - (6)].parsertype)->getTypeInfo());
	   delete (yyvsp[(1) - (6)].parsertype);

	   int ar = get_pop_argv_ref();
	   (yyval.node) = new QoreClosureParseNode(new UserClosureFunction((yyvsp[(6) - (6)].sblock), (yylsp[(4) - (6)]).first_line, (yylsp[(4) - (6)]).last_line, (yyvsp[(4) - (6)].node), rt, false, ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS));
	}
    break;

  case 310:
/* Line 1792 of yacc.c  */
#line 3118 "parser.ypp"
    {
	   check_funcmod((yyvsp[(1) - (7)].i4));
	   int ar = get_pop_argv_ref();
	   int64 flags = ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS;
	   if ((yyvsp[(1) - (7)].i4) & OFM_DEPRECATED)
	      flags |= QC_DEPRECATED;
	   (yyval.node) = new QoreClosureParseNode(new UserClosureFunction((yyvsp[(7) - (7)].sblock), (yylsp[(4) - (7)]).first_line, (yylsp[(4) - (7)]).last_line, (yyvsp[(4) - (7)].node), (yyvsp[(6) - (7)].returnTypeInfo), (yyvsp[(1) - (7)].i4) | OFM_SYNCED, flags));
	}
    break;

  case 311:
/* Line 1792 of yacc.c  */
#line 3126 "parser.ypp"
    {
	   check_funcmod((yyvsp[(1) - (7)].i4));

	   RetTypeInfo* rt = new RetTypeInfo((yyvsp[(2) - (7)].parsertype)->getParseTypeInfo(), (yyvsp[(2) - (7)].parsertype)->getTypeInfo());
	   delete (yyvsp[(2) - (7)].parsertype);

	   int ar = get_pop_argv_ref();
	   int64 flags = ar > 0 ? QC_USES_EXTRA_ARGS : QC_NO_FLAGS;
	   if ((yyvsp[(1) - (7)].i4) & OFM_DEPRECATED)
	      flags |= QC_DEPRECATED;
	   (yyval.node) = new QoreClosureParseNode(new UserClosureFunction((yyvsp[(7) - (7)].sblock), (yylsp[(5) - (7)]).first_line, (yylsp[(5) - (7)]).last_line, (yyvsp[(5) - (7)].node), rt, (yyvsp[(1) - (7)].i4) | OFM_SYNCED, flags));
	}
    break;

  case 312:
/* Line 1792 of yacc.c  */
#line 3138 "parser.ypp"
    { 
	   (yyval.node) = (yyvsp[(1) - (1)].implicit_arg);
	   inc_numeric_argv_ref();
	}
    break;

  case 313:
/* Line 1792 of yacc.c  */
#line 3142 "parser.ypp"
    {
	   (yyval.node) = new QoreImplicitElementNode;
	}
    break;

  case 314:
/* Line 1792 of yacc.c  */
#line 3145 "parser.ypp"
    {
	   (yyval.node) = new QoreDeleteOperatorNode((yyvsp[(2) - (2)].node));
	}
    break;

  case 315:
/* Line 1792 of yacc.c  */
#line 3148 "parser.ypp"
    {
	   (yyval.node) = new QoreRemoveOperatorNode((yyvsp[(2) - (2)].node));
	}
    break;

  case 316:
/* Line 1792 of yacc.c  */
#line 3151 "parser.ypp"
    {
           (yyval.node) = new QoreCastOperatorNode((yyvsp[(1) - (4)].string), (yyvsp[(3) - (4)].node));
	}
    break;

  case 317:
/* Line 1792 of yacc.c  */
#line 3157 "parser.ypp"
    {
	   (yyval.String) = (yyvsp[(1) - (1)].String);
	}
    break;

  case 318:
/* Line 1792 of yacc.c  */
#line 3160 "parser.ypp"
    {
	   (yyval.String) = (yyvsp[(1) - (2)].String);
	   (yyval.String)->concat((yyvsp[(2) - (2)].String));
	   (yyvsp[(2) - (2)].String)->deref();
	}
    break;

  case 319:
/* Line 1792 of yacc.c  */
#line 3167 "parser.ypp"
    { (yyval.node) = new QoreFloatNode((yyvsp[(1) - (1)].decimal)); }
    break;

  case 320:
/* Line 1792 of yacc.c  */
#line 3168 "parser.ypp"
    { (yyval.node) = new QoreBigIntNode((yyvsp[(1) - (1)].integer)); }
    break;

  case 321:
/* Line 1792 of yacc.c  */
#line 3169 "parser.ypp"
    { (yyval.node) = (yyvsp[(1) - (1)].String); }
    break;

  case 322:
/* Line 1792 of yacc.c  */
#line 3170 "parser.ypp"
    { (yyval.node) = (yyvsp[(1) - (1)].datetime); }
    break;

  case 323:
/* Line 1792 of yacc.c  */
#line 3171 "parser.ypp"
    { (yyval.node) = (yyvsp[(1) - (1)].num); }
    break;


/* Line 1792 of yacc.c  */
#line 8759 "parser.cpp"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, yyscanner);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 3174 "parser.ypp"

